/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 5.9.8
 * @date    2020-06-15T13:24:29.180Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
import{DataView as t,DataSet as e}from"vis-data/peer/esm/vis-data.js";var r="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function i(t,e,r){return t(r={path:e,exports:{},require:function(t,e){return function(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}(null==e&&r.path)}},r.exports),r.exports}function n(t){return t&&t.default||t}var o=function(t){return t&&t.Math==Math&&t},a=o("object"==typeof globalThis&&globalThis)||o("object"==typeof window&&window)||o("object"==typeof self&&self)||o("object"==typeof r&&r)||Function("return this")(),s=function(t){try{return!!t()}catch(t){return!0}},l=!s((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),h={}.propertyIsEnumerable,c=Object.getOwnPropertyDescriptor,u={f:c&&!h.call({1:2},1)?function(t){var e=c(this,t);return!!e&&e.enumerable}:h},f=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},d={}.toString,p=function(t){return d.call(t).slice(8,-1)},v="".split,y=s((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==p(t)?v.call(t,""):Object(t)}:Object,m=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},g=function(t){return y(m(t))},b=function(t){return"object"==typeof t?null!==t:"function"==typeof t},x=function(t,e){if(!b(t))return t;var r,i;if(e&&"function"==typeof(r=t.toString)&&!b(i=r.call(t)))return i;if("function"==typeof(r=t.valueOf)&&!b(i=r.call(t)))return i;if(!e&&"function"==typeof(r=t.toString)&&!b(i=r.call(t)))return i;throw TypeError("Can't convert object to primitive value")},w={}.hasOwnProperty,_=function(t,e){return w.call(t,e)},S=a.document,L=b(S)&&b(S.createElement),C=function(t){return L?S.createElement(t):{}},A=!l&&!s((function(){return 7!=Object.defineProperty(C("div"),"a",{get:function(){return 7}}).a})),T=Object.getOwnPropertyDescriptor,O={f:l?T:function(t,e){if(t=g(t),e=x(e,!0),A)try{return T(t,e)}catch(t){}if(_(t,e))return f(!u.f.call(t,e),t[e])}},M=/#|\.prototype\./,P=function(t,e){var r=R[E(t)];return r==k||r!=D&&("function"==typeof e?s(e):!!e)},E=P.normalize=function(t){return String(t).replace(M,".").toLowerCase()},R=P.data={},D=P.NATIVE="N",k=P.POLYFILL="P",z=P,I={},j=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},B=function(t,e,r){if(j(t),void 0===e)return t;switch(r){case 0:return function(){return t.call(e)};case 1:return function(r){return t.call(e,r)};case 2:return function(r,i){return t.call(e,r,i)};case 3:return function(r,i,n){return t.call(e,r,i,n)}}return function(){return t.apply(e,arguments)}},F=function(t){if(!b(t))throw TypeError(String(t)+" is not an object");return t},W=Object.defineProperty,G={f:l?W:function(t,e,r){if(F(t),e=x(e,!0),F(r),A)try{return W(t,e,r)}catch(t){}if("get"in r||"set"in r)throw TypeError("Accessors not supported");return"value"in r&&(t[e]=r.value),t}},N=l?function(t,e,r){return G.f(t,e,f(1,r))}:function(t,e,r){return t[e]=r,t},Y=O.f,V=function(t){var e=function(e,r,i){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,r)}return new t(e,r,i)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},X=function(t,e){var r,i,n,o,s,l,h,c,u=t.target,f=t.global,d=t.stat,p=t.proto,v=f?a:d?a[u]:(a[u]||{}).prototype,y=f?I:I[u]||(I[u]={}),m=y.prototype;for(n in e)r=!z(f?n:u+(d?".":"#")+n,t.forced)&&v&&_(v,n),s=y[n],r&&(l=t.noTargetGet?(c=Y(v,n))&&c.value:v[n]),o=r&&l?l:e[n],r&&typeof s==typeof o||(h=t.bind&&r?B(o,a):t.wrap&&r?V(o):p&&"function"==typeof o?B(Function.call,o):o,(t.sham||o&&o.sham||s&&s.sham)&&N(h,"sham",!0),y[n]=h,p&&(_(I,i=u+"Prototype")||N(I,i,{}),I[i][n]=o,t.real&&m&&!m[n]&&N(m,n,o)))},Z=Math.ceil,U=Math.floor,H=function(t){return isNaN(t=+t)?0:(t>0?U:Z)(t)},$=Math.min,J=function(t){return t>0?$(H(t),9007199254740991):0},q=Math.max,K=Math.min,Q=function(t,e){var r=H(t);return r<0?q(r+e,0):K(r,e)},tt=function(t){return function(e,r,i){var n,o=g(e),a=J(o.length),s=Q(i,a);if(t&&r!=r){for(;a>s;)if((n=o[s++])!=n)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===r)return t||s||0;return!t&&-1}},et={includes:tt(!0),indexOf:tt(!1)},rt={},it=et.indexOf,nt=function(t,e){var r,i=g(t),n=0,o=[];for(r in i)!_(rt,r)&&_(i,r)&&o.push(r);for(;e.length>n;)_(i,r=e[n++])&&(~it(o,r)||o.push(r));return o},ot=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],at=Object.keys||function(t){return nt(t,ot)},st={f:Object.getOwnPropertySymbols},lt=function(t){return Object(m(t))},ht=Object.assign,ct=Object.defineProperty,ut=!ht||s((function(){if(l&&1!==ht({b:1},ht(ct({},"a",{enumerable:!0,get:function(){ct(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},r=Symbol();return t[r]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=ht({},t)[r]||"abcdefghijklmnopqrst"!=at(ht({},e)).join("")}))?function(t,e){for(var r=lt(t),i=arguments.length,n=1,o=st.f,a=u.f;i>n;)for(var s,h=y(arguments[n++]),c=o?at(h).concat(o(h)):at(h),f=c.length,d=0;f>d;)s=c[d++],l&&!a.call(h,s)||(r[s]=h[s]);return r}:ht;X({target:"Object",stat:!0,forced:Object.assign!==ut},{assign:ut});var ft=I.Object.assign,dt=function(t){return"function"==typeof t?t:void 0},pt=function(t,e){return arguments.length<2?dt(I[t])||dt(a[t]):I[t]&&I[t][e]||a[t]&&a[t][e]},vt=pt("navigator","userAgent")||"",yt=[].slice,mt=/MSIE .\./.test(vt),gt=function(t){return function(e,r){var i=arguments.length>2,n=i?yt.call(arguments,2):void 0;return t(i?function(){("function"==typeof e?e:Function(e)).apply(this,n)}:e,r)}};X({global:!0,bind:!0,forced:mt},{setTimeout:gt(a.setTimeout),setInterval:gt(a.setInterval)});var bt,xt,wt=I.setTimeout,_t=Array.isArray||function(t){return"Array"==p(t)},St=function(t,e,r){var i=x(e);i in t?G.f(t,i,f(0,r)):t[i]=r},Lt=a["__core-js_shared__"]||function(t,e){try{N(a,t,e)}catch(r){a[t]=e}return e}("__core-js_shared__",{}),Ct=i((function(t){(t.exports=function(t,e){return Lt[t]||(Lt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),At=0,Tt=Math.random(),Ot=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++At+Tt).toString(36)},Mt=!!Object.getOwnPropertySymbols&&!s((function(){return!String(Symbol())})),Pt=Mt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Et=Ct("wks"),Rt=a.Symbol,Dt=Pt?Rt:Rt&&Rt.withoutSetter||Ot,kt=function(t){return _(Et,t)||(Mt&&_(Rt,t)?Et[t]=Rt[t]:Et[t]=Dt("Symbol."+t)),Et[t]},zt=kt("species"),It=function(t,e){var r;return _t(t)&&("function"!=typeof(r=t.constructor)||r!==Array&&!_t(r.prototype)?b(r)&&null===(r=r[zt])&&(r=void 0):r=void 0),new(void 0===r?Array:r)(0===e?0:e)},jt=a.process,Bt=jt&&jt.versions,Ft=Bt&&Bt.v8;Ft?xt=(bt=Ft.split("."))[0]+bt[1]:vt&&(!(bt=vt.match(/Edge\/(\d+)/))||bt[1]>=74)&&(bt=vt.match(/Chrome\/(\d+)/))&&(xt=bt[1]);var Wt=xt&&+xt,Gt=kt("species"),Nt=function(t){return Wt>=51||!s((function(){var e=[];return(e.constructor={})[Gt]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Yt=kt("isConcatSpreadable"),Vt=Wt>=51||!s((function(){var t=[];return t[Yt]=!1,t.concat()[0]!==t})),Xt=Nt("concat"),Zt=function(t){if(!b(t))return!1;var e=t[Yt];return void 0!==e?!!e:_t(t)};X({target:"Array",proto:!0,forced:!Vt||!Xt},{concat:function(t){var e,r,i,n,o,a=lt(this),s=It(a,0),l=0;for(e=-1,i=arguments.length;e<i;e++)if(Zt(o=-1===e?a:arguments[e])){if(l+(n=J(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(r=0;r<n;r++,l++)r in o&&St(s,l,o[r])}else{if(l>=9007199254740991)throw TypeError("Maximum allowed index exceeded");St(s,l++,o)}return s.length=l,s}});var Ut=function(t){return I[t+"Prototype"]},Ht=Ut("Array").concat,$t=Array.prototype,Jt=function(t){var e=t.concat;return t===$t||t instanceof Array&&e===$t.concat?Ht:e};X({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var qt=I.Number.isNaN;X({target:"Array",stat:!0},{isArray:_t});var Kt=I.Array.isArray,Qt=Kt,te={f:kt},ee=G.f,re=function(t){var e=I.Symbol||(I.Symbol={});_(e,t)||ee(e,t,{value:te.f(t)})};re("iterator");var ie=function(t){return function(e,r){var i,n,o=String(m(e)),a=H(r),s=o.length;return a<0||a>=s?t?"":void 0:(i=o.charCodeAt(a))<55296||i>56319||a+1===s||(n=o.charCodeAt(a+1))<56320||n>57343?t?o.charAt(a):i:t?o.slice(a,a+2):n-56320+(i-55296<<10)+65536}},ne={codeAt:ie(!1),charAt:ie(!0)},oe=Function.toString;"function"!=typeof Lt.inspectSource&&(Lt.inspectSource=function(t){return oe.call(t)});var ae,se,le,he=Lt.inspectSource,ce=a.WeakMap,ue="function"==typeof ce&&/native code/.test(he(ce)),fe=Ct("keys"),de=function(t){return fe[t]||(fe[t]=Ot(t))},pe=a.WeakMap;if(ue){var ve=new pe,ye=ve.get,me=ve.has,ge=ve.set;ae=function(t,e){return ge.call(ve,t,e),e},se=function(t){return ye.call(ve,t)||{}},le=function(t){return me.call(ve,t)}}else{var be=de("state");rt[be]=!0,ae=function(t,e){return N(t,be,e),e},se=function(t){return _(t,be)?t[be]:{}},le=function(t){return _(t,be)}}var xe,we,_e,Se={set:ae,get:se,has:le,enforce:function(t){return le(t)?se(t):ae(t,{})},getterFor:function(t){return function(e){var r;if(!b(e)||(r=se(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return r}}},Le=!s((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Ce=de("IE_PROTO"),Ae=Object.prototype,Te=Le?Object.getPrototypeOf:function(t){return t=lt(t),_(t,Ce)?t[Ce]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?Ae:null},Oe=(kt("iterator"),!1);[].keys&&("next"in(_e=[].keys())?(we=Te(Te(_e)))!==Object.prototype&&(xe=we):Oe=!0),null==xe&&(xe={});var Me,Pe={IteratorPrototype:xe,BUGGY_SAFARI_ITERATORS:Oe},Ee=l?Object.defineProperties:function(t,e){F(t);for(var r,i=at(e),n=i.length,o=0;n>o;)G.f(t,r=i[o++],e[r]);return t},Re=pt("document","documentElement"),De=de("IE_PROTO"),ke=function(){},ze=function(t){return"<script>"+t+"<\/script>"},Ie=function(){try{Me=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Ie=Me?function(t){t.write(ze("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Me):((e=C("iframe")).style.display="none",Re.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(ze("document.F=Object")),t.close(),t.F);for(var r=ot.length;r--;)delete Ie.prototype[ot[r]];return Ie()};rt[De]=!0;var je=Object.create||function(t,e){var r;return null!==t?(ke.prototype=F(t),r=new ke,ke.prototype=null,r[De]=t):r=Ie(),void 0===e?r:Ee(r,e)},Be={};Be[kt("toStringTag")]="z";var Fe="[object z]"===String(Be),We=kt("toStringTag"),Ge="Arguments"==p(function(){return arguments}()),Ne=Fe?p:function(t){var e,r,i;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(r=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),We))?r:Ge?p(e):"Object"==(i=p(e))&&"function"==typeof e.callee?"Arguments":i},Ye=Fe?{}.toString:function(){return"[object "+Ne(this)+"]"},Ve=G.f,Xe=kt("toStringTag"),Ze=function(t,e,r,i){if(t){var n=r?t:t.prototype;_(n,Xe)||Ve(n,Xe,{configurable:!0,value:e}),i&&!Fe&&N(n,"toString",Ye)}},Ue={},He=Pe.IteratorPrototype,$e=function(){return this},Je=(Object.setPrototypeOf||"__proto__"in{}&&function(){var t,e=!1,r={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(r,[]),e=r instanceof Array}catch(t){}}(),function(t,e,r,i){i&&i.enumerable?t[e]=r:N(t,e,r)}),qe=Pe.IteratorPrototype,Ke=Pe.BUGGY_SAFARI_ITERATORS,Qe=kt("iterator"),tr=function(){return this},er=function(t,e,r,i,n,o,a){!function(t,e,r){var i=e+" Iterator";t.prototype=je(He,{next:f(1,r)}),Ze(t,i,!1,!0),Ue[i]=$e}(r,e,i);var s,l,h,c=function(t){if(t===n&&y)return y;if(!Ke&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new r(this,t)}}return function(){return new r(this)}},u=e+" Iterator",d=!1,p=t.prototype,v=p[Qe]||p["@@iterator"]||n&&p[n],y=!Ke&&v||c(n),m="Array"==e&&p.entries||v;if(m&&(s=Te(m.call(new t)),qe!==Object.prototype&&s.next&&(Ze(s,u,!0,!0),Ue[u]=tr)),"values"==n&&v&&"values"!==v.name&&(d=!0,y=function(){return v.call(this)}),a&&p[Qe]!==y&&N(p,Qe,y),Ue[e]=y,n)if(l={values:c("values"),keys:o?y:c("keys"),entries:c("entries")},a)for(h in l)(Ke||d||!(h in p))&&Je(p,h,l[h]);else X({target:e,proto:!0,forced:Ke||d},l);return l},rr=ne.charAt,ir=Se.set,nr=Se.getterFor("String Iterator");er(String,"String",(function(t){ir(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=nr(this),r=e.string,i=e.index;return i>=r.length?{value:void 0,done:!0}:(t=rr(r,i),e.index+=t.length,{value:t,done:!1})}));var or=Se.set,ar=Se.getterFor("Array Iterator");er(Array,"Array",(function(t,e){or(this,{type:"Array Iterator",target:g(t),index:0,kind:e})}),(function(){var t=ar(this),e=t.target,r=t.kind,i=t.index++;return!e||i>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==r?{value:i,done:!1}:"values"==r?{value:e[i],done:!1}:{value:[i,e[i]],done:!1}}),"values");Ue.Arguments=Ue.Array;var sr=kt("toStringTag");for(var lr in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var hr=a[lr],cr=hr&&hr.prototype;cr&&Ne(cr)!==sr&&N(cr,sr,lr),Ue[lr]=Ue.Array}var ur=te.f("iterator"),fr=Object.freeze({__proto__:null}),dr=ot.concat("length","prototype"),pr={f:Object.getOwnPropertyNames||function(t){return nt(t,dr)}},vr=pr.f,yr={}.toString,mr="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],gr={f:function(t){return mr&&"[object Window]"==yr.call(t)?function(t){try{return vr(t)}catch(t){return mr.slice()}}(t):vr(g(t))}},br=[].push,xr=function(t){var e=1==t,r=2==t,i=3==t,n=4==t,o=6==t,a=5==t||o;return function(s,l,h,c){for(var u,f,d=lt(s),p=y(d),v=B(l,h,3),m=J(p.length),g=0,b=c||It,x=e?b(s,m):r?b(s,0):void 0;m>g;g++)if((a||g in p)&&(f=v(u=p[g],g,d),t))if(e)x[g]=f;else if(f)switch(t){case 3:return!0;case 5:return u;case 6:return g;case 2:br.call(x,u)}else if(n)return!1;return o?-1:i||n?n:x}},wr={forEach:xr(0),map:xr(1),filter:xr(2),some:xr(3),every:xr(4),find:xr(5),findIndex:xr(6)},_r=wr.forEach,Sr=de("hidden"),Lr=kt("toPrimitive"),Cr=Se.set,Ar=Se.getterFor("Symbol"),Tr=Object.prototype,Or=a.Symbol,Mr=pt("JSON","stringify"),Pr=O.f,Er=G.f,Rr=gr.f,Dr=u.f,kr=Ct("symbols"),zr=Ct("op-symbols"),Ir=Ct("string-to-symbol-registry"),jr=Ct("symbol-to-string-registry"),Br=Ct("wks"),Fr=a.QObject,Wr=!Fr||!Fr.prototype||!Fr.prototype.findChild,Gr=l&&s((function(){return 7!=je(Er({},"a",{get:function(){return Er(this,"a",{value:7}).a}})).a}))?function(t,e,r){var i=Pr(Tr,e);i&&delete Tr[e],Er(t,e,r),i&&t!==Tr&&Er(Tr,e,i)}:Er,Nr=function(t,e){var r=kr[t]=je(Or.prototype);return Cr(r,{type:"Symbol",tag:t,description:e}),l||(r.description=e),r},Yr=Pt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Or},Vr=function(t,e,r){t===Tr&&Vr(zr,e,r),F(t);var i=x(e,!0);return F(r),_(kr,i)?(r.enumerable?(_(t,Sr)&&t[Sr][i]&&(t[Sr][i]=!1),r=je(r,{enumerable:f(0,!1)})):(_(t,Sr)||Er(t,Sr,f(1,{})),t[Sr][i]=!0),Gr(t,i,r)):Er(t,i,r)},Xr=function(t,e){F(t);var r=g(e),i=at(r).concat($r(r));return _r(i,(function(e){l&&!Zr.call(r,e)||Vr(t,e,r[e])})),t},Zr=function(t){var e=x(t,!0),r=Dr.call(this,e);return!(this===Tr&&_(kr,e)&&!_(zr,e))&&(!(r||!_(this,e)||!_(kr,e)||_(this,Sr)&&this[Sr][e])||r)},Ur=function(t,e){var r=g(t),i=x(e,!0);if(r!==Tr||!_(kr,i)||_(zr,i)){var n=Pr(r,i);return!n||!_(kr,i)||_(r,Sr)&&r[Sr][i]||(n.enumerable=!0),n}},Hr=function(t){var e=Rr(g(t)),r=[];return _r(e,(function(t){_(kr,t)||_(rt,t)||r.push(t)})),r},$r=function(t){var e=t===Tr,r=Rr(e?zr:g(t)),i=[];return _r(r,(function(t){!_(kr,t)||e&&!_(Tr,t)||i.push(kr[t])})),i};if(Mt||(Je((Or=function(){if(this instanceof Or)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Ot(t),r=function(t){this===Tr&&r.call(zr,t),_(this,Sr)&&_(this[Sr],e)&&(this[Sr][e]=!1),Gr(this,e,f(1,t))};return l&&Wr&&Gr(Tr,e,{configurable:!0,set:r}),Nr(e,t)}).prototype,"toString",(function(){return Ar(this).tag})),Je(Or,"withoutSetter",(function(t){return Nr(Ot(t),t)})),u.f=Zr,G.f=Vr,O.f=Ur,pr.f=gr.f=Hr,st.f=$r,te.f=function(t){return Nr(kt(t),t)},l&&Er(Or.prototype,"description",{configurable:!0,get:function(){return Ar(this).description}})),X({global:!0,wrap:!0,forced:!Mt,sham:!Mt},{Symbol:Or}),_r(at(Br),(function(t){re(t)})),X({target:"Symbol",stat:!0,forced:!Mt},{for:function(t){var e=String(t);if(_(Ir,e))return Ir[e];var r=Or(e);return Ir[e]=r,jr[r]=e,r},keyFor:function(t){if(!Yr(t))throw TypeError(t+" is not a symbol");if(_(jr,t))return jr[t]},useSetter:function(){Wr=!0},useSimple:function(){Wr=!1}}),X({target:"Object",stat:!0,forced:!Mt,sham:!l},{create:function(t,e){return void 0===e?je(t):Xr(je(t),e)},defineProperty:Vr,defineProperties:Xr,getOwnPropertyDescriptor:Ur}),X({target:"Object",stat:!0,forced:!Mt},{getOwnPropertyNames:Hr,getOwnPropertySymbols:$r}),X({target:"Object",stat:!0,forced:s((function(){st.f(1)}))},{getOwnPropertySymbols:function(t){return st.f(lt(t))}}),Mr){var Jr=!Mt||s((function(){var t=Or();return"[null]"!=Mr([t])||"{}"!=Mr({a:t})||"{}"!=Mr(Object(t))}));X({target:"JSON",stat:!0,forced:Jr},{stringify:function(t,e,r){for(var i,n=[t],o=1;arguments.length>o;)n.push(arguments[o++]);if(i=e,(b(e)||void 0!==t)&&!Yr(t))return _t(e)||(e=function(t,e){if("function"==typeof i&&(e=i.call(this,t,e)),!Yr(e))return e}),n[1]=e,Mr.apply(null,n)}})}Or.prototype[Lr]||N(Or.prototype,Lr,Or.prototype.valueOf),Ze(Or,"Symbol"),rt[Sr]=!0,re("asyncIterator");var qr=Object.freeze({__proto__:null});re("hasInstance"),re("isConcatSpreadable"),re("match"),re("matchAll"),re("replace"),re("search"),re("species"),re("split"),re("toPrimitive"),re("toStringTag"),re("unscopables"),Ze(Math,"Math",!0),Ze(a.JSON,"JSON",!0),n(fr),n(qr);var Kr=I.Symbol;re("asyncDispose"),re("dispose"),re("observable"),re("patternMatch"),re("replaceAll");var Qr=Kr,ti=i((function(t){function e(r){return t.exports=e="function"==typeof Qr&&"symbol"==typeof ur?function(t){return typeof t}:function(t){return t&&"function"==typeof Qr&&t.constructor===Qr&&t!==Qr.prototype?"symbol":typeof t},e(r)}t.exports=e})),ei=function(t,e){var r=[][t];return!!r&&s((function(){r.call(null,e||function(){throw 1},1)}))},ri=Object.defineProperty,ii={},ni=function(t){throw t},oi=function(t,e){if(_(ii,t))return ii[t];e||(e={});var r=[][t],i=!!_(e,"ACCESSORS")&&e.ACCESSORS,n=_(e,0)?e[0]:ni,o=_(e,1)?e[1]:void 0;return ii[t]=!!r&&!s((function(){if(i&&!l)return!0;var t={length:-1};i?ri(t,1,{enumerable:!0,get:ni}):t[1]=1,r.call(t,n,o)}))},ai=wr.forEach,si=ei("forEach"),li=oi("forEach"),hi=si&&li?[].forEach:function(t){return ai(this,t,arguments.length>1?arguments[1]:void 0)};X({target:"Array",proto:!0,forced:[].forEach!=hi},{forEach:hi});var ci=Ut("Array").forEach,ui=Array.prototype,fi={DOMTokenList:!0,NodeList:!0},di=function(t){var e=t.forEach;return t===ui||t instanceof Array&&e===ui.forEach||fi.hasOwnProperty(Ne(t))?ci:e},pi=Ut("Array").values,vi=Array.prototype,yi={DOMTokenList:!0,NodeList:!0},mi=function(t){var e=t.values;return t===vi||t instanceof Array&&e===vi.values||yi.hasOwnProperty(Ne(t))?pi:e};X({target:"Array",proto:!0},{fill:function(t){for(var e=lt(this),r=J(e.length),i=arguments.length,n=Q(i>1?arguments[1]:void 0,r),o=i>2?arguments[2]:void 0,a=void 0===o?r:Q(o,r);a>n;)e[n++]=t;return e}});var gi=Ut("Array").fill,bi=Array.prototype,xi=function(t){var e=t.fill;return t===bi||t instanceof Array&&e===bi.fill?gi:e},wi="\t\n\v\f\r                　\u2028\u2029\ufeff",_i="["+wi+"]",Si=RegExp("^"+_i+_i+"*"),Li=RegExp(_i+_i+"*$"),Ci=function(t){return function(e){var r=String(m(e));return 1&t&&(r=r.replace(Si,"")),2&t&&(r=r.replace(Li,"")),r}},Ai={start:Ci(1),end:Ci(2),trim:Ci(3)},Ti=Ai.trim,Oi=a.parseFloat,Mi=1/Oi(wi+"-0")!=-1/0?function(t){var e=Ti(String(t)),r=Oi(e);return 0===r&&"-"==e.charAt(0)?-0:r}:Oi;X({global:!0,forced:parseFloat!=Mi},{parseFloat:Mi});var Pi=I.parseFloat,Ei=wr.filter,Ri=Nt("filter"),Di=oi("filter");X({target:"Array",proto:!0,forced:!Ri||!Di},{filter:function(t){return Ei(this,t,arguments.length>1?arguments[1]:void 0)}});var ki=Ut("Array").filter,zi=Array.prototype,Ii=function(t){var e=t.filter;return t===zi||t instanceof Array&&e===zi.filter?ki:e},ji=et.indexOf,Bi=[].indexOf,Fi=!!Bi&&1/[1].indexOf(1,-0)<0,Wi=ei("indexOf"),Gi=oi("indexOf",{ACCESSORS:!0,1:0});X({target:"Array",proto:!0,forced:Fi||!Wi||!Gi},{indexOf:function(t){return Fi?Bi.apply(this,arguments)||0:ji(this,t,arguments.length>1?arguments[1]:void 0)}});var Ni=Ut("Array").indexOf,Yi=Array.prototype,Vi=function(t){var e=t.indexOf;return t===Yi||t instanceof Array&&e===Yi.indexOf?Ni:e},Xi=[],Zi=Xi.sort,Ui=s((function(){Xi.sort(void 0)})),Hi=s((function(){Xi.sort(null)})),$i=ei("sort");X({target:"Array",proto:!0,forced:Ui||!Hi||!$i},{sort:function(t){return void 0===t?Zi.call(lt(this)):Zi.call(lt(this),j(t))}});var Ji=Ut("Array").sort,qi=Array.prototype,Ki=function(t){var e=t.sort;return t===qi||t instanceof Array&&e===qi.sort?Ji:e},Qi=i((function(t){function e(t){if(t)return function(t){for(var r in e.prototype)t[r]=e.prototype[r];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r,i=this._callbacks["$"+t];if(!i)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var n=0;n<i.length;n++)if((r=i[n])===e||r.fn===e){i.splice(n,1);break}return 0===i.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),r=this._callbacks["$"+t],i=1;i<arguments.length;i++)e[i-1]=arguments[i];if(r){i=0;for(var n=(r=r.slice(0)).length;i<n;++i)r[i].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}));X({target:"Object",stat:!0,forced:!l,sham:!l},{defineProperty:G.f});var tn=i((function(t){var e=I.Object,r=t.exports=function(t,r,i){return e.defineProperty(t,r,i)};e.defineProperty.sham&&(r.sham=!0)}));X({target:"Object",stat:!0,forced:!l,sham:!l},{defineProperties:Ee});i((function(t){var e=I.Object,r=t.exports=function(t,r){return e.defineProperties(t,r)};e.defineProperties.sham&&(r.sham=!0)}));var en=pt("Reflect","ownKeys")||function(t){var e=pr.f(F(t)),r=st.f;return r?e.concat(r(t)):e};X({target:"Object",stat:!0,sham:!l},{getOwnPropertyDescriptors:function(t){for(var e,r,i=g(t),n=O.f,o=en(i),a={},s=0;o.length>s;)void 0!==(r=n(i,e=o[s++]))&&St(a,e,r);return a}});I.Object.getOwnPropertyDescriptors;var rn=O.f,nn=s((function(){rn(1)}));X({target:"Object",stat:!0,forced:!l||nn,sham:!l},{getOwnPropertyDescriptor:function(t,e){return rn(g(t),e)}});i((function(t){var e=I.Object,r=t.exports=function(t,r){return e.getOwnPropertyDescriptor(t,r)};e.getOwnPropertyDescriptor.sham&&(r.sham=!0)})),I.Object.getOwnPropertySymbols;var on=kt("iterator"),an=function(t){if(null!=t)return t[on]||t["@@iterator"]||Ue[Ne(t)]},sn=function(t,e,r,i){try{return i?e(F(r)[0],r[1]):e(r)}catch(e){var n=t.return;throw void 0!==n&&F(n.call(t)),e}},ln=kt("iterator"),hn=Array.prototype,cn=function(t){return void 0!==t&&(Ue.Array===t||hn[ln]===t)},un=kt("iterator"),fn=!1;try{var dn=0,pn={next:function(){return{done:!!dn++}},return:function(){fn=!0}};pn[un]=function(){return this},Array.from(pn,(function(){throw 2}))}catch(t){}var vn=!function(t,e){if(!e&&!fn)return!1;var r=!1;try{var i={};i[un]=function(){return{next:function(){return{done:r=!0}}}},t(i)}catch(t){}return r}((function(t){Array.from(t)}));X({target:"Array",stat:!0,forced:vn},{from:function(t){var e,r,i,n,o,a,s=lt(t),l="function"==typeof this?this:Array,h=arguments.length,c=h>1?arguments[1]:void 0,u=void 0!==c,f=an(s),d=0;if(u&&(c=B(c,h>2?arguments[2]:void 0,2)),null==f||l==Array&&cn(f))for(r=new l(e=J(s.length));e>d;d++)a=u?c(s[d],d):s[d],St(r,d,a);else for(o=(n=f.call(s)).next,r=new l;!(i=o.call(n)).done;d++)a=u?sn(n,c,[i.value,d],!0):i.value,St(r,d,a);return r.length=d,r}});var yn=I.Array.from;X({target:"Object",stat:!0,sham:!l},{create:je});var mn,gn=tn,bn=Ai.trim;X({target:"String",proto:!0,forced:(mn="trim",s((function(){return!!wi[mn]()||"​᠎"!="​᠎"[mn]()||wi[mn].name!==mn})))},{trim:function(){return bn(this)}});Ut("String").trim;var xn=Ai.trim,wn=a.parseInt,_n=/^[+-]?0[Xx]/,Sn=8!==wn(wi+"08")||22!==wn(wi+"0x16")?function(t,e){var r=xn(String(t));return wn(r,e>>>0||(_n.test(r)?16:10))}:wn;X({global:!0,forced:parseInt!=Sn},{parseInt:Sn});var Ln=I.parseInt,Cn=u.f,An=function(t){return function(e){for(var r,i=g(e),n=at(i),o=n.length,a=0,s=[];o>a;)r=n[a++],l&&!Cn.call(i,r)||s.push(t?[r,i[r]]:i[r]);return s}},Tn={entries:An(!0),values:An(!1)}.values;X({target:"Object",stat:!0},{values:function(t){return Tn(t)}});I.Object.values;var On=s((function(){Te(1)}));X({target:"Object",stat:!0,forced:On,sham:!Le},{getPrototypeOf:function(t){return Te(lt(t))}});var Mn=I.Object.getPrototypeOf,Pn=Kt,En=kt("iterator"),Rn=function(t){var e=Object(t);return void 0!==e[En]||"@@iterator"in e||Ue.hasOwnProperty(Ne(e))},Dn=yn,kn=Nt("slice"),zn=oi("slice",{ACCESSORS:!0,0:0,1:2}),In=kt("species"),jn=[].slice,Bn=Math.max;X({target:"Array",proto:!0,forced:!kn||!zn},{slice:function(t,e){var r,i,n,o=g(this),a=J(o.length),s=Q(t,a),l=Q(void 0===e?a:e,a);if(_t(o)&&("function"!=typeof(r=o.constructor)||r!==Array&&!_t(r.prototype)?b(r)&&null===(r=r[In])&&(r=void 0):r=void 0,r===Array||void 0===r))return jn.call(o,s,l);for(i=new(void 0===r?Array:r)(Bn(l-s,0)),n=0;s<l;s++,n++)s in o&&St(i,n,o[s]);return i.length=n,i}});var Fn=Ut("Array").slice,Wn=Array.prototype,Gn=function(t){var e=t.slice;return t===Wn||t instanceof Array&&e===Wn.slice?Fn:e},Nn=Gn;var Yn=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,i=new Array(e);r<e;r++)i[r]=t[r];return i};var Vn=function(t,e){var r;if(t){if("string"==typeof t)return Yn(t,e);var i=Nn(r=Object.prototype.toString.call(t)).call(r,8,-1);return"Object"===i&&t.constructor&&(i=t.constructor.name),"Map"===i||"Set"===i?Dn(t):"Arguments"===i||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(i)?Yn(t,e):void 0}};X({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});I.Date.now;var Xn=s((function(){at(1)}));X({target:"Object",stat:!0,forced:Xn},{keys:function(t){return at(lt(t))}});var Zn=I.Object.keys,Un=wr.map,Hn=Nt("map"),$n=oi("map");X({target:"Array",proto:!0,forced:!Hn||!$n},{map:function(t){return Un(this,t,arguments.length>1?arguments[1]:void 0)}});var Jn=Ut("Array").map,qn=Array.prototype,Kn=function(t){var e=t.map;return t===qn||t instanceof Array&&e===qn.map?Jn:e};X({target:"Reflect",stat:!0},{ownKeys:en});I.Reflect.ownKeys;var Qn=Gn;var to=function(t){if(Pn(t))return Yn(t)};var eo=function(t){if(void 0!==Qr&&Rn(Object(t)))return Dn(t)};var ro=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var io=function(t){return to(t)||eo(t)||Vn(t)||ro()},no=(Kr("DELETE"),/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i),oo=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function ao(t,e,r,i){var n=!1;!0===i&&(n=null===e[r]&&void 0!==t[r]),n?delete t[r]:t[r]=e[r]}function so(t,e){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var n in e)if(Object.prototype.hasOwnProperty.call(e,n)||!0===r)if("object"===ti(e[n])&&null!==e[n]&&Mn(e[n])===Object.prototype)void 0===t[n]?t[n]=so({},e[n],r):"object"===ti(t[n])&&null!==t[n]&&Mn(t[n])===Object.prototype?so(t[n],e[n],r):ao(t,e,n,i);else if(Qt(e[n])){var o;t[n]=Qn(o=e[n]).call(o)}else ao(t,e,n,i);return t}function lo(t,e){var r;return Jt(r=[]).call(r,io(t),[e])}function ho(t){return Qn(t).call(t)}function co(t,e,r,i){var n;t.addEventListener?(void 0===i&&(i=!1),"mousewheel"===e&&Vi(n=navigator.userAgent).call(n,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,r,i)):t.attachEvent("on"+e,r)}function uo(t,e,r,i){var n;t.removeEventListener?(void 0===i&&(i=!1),"mousewheel"===e&&Vi(n=navigator.userAgent).call(n,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,r,i)):t.detachEvent("on"+e,r)}function fo(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function po(t,e,r){var i,n,o,a=Math.floor(6*t),s=6*t-a,l=r*(1-e),h=r*(1-s*e),c=r*(1-(1-s)*e);switch(a%6){case 0:i=r,n=c,o=l;break;case 1:i=h,n=r,o=l;break;case 2:i=l,n=r,o=c;break;case 3:i=l,n=h,o=r;break;case 4:i=c,n=l,o=r;break;case 5:i=r,n=l,o=h}return{r:Math.floor(255*i),g:Math.floor(255*n),b:Math.floor(255*o)}}function vo(t,e,r){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==r?r:0}vo.subtract=function(t,e){var r=new vo;return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},vo.add=function(t,e){var r=new vo;return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},vo.avg=function(t,e){return new vo((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},vo.scalarProduct=function(t,e){return new vo(t.x*e,t.y*e,t.z*e)},vo.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},vo.crossProduct=function(t,e){var r=new vo;return r.x=t.y*e.z-t.z*e.y,r.y=t.z*e.x-t.x*e.z,r.z=t.x*e.y-t.y*e.x,r},vo.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},vo.prototype.normalize=function(){return vo.scalarProduct(this,1/this.length())};var yo=vo;var mo=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function go(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var r=this;this.frame.slide.onmousedown=function(t){r._onMouseDown(t)},this.frame.prev.onclick=function(t){r.prev(t)},this.frame.play.onclick=function(t){r.togglePlay(t)},this.frame.next.onclick=function(t){r.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function bo(t,e,r,i){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,r,i)}go.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},go.prototype.next=function(){var t=this.getIndex();t<mi(this).length-1&&(t++,this.setIndex(t))},go.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<mi(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var r=new Date-t,i=Math.max(this.playInterval-r,0),n=this;this.playTimeout=wt((function(){n.playNext()}),i)},go.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},go.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},go.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},go.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},go.prototype.setPlayInterval=function(t){this.playInterval=t},go.prototype.getPlayInterval=function(){return this.playInterval},go.prototype.setPlayLoop=function(t){this.playLoop=t},go.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},go.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},go.prototype.setValues=function(t){this.values=t,mi(this).length>0?this.setIndex(0):this.index=void 0},go.prototype.setIndex=function(t){if(!(t<mi(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},go.prototype.getIndex=function(){return this.index},go.prototype.get=function(){return mi(this)[this.index]},go.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=Pi(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},co(document,"mousemove",this.onmousemove),co(document,"mouseup",this.onmouseup),fo(t)}},go.prototype.leftToIndex=function(t){var e=Pi(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,r=t-3,i=Math.round(r/e*(mi(this).length-1));return i<0&&(i=0),i>mi(this).length-1&&(i=mi(this).length-1),i},go.prototype.indexToLeft=function(t){var e=Pi(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(mi(this).length-1)*e+3},go.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,r=this.startSlideX+e,i=this.leftToIndex(r);this.setIndex(i),fo()},go.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",uo(document,"mousemove",this.onmousemove),uo(document,"mouseup",this.onmouseup),fo()},bo.prototype.isNumeric=function(t){return!isNaN(Pi(t))&&isFinite(t)},bo.prototype.setRange=function(t,e,r,i){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(r))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(r,i)},bo.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=bo.calculatePrettyStep(t):this._step=t)},bo.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},r=Math.pow(10,Math.round(e(t))),i=2*Math.pow(10,Math.round(e(t/2))),n=5*Math.pow(10,Math.round(e(t/5))),o=r;return Math.abs(i-t)<=Math.abs(o-t)&&(o=i),Math.abs(n-t)<=Math.abs(o-t)&&(o=n),o<=0&&(o=1),o},bo.prototype.getCurrent=function(){return Pi(this._current.toPrecision(this.precision))},bo.prototype.getStep=function(){return this._step},bo.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},bo.prototype.next=function(){this._current+=this._step},bo.prototype.end=function(){return this._current>this._end};var xo=bo,wo=[].reverse,_o=[1,2];X({target:"Array",proto:!0,forced:String(_o)===String(_o.reverse())},{reverse:function(){return _t(this)&&(this.length=this.length),wo.call(this)}});var So=Ut("Array").reverse,Lo=Array.prototype,Co=function(t){var e=t.reverse;return t===Lo||t instanceof Array&&e===Lo.reverse?So:e},Ao=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};X({target:"Math",stat:!0},{sign:Ao});var To=I.Math.sign;function Oo(){this.armLocation=new yo,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new yo,this.offsetMultiplier=.6,this.cameraLocation=new yo,this.cameraRotation=new yo(.5*Math.PI,0,0),this.calculateCameraOrientation()}Oo.prototype.setOffset=function(t,e){var r=Math.abs,i=To,n=this.offsetMultiplier,o=this.armLength*n;r(t)>o&&(t=i(t)*o),r(e)>o&&(e=i(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},Oo.prototype.getOffset=function(){return this.cameraOffset},Oo.prototype.setArmLocation=function(t,e,r){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=r,this.calculateCameraOrientation()},Oo.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},Oo.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},Oo.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},Oo.prototype.getArmLength=function(){return this.armLength},Oo.prototype.getCameraLocation=function(){return this.cameraLocation},Oo.prototype.getCameraRotation=function(){return this.cameraRotation},Oo.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,r=this.cameraOffset.x,i=this.cameraOffset.y,n=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+r*o(e)+i*-n(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+r*n(e)+i*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+i*n(t)};var Mo={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},Po={dot:Mo.DOT,"dot-line":Mo.DOTLINE,"dot-color":Mo.DOTCOLOR,"dot-size":Mo.DOTSIZE,line:Mo.LINE,grid:Mo.GRID,surface:Mo.SURFACE,bar:Mo.BAR,"bar-color":Mo.BARCOLOR,"bar-size":Mo.BARSIZE},Eo=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],Ro=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],Do=void 0;function ko(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function zo(t,e){return void 0===t||""===t?e:t+(void 0===(r=e)||""===r||"string"!=typeof r?r:r.charAt(0).toUpperCase()+Qn(r).call(r,1));var r}function Io(t,e,r,i){for(var n,o=0;o<r.length;++o)e[zo(i,n=r[o])]=t[n]}function jo(t,e,r,i){for(var n,o=0;o<r.length;++o)void 0!==t[n=r[o]]&&(e[zo(i,n)]=t[n])}function Bo(t,e){if(void 0!==t.backgroundColor&&function(t,e){var r="white",i="gray",n=1;if("string"==typeof t)r=t,i="none",n=0;else{if("object"!==ti(t))throw new Error("Unsupported type of backgroundColor");void 0!==xi(t)&&(r=xi(t)),void 0!==t.stroke&&(i=t.stroke),void 0!==t.strokeWidth&&(n=t.strokeWidth)}e.frame.style.backgroundColor=r,e.frame.style.borderColor=i,e.frame.style.borderWidth=n+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(xi(t)&&(e.dataColor.fill=xi(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var r;if("string"==typeof t){if(-1===(r=function(t){var e=Po[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var r in Mo)if(Mo[r]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");r=t}e.style=r}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var r;if(Qt(t))r=Fo(t);else{if("object"!==ti(t))throw new Error("Unsupported type of surfaceColors");r=Wo(t.hue)}Co(r).call(r),e.colormap=r}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var r;if(Qt(t))r=Fo(t);else if("object"===ti(t))r=Wo(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");r=t}e.colormap=r}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===Do.showLegend){var r=e.style===Mo.DOTCOLOR||e.style===Mo.DOTSIZE;e.showLegend=r}}else e.showLegend=t}(t.showLegend,e),Go(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,r){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Qt(r))throw new TypeError("Arrays are not supported by deepExtend");for(var n=0;n<t.length;n++){var o=t[n];if(Object.prototype.hasOwnProperty.call(r,o))if(r[o]&&r[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?so(e[o],r[o],!1,i):ao(e,r,o,i);else{if(Qt(r[o]))throw new TypeError("Arrays are not supported by deepExtend");ao(e,r,o,i)}}}(["tooltipStyle"],e,t)}function Fo(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return Kn(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=oo.exec(t))?{r:Ln(e[1]+e[1],16),g:Ln(e[2]+e[2],16),b:Ln(e[3]+e[3],16)}:null;case 6:case 7:return(e=no.exec(t))?{r:Ln(e[1],16),g:Ln(e[2],16),b:Ln(e[3],16)}:null;default:return null}}(t)}))}function Wo(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),r=[],i=0;i<t.colorStops;++i){var n=(t.start+e*i)%360/360;r.push(po(n<0?n+1:n,t.saturation/100,t.brightness/100))}return r}function Go(t,e){var r=t;void 0!==r&&(void 0===e.camera&&(e.camera=new Oo),e.camera.setArmRotation(r.horizontal,r.vertical),e.camera.setArmLength(r.distance))}var No=pt("JSON","stringify"),Yo=/[\uD800-\uDFFF]/g,Vo=/^[\uD800-\uDBFF]$/,Xo=/^[\uDC00-\uDFFF]$/,Zo=function(t,e,r){var i=r.charAt(e-1),n=r.charAt(e+1);return Vo.test(t)&&!Xo.test(n)||Xo.test(t)&&!Vo.test(i)?"\\u"+t.charCodeAt(0).toString(16):t},Uo=s((function(){return'"\\udf06\\ud834"'!==No("\udf06\ud834")||'"\\udead"'!==No("\udead")}));No&&X({target:"JSON",stat:!0,forced:Uo},{stringify:function(t,e,r){var i=No.apply(null,arguments);return"string"==typeof i?i.replace(Yo,Zo):i}}),I.JSON||(I.JSON={stringify:JSON.stringify});var Ho=function(t,e,r){return I.JSON.stringify.apply(null,arguments)};var $o=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function Jo(t,e){for(var r=0;r<e.length;r++){var i=e[r];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),gn(t,i.key,i)}}var qo,Ko=function(t,e,r){return e&&Jo(t.prototype,e),r&&Jo(t,r),t},Qo=!1,ta="background: #FFeeee; color: #dd0000",ea=function(){function t(){$o(this,t)}return Ko(t,null,[{key:"validate",value:function(e,r,i){Qo=!1,qo=r;var n=r;return void 0!==i&&(n=r[i]),t.parse(e,n,[]),Qo}},{key:"parse",value:function(e,r,i){for(var n in e)e.hasOwnProperty(n)&&t.check(n,e,r,i)}},{key:"check",value:function(e,r,i,n){if(void 0!==i[e]||void 0!==i.__any__){var o=e,a=!0;void 0===i[e]&&void 0!==i.__any__&&(o="__any__",a="object"===t.getType(r[e]));var s=i[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,r,i,o,s,n)}else t.getSuggestion(e,i,n)}},{key:"checkFields",value:function(e,r,i,n,o,a){var s=function(r){console.log("%c"+r+t.printLocation(a,e),ta)},l=t.getType(r[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===Vi(h).call(h,r[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+r[e]+'". '),Qo=!0):"object"===l&&"__any__"!==n&&(a=lo(a,e),t.parse(r[e],i[n],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(Zn(o))+". Received ["+l+'] "'+r[e]+'"'),Qo=!0)}},{key:"getType",value:function(t){var e=ti(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Qt(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,r,i){var n,o=t.findInOptions(e,r,i,!1),a=t.findInOptions(e,qo,[],!0);n=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(Zn(r))+t.printLocation(i,e),console.log('%cUnknown option detected: "'+e+'"'+n,ta),Qo=!0}},{key:"findInOptions",value:function(e,r,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],l=e.toLowerCase(),h=void 0;for(var c in r){var u=void 0;if(void 0!==r[c].__type__&&!0===n){var f=t.findInOptions(e,r[c],lo(i,c));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,h=f.indexMatch)}else{var d;-1!==Vi(d=c.toLowerCase()).call(d,l)&&(h=c),o>(u=t.levenshteinDistance(e,c))&&(a=c,s=ho(i),o=u)}}return{closestMatch:a,path:s,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",i="\n\n"+r+"options = {\n",n=0;n<t.length;n++){for(var o=0;o<n+1;o++)i+="  ";i+=t[n]+": {\n"}for(var a=0;a<t.length+1;a++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var l=0;l<t.length-s;l++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return Ho(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var r,i,n=[];for(r=0;r<=e.length;r++)n[r]=[r];for(i=0;i<=t.length;i++)n[0][i]=i;for(r=1;r<=e.length;r++)for(i=1;i<=t.length;i++)e.charAt(r-1)==t.charAt(i-1)?n[r][i]=n[r-1][i-1]:n[r][i]=Math.min(n[r-1][i-1]+1,Math.min(n[r][i-1]+1,n[r-1][i]+1));return n[e.length][t.length]}}]),t}(),ra="string",ia="boolean",na="number",oa="object",aa={fill:{string:ra},stroke:{string:ra},strokeWidth:{number:na},__type__:{string:ra,object:oa,undefined:"undefined"}},sa={animationAutoStart:{boolean:ia,undefined:"undefined"},animationInterval:{number:na},animationPreload:{boolean:ia},axisColor:{string:ra},axisFontSize:{number:na},axisFontType:{string:ra},backgroundColor:aa,xBarWidth:{number:na,undefined:"undefined"},yBarWidth:{number:na,undefined:"undefined"},cameraPosition:{distance:{number:na},horizontal:{number:na},vertical:{number:na},__type__:{object:oa}},zoomable:{boolean:ia},ctrlToZoom:{boolean:ia},xCenter:{string:ra},yCenter:{string:ra},colormap:{hue:{start:{number:na},end:{number:na},saturation:{number:na},brightness:{number:na},colorStops:{number:na},__type__:{object:oa}},__type__:{array:"array",object:oa,function:"function",undefined:"undefined"}},dataColor:aa,dotSizeMinFraction:{number:na},dotSizeMaxFraction:{number:na},dotSizeRatio:{number:na},filterLabel:{string:ra},gridColor:{string:ra},onclick:{function:"function"},keepAspectRatio:{boolean:ia},xLabel:{string:ra},yLabel:{string:ra},zLabel:{string:ra},legendLabel:{string:ra},xMin:{number:na,undefined:"undefined"},yMin:{number:na,undefined:"undefined"},zMin:{number:na,undefined:"undefined"},xMax:{number:na,undefined:"undefined"},yMax:{number:na,undefined:"undefined"},zMax:{number:na,undefined:"undefined"},showAnimationControls:{boolean:ia,undefined:"undefined"},showGrayBottom:{boolean:ia},showGrid:{boolean:ia},showLegend:{boolean:ia,undefined:"undefined"},showPerspective:{boolean:ia},showShadow:{boolean:ia},showSurfaceGrid:{boolean:ia},showXAxis:{boolean:ia},showYAxis:{boolean:ia},showZAxis:{boolean:ia},rotateAxisLabels:{boolean:ia},surfaceColors:{hue:{start:{number:na},end:{number:na},saturation:{number:na},brightness:{number:na},colorStops:{number:na},__type__:{object:oa}},__type__:{boolean:ia,array:"array",object:oa,undefined:"undefined"}},xStep:{number:na,undefined:"undefined"},yStep:{number:na,undefined:"undefined"},zStep:{number:na,undefined:"undefined"},style:{number:na,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:ia,function:"function"},tooltipDelay:{number:na},tooltipStyle:{content:{color:{string:ra},background:{string:ra},border:{string:ra},borderRadius:{string:ra},boxShadow:{string:ra},padding:{string:ra},__type__:{object:oa}},line:{borderLeft:{string:ra},height:{string:ra},width:{string:ra},pointerEvents:{string:ra},__type__:{object:oa}},dot:{border:{string:ra},borderRadius:{string:ra},height:{string:ra},width:{string:ra},pointerEvents:{string:ra},__type__:{object:oa}},__type__:{object:oa}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:na,undefined:"undefined"},valueMin:{number:na,undefined:"undefined"},verticalRatio:{number:na},height:{string:ra},width:{string:ra},__type__:{object:oa}};function la(){this.min=void 0,this.max=void 0}la.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},la.prototype.combine=function(t){this.add(t.min),this.add(t.max)},la.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,r=this.max+t;if(e>r)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=r}},la.prototype.range=function(){return this.max-this.min},la.prototype.center=function(){return(this.min+this.max)/2};var ha=la;function ca(t,e,r){this.dataGroup=t,this.column=e,this.graph=r,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),mi(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,r.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function ua(){this.dataTable=null}ca.prototype.isLoaded=function(){return this.loaded},ca.prototype.getLoadedProgress=function(){for(var t=mi(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},ca.prototype.getLabel=function(){return this.graph.filterLabel},ca.prototype.getColumn=function(){return this.column},ca.prototype.getSelectedValue=function(){if(void 0!==this.index)return mi(this)[this.index]},ca.prototype.getValues=function(){return mi(this)},ca.prototype.getValue=function(t){if(t>=mi(this).length)throw new Error("Index out of range");return mi(this)[t]},ca.prototype._getDataPoints=function(e){if(void 0===e&&(e=this.index),void 0===e)return[];var r;if(this.dataPoints[e])r=this.dataPoints[e];else{var i={};i.column=this.column,i.value=mi(this)[e];var n=new t(this.dataGroup.getDataSet(),{filter:function(t){return t[i.column]==i.value}}).get();r=this.dataGroup._getDataPoints(n),this.dataPoints[e]=r}return r},ca.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},ca.prototype.selectValue=function(t){if(t>=mi(this).length)throw new Error("Index out of range");this.index=t,this.value=mi(this)[t]},ca.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<mi(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var r=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+r+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var i=this;wt((function(){i.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},ua.prototype.initializeData=function(r,i,n){if(void 0!==i){var o;if(Qt(i)&&(i=new e(i)),!(i instanceof e||i instanceof t))throw new Error("Array, DataSet, or DataView expected");if(0!=(o=i.get()).length){this.style=n,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=i,this.dataTable=o;var a=this;this._onChange=function(){r.setData(a.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var s=r.hasBars(n);if(s&&(void 0!==r.defaultXBarWidth?this.xBarWidth=r.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(o,this.colX)||1,void 0!==r.defaultYBarWidth?this.yBarWidth=r.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(o,this.colY)||1),this._initializeRange(o,this.colX,r,s),this._initializeRange(o,this.colY,r,s),this._initializeRange(o,this.colZ,r,!1),o[0].hasOwnProperty("style")){this.colValue="style";var l=this.getColumnRange(o,this.colValue);this._setRangeDefaults(l,r.defaultValueMin,r.defaultValueMax),this.valueRange=l}else this.colValue="z",this.valueRange=this.zRange;return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new ca(this,"filter",r),this.dataFilter.setOnLoadCallback((function(){r.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},ua.prototype._collectRangeSettings=function(t,e){var r;if(-1==Vi(r=["x","y","z"]).call(r,t))throw new Error("Column '"+t+"' invalid");var i=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+i+"Min"],max:e["default"+i+"Max"],step:e["default"+i+"Step"],range_label:t+"Range",step_label:t+"Step"}},ua.prototype._initializeRange=function(t,e,r,i){var n=this._collectRangeSettings(e,r),o=this.getColumnRange(t,e);i&&"z"!=e&&o.expand(n.barWidth/2),this._setRangeDefaults(o,n.min,n.max),this[n.range_label]=o,this[n.step_label]=void 0!==n.step?n.step:o.range()/5},ua.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var r=[],i=0;i<e.length;i++){var n=e[i][t]||0;-1===Vi(r).call(r,n)&&r.push(n)}return Ki(r).call(r,(function(t,e){return t-e}))},ua.prototype.getSmallestDifference=function(t,e){for(var r=this.getDistinctValues(t,e),i=null,n=1;n<r.length;n++){var o=r[n]-r[n-1];(null==i||i>o)&&(i=o)}return i},ua.prototype.getColumnRange=function(t,e){for(var r=new ha,i=0;i<t.length;i++){var n=t[i][e];r.adjust(n)}return r},ua.prototype.getNumberOfRows=function(){return this.dataTable.length},ua.prototype._setRangeDefaults=function(t,e,r){void 0!==e&&(t.min=e),void 0!==r&&(t.max=r),t.max<=t.min&&(t.max=t.min+1)},ua.prototype.getDataTable=function(){return this.dataTable},ua.prototype.getDataSet=function(){return this.dataSet},ua.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var i=new yo;i.x=t[r][this.colX]||0,i.y=t[r][this.colY]||0,i.z=t[r][this.colZ]||0,i.data=t[r],i.value=t[r][this.colValue]||0;var n={};n.point=i,n.bottom=new yo(i.x,i.y,this.zRange.min),n.trans=void 0,n.screen=void 0,e.push(n)}return e},ua.prototype.initDataAsMatrix=function(t){var e,r,i,n,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),l=[];for(i=0;i<s.length;i++){n=s[i];var h=Vi(o).call(o,n.point.x),c=Vi(a).call(a,n.point.y);void 0===l[h]&&(l[h]=[]),l[h][c]=n}for(e=0;e<l.length;e++)for(r=0;r<l[e].length;r++)l[e][r]&&(l[e][r].pointRight=e<l.length-1?l[e+1][r]:void 0,l[e][r].pointTop=r<l[e].length-1?l[e][r+1]:void 0,l[e][r].pointCross=e<l.length-1&&r<l[e].length-1?l[e+1][r+1]:void 0);return s},ua.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},ua.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},ua.prototype._getDataPoints=function(t){var e=[];if(this.style===Mo.GRID||this.style===Mo.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===Mo.LINE)for(var r=0;r<e.length;r++)r>0&&(e[r-1].pointNext=e[r]);return e},fa.STYLE=Mo;function fa(t,e,r){if(!(this instanceof fa))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new ua,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||ko(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");Do=t,Io(t,e,Eo),Io(t,e,Ro,"default"),Bo(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new yo(0,0,-1)}(fa.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(r),this.setData(e)}function da(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function pa(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}fa.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:void 0,animationInterval:1e3,animationPreload:!1,animationAutoStart:void 0,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:fa.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:void 0,colormap:void 0,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:void 0,backgroundColor:void 0,xBarWidth:void 0,yBarWidth:void 0,valueMin:void 0,valueMax:void 0,xMin:void 0,xMax:void 0,xStep:void 0,yMin:void 0,yMax:void 0,yStep:void 0,zMin:void 0,zMax:void 0,zStep:void 0},Qi(fa.prototype),fa.prototype._setScale=function(){this.scale=new yo(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,r=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,r)},fa.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},fa.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),r=this.camera.getCameraRotation(),i=t.x*this.scale.x,n=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,l=e.z,h=Math.sin(r.x),c=Math.cos(r.x),u=Math.sin(r.y),f=Math.cos(r.y),d=Math.sin(r.z),p=Math.cos(r.z);return new yo(f*(d*(n-s)+p*(i-a))-u*(o-l),h*(f*(o-l)+u*(d*(n-s)+p*(i-a)))+c*(p*(n-s)-d*(i-a)),c*(f*(o-l)+u*(d*(n-s)+p*(i-a)))-h*(p*(n-s)-d*(i-a)))},fa.prototype._convertTranslationToScreen=function(t){var e,r,i=this.eye.x,n=this.eye.y,o=this.eye.z,a=t.x,s=t.y,l=t.z;return this.showPerspective?(e=o/l*(a-i),r=o/l*(s-n)):(e=a*(-o/this.camera.getArmLength()),r=s*(-o/this.camera.getArmLength())),new mo(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-r*this.frame.canvas.clientWidth)},fa.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var r=t[e];r.trans=this._convertPointToTranslation(r.point),r.screen=this._convertTranslationToScreen(r.trans);var i=this._convertPointToTranslation(r.bottom);r.dist=this.showPerspective?i.length():-i.z}Ki(t).call(t,(function(t,e){return e.dist-t.dist}))},fa.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},fa.prototype.getDataPoints=function(t){for(var e=[],r=0;r<t.length;r++){var i=new yo;i.x=t[r][this.colX]||0,i.y=t[r][this.colY]||0,i.z=t[r][this.colZ]||0,i.data=t[r],i.value=t[r][this.colValue]||0;var n={};n.point=i,n.bottom=new yo(i.x,i.y,this.zRange.min),n.trans=void 0,n.screen=void 0,e.push(n)}return e},fa.prototype._getDataPoints=function(t){var e,r,i,n,o=[];if(this.style===fa.STYLE.GRID||this.style===fa.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var l=[];for(i=0;i<o.length;i++){n=o[i];var h=Vi(a).call(a,n.point.x),c=Vi(s).call(s,n.point.y);void 0===l[h]&&(l[h]=[]),l[h][c]=n}for(e=0;e<l.length;e++)for(r=0;r<l[e].length;r++)l[e][r]&&(l[e][r].pointRight=e<l.length-1?l[e+1][r]:void 0,l[e][r].pointTop=r<l[e].length-1?l[e][r+1]:void 0,l[e][r].pointCross=e<l.length-1&&r<l[e].length-1?l[e+1][r+1]:void 0)}else if(o=this.getDataPoints(t),this.style===fa.STYLE.LINE)for(i=0;i<o.length;i++)i>0&&(o[i-1].pointNext=o[i]);return o},fa.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),Ii(this.frame).style.position="absolute",Ii(this.frame).style.bottom="0px",Ii(this.frame).style.left="0px",Ii(this.frame).style.width="100%",this.frame.appendChild(Ii(this.frame));var e=this;co(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),co(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),co(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),co(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),co(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},fa.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},fa.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,Ii(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},fa.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!Ii(this.frame)||!Ii(this.frame).slider)throw new Error("No animation available");Ii(this.frame).slider.play()}},fa.prototype.animationStop=function(){Ii(this.frame)&&Ii(this.frame).slider&&Ii(this.frame).slider.stop()},fa.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=Pi(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=Pi(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=Pi(this.yCenter)/100*(this.frame.canvas.clientHeight-Ii(this.frame).clientHeight):this.currentYCenter=Pi(this.yCenter)},fa.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},fa.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},fa.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},fa.prototype.setOptions=function(t){void 0!==t&&(!0===ea.validate(t,sa)&&console.log("%cErrors have been found in the supplied options object.",ta),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===Do||ko(Do))throw new Error("DEFAULTS not set for module Settings");jo(t,e,Eo),jo(t,e,Ro,"default"),Bo(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},fa.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case fa.STYLE.BAR:t=this._redrawBarGraphPoint;break;case fa.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case fa.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case fa.STYLE.DOT:t=this._redrawDotGraphPoint;break;case fa.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case fa.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case fa.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case fa.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case fa.STYLE.GRID:t=this._redrawGridGraphPoint;break;case fa.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},fa.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},fa.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},fa.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},fa.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},fa.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},fa.prototype._getLegendWidth=function(){var t;this.style===fa.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===fa.STYLE.BARSIZE?this.xBarWidth:20;return t},fa.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==fa.STYLE.LINE&&this.style!==fa.STYLE.BARSIZE){var t=this.style===fa.STYLE.BARSIZE||this.style===fa.STYLE.DOTSIZE,e=this.style===fa.STYLE.DOTSIZE||this.style===fa.STYLE.DOTCOLOR||this.style===fa.STYLE.SURFACE||this.style===fa.STYLE.BARCOLOR,r=Math.max(.25*this.frame.clientHeight,100),i=this.margin,n=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-n,s=i+r,l=this._getContext();if(l.lineWidth=1,l.font="14px arial",!1===t){var h,c=r;for(h=0;h<c;h++){var u=1-(h-0)/(c-0),f=this._colormap(u,1);l.strokeStyle=f,l.beginPath(),l.moveTo(a,i+h),l.lineTo(o,i+h),l.stroke()}l.strokeStyle=this.axisColor,l.strokeRect(a,i,n,r)}else{var d;this.style===fa.STYLE.DOTSIZE?d=n*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,fa.STYLE.BARSIZE),l.strokeStyle=this.axisColor,l.fillStyle=xi(this.dataColor),l.beginPath(),l.moveTo(a,i),l.lineTo(o,i),l.lineTo(a+d,s),l.lineTo(a,s),l.closePath(),xi(l).call(l),l.stroke()}var p,v,y=e?this.valueRange.min:this.zRange.min,m=e?this.valueRange.max:this.zRange.max,g=new xo(y,m,(m-y)/5,!0);for(g.start(!0);!g.end();)h=s-(g.getCurrent()-y)/(m-y)*r,p=new mo(a-5,h),v=new mo(a,h),this._line(l,p,v),l.textAlign="right",l.textBaseline="middle",l.fillStyle=this.axisColor,l.fillText(g.getCurrent(),a-10,h),g.next();l.textAlign="right",l.textBaseline="top";var b=this.legendLabel;l.fillText(b,o,s+this.margin)}},fa.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=Ii(this.frame);if(e.innerHTML="",t){var r=new go(e,{visible:this.showAnimationControls});e.slider=r,e.style.padding="10px",r.setValues(mi(t)),r.setPlayInterval(this.animationInterval);var i=this;r.setOnChangeCallback((function(){var t=i.dataGroup.dataFilter,e=r.getIndex();t.selectValue(e),i.dataPoints=t._getDataPoints(),i.redraw()}))}else e.slider=void 0},fa.prototype._redrawSlider=function(){void 0!==Ii(this.frame).slider&&Ii(this.frame).slider.redraw()},fa.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var r=this.margin,i=this.margin;e.fillText(t,r,i)}},fa.prototype._line=function(t,e,r,i){void 0!==i&&(t.strokeStyle=i),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(r.x,r.y),t.stroke()},fa.prototype.drawAxisLabelX=function(t,e,r,i,n){void 0===n&&(n=0);var o=this._convert3Dto2D(e);Math.cos(2*i)>0?(t.textAlign="center",t.textBaseline="top",o.y+=n):Math.sin(2*i)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},fa.prototype.drawAxisLabelY=function(t,e,r,i,n){void 0===n&&(n=0);var o=this._convert3Dto2D(e);Math.cos(2*i)<0?(t.textAlign="center",t.textBaseline="top",o.y+=n):Math.sin(2*i)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)},fa.prototype.drawAxisLabelZ=function(t,e,r,i){void 0===i&&(i=0);var n=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,n.x-i,n.y)},fa.prototype.drawAxisLabelXRotate=function(t,e,r,i,n){var o=this._convert3Dto2D(e);Math.cos(2*i)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*i)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},fa.prototype.drawAxisLabelYRotate=function(t,e,r,i,n){var o=this._convert3Dto2D(e);Math.cos(2*i)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,0,0),t.restore()):Math.sin(2*i)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,o.x,o.y))},fa.prototype.drawAxisLabelZRotate=function(t,e,r,i){void 0===i&&(i=0);var n=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(r,n.x-i,n.y)},fa.prototype._line3d=function(t,e,r,i){var n=this._convert3Dto2D(e),o=this._convert3Dto2D(r);this._line(t,n,o,i)},fa.prototype._redrawAxis=function(){var t,e,r,i,n,o,a,s,l,h,c=this._getContext();c.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var u,f,d,p=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new mo(Math.cos(m),Math.sin(m)),b=this.xRange,x=this.yRange,w=this.zRange;for(c.lineWidth=1,i=void 0===this.defaultXStep,(r=new xo(b.min,b.max,this.xStep,i)).start(!0);!r.end();){var _=r.getCurrent();if(this.showGrid?(t=new yo(_,x.min,w.min),e=new yo(_,x.max,w.min),this._line3d(c,t,e,this.gridColor)):this.showXAxis&&(t=new yo(_,x.min,w.min),e=new yo(_,x.min+p,w.min),this._line3d(c,t,e,this.axisColor),t=new yo(_,x.max,w.min),e=new yo(_,x.max-p,w.min),this._line3d(c,t,e,this.axisColor)),this.showXAxis){a=g.x>0?x.min:x.max,u=new yo(_,a,w.min);var S="  "+this.xValueLabel(_)+"  ";this._drawAxisLabelX.call(this,c,u,S,m,y)}r.next()}for(c.lineWidth=1,i=void 0===this.defaultYStep,(r=new xo(x.min,x.max,this.yStep,i)).start(!0);!r.end();){var L=r.getCurrent();if(this.showGrid?(t=new yo(b.min,L,w.min),e=new yo(b.max,L,w.min),this._line3d(c,t,e,this.gridColor)):this.showYAxis&&(t=new yo(b.min,L,w.min),e=new yo(b.min+v,L,w.min),this._line3d(c,t,e,this.axisColor),t=new yo(b.max,L,w.min),e=new yo(b.max-v,L,w.min),this._line3d(c,t,e,this.axisColor)),this.showYAxis){o=g.y>0?b.min:b.max,u=new yo(o,L,w.min);var C="  "+this.yValueLabel(L)+"  ";this._drawAxisLabelY.call(this,c,u,C,m,y)}r.next()}if(this.showZAxis){for(c.lineWidth=1,i=void 0===this.defaultZStep,(r=new xo(w.min,w.max,this.zStep,i)).start(!0),o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max;!r.end();){var A=r.getCurrent(),T=new yo(o,a,A),O=this._convert3Dto2D(T);e=new mo(O.x-y,O.y),this._line(c,O,e,this.axisColor);var M=this.zValueLabel(A)+" ";this._drawAxisLabelZ.call(this,c,T,M,5),r.next()}c.lineWidth=1,t=new yo(o,a,w.min),e=new yo(o,a,w.max),this._line3d(c,t,e,this.axisColor)}this.showXAxis&&(c.lineWidth=1,f=new yo(b.min,x.min,w.min),d=new yo(b.max,x.min,w.min),this._line3d(c,f,d,this.axisColor),f=new yo(b.min,x.max,w.min),d=new yo(b.max,x.max,w.min),this._line3d(c,f,d,this.axisColor));this.showYAxis&&(c.lineWidth=1,t=new yo(b.min,x.min,w.min),e=new yo(b.min,x.max,w.min),this._line3d(c,t,e,this.axisColor),t=new yo(b.max,x.min,w.min),e=new yo(b.max,x.max,w.min),this._line3d(c,t,e,this.axisColor));var P=this.xLabel;P.length>0&&this.showXAxis&&(h=.1/this.scale.y,o=(b.max+3*b.min)/4,a=g.x>0?x.min-h:x.max+h,n=new yo(o,a,w.min),this.drawAxisLabelX(c,n,P,m));var E=this.yLabel;E.length>0&&this.showYAxis&&(l=.1/this.scale.x,o=g.y>0?b.min-l:b.max+l,a=(x.max+3*x.min)/4,n=new yo(o,a,w.min),this.drawAxisLabelY(c,n,E,m));var R=this.zLabel;R.length>0&&this.showZAxis&&(30,o=g.x>0?b.min:b.max,a=g.y<0?x.min:x.max,s=(w.max+3*w.min)/4,n=new yo(o,a,s),this.drawAxisLabelZ(c,n,R,30))},fa.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},fa.prototype._redrawBar=function(t,e,r,i,n,o){var a,s=this,l=e.point,h=this.zRange.min,c=[{point:new yo(l.x-r,l.y-i,l.z)},{point:new yo(l.x+r,l.y-i,l.z)},{point:new yo(l.x+r,l.y+i,l.z)},{point:new yo(l.x-r,l.y+i,l.z)}],u=[{point:new yo(l.x-r,l.y-i,h)},{point:new yo(l.x+r,l.y-i,h)},{point:new yo(l.x+r,l.y+i,h)},{point:new yo(l.x-r,l.y+i,h)}];di(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)})),di(u).call(u,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:c,center:yo.avg(u[0].point,u[2].point)},{corners:[c[0],c[1],u[1],u[0]],center:yo.avg(u[1].point,u[0].point)},{corners:[c[1],c[2],u[2],u[1]],center:yo.avg(u[2].point,u[1].point)},{corners:[c[2],c[3],u[3],u[2]],center:yo.avg(u[3].point,u[2].point)},{corners:[c[3],c[0],u[0],u[3]],center:yo.avg(u[0].point,u[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}Ki(f).call(f,(function(t,e){var r=e.dist-t.dist;return r||(t.corners===c?1:e.corners===c?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=n;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},fa.prototype._polygon=function(t,e,r,i){if(!(e.length<2)){void 0!==r&&(t.fillStyle=r),void 0!==i&&(t.strokeStyle=i),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var n=1;n<e.length;++n){var o=e[n];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),xi(t).call(t),t.stroke()}},fa.prototype._drawCircle=function(t,e,r,i,n){var o=this._calcRadius(e,n);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=i,t.fillStyle=r,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),xi(t).call(t),t.stroke()},fa.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},fa.prototype._getColorsColor=function(t){var e,r,i;if(t&&t.point&&t.point.data&&t.point.data.style&&(i=t.point.data.style),i&&"object"===ti(i)&&xi(i)&&i.stroke)return{fill:xi(i),border:i.stroke};if("string"==typeof t.point.value)e=t.point.value,r=t.point.value;else{var n=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(n,1),r=this._colormap(n,.8)}return{fill:e,border:r}},fa.prototype._getColorsSize=function(){return{fill:xi(this.dataColor),border:this.dataColor.stroke}},fa.prototype._colormap=function(t){var e,r,i,n,o,a,s,l,h,c=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,u=this.colormap;if(Qt(u)){var f=u.length-1,d=Math.max(Math.floor(t*f),0),p=Math.min(d+1,f),v=t*f-d,y=u[d],m=u[p];e=y.r+v*(m.r-y.r),r=y.g+v*(m.g-y.g),i=y.b+v*(m.b-y.b)}else if("function"==typeof u){var g=u(t);e=g.r,r=g.g,i=g.b,n=g.a}else{var b=240*(1-t),x=po(b/360,1,1);e=x.r,r=x.g,i=x.b}return"number"!=typeof n||qt(n)?Jt(o=Jt(a="RGB(".concat(Math.round(e*c),", ")).call(a,Math.round(r*c),", ")).call(o,Math.round(i*c),")"):Jt(s=Jt(l=Jt(h="RGBA(".concat(Math.round(e*c),", ")).call(h,Math.round(r*c),", ")).call(l,Math.round(i*c),", ")).call(s,n,")")},fa.prototype._calcRadius=function(t,e){var r;return void 0===e&&(e=this._dotSize()),(r=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(r=0),r},fa.prototype._redrawBarGraphPoint=function(t,e){var r=this.xBarWidth/2,i=this.yBarWidth/2,n=this._getColorsRegular(e);this._redrawBar(t,e,r,i,xi(n),n.border)},fa.prototype._redrawBarColorGraphPoint=function(t,e){var r=this.xBarWidth/2,i=this.yBarWidth/2,n=this._getColorsColor(e);this._redrawBar(t,e,r,i,xi(n),n.border)},fa.prototype._redrawBarSizeGraphPoint=function(t,e){var r=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=this.xBarWidth/2*(.8*r+.2),n=this.yBarWidth/2*(.8*r+.2),o=this._getColorsSize();this._redrawBar(t,e,i,n,xi(o),o.border)},fa.prototype._redrawDotGraphPoint=function(t,e){var r=this._getColorsRegular(e);this._drawCircle(t,e,xi(r),r.border)},fa.prototype._redrawDotLineGraphPoint=function(t,e){var r=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,r,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},fa.prototype._redrawDotColorGraphPoint=function(t,e){var r=this._getColorsColor(e);this._drawCircle(t,e,xi(r),r.border)},fa.prototype._redrawDotSizeGraphPoint=function(t,e){var r=this._dotSize(),i=(e.point.value-this.valueRange.min)/this.valueRange.range(),n=r*this.dotSizeMinFraction,o=n+(r*this.dotSizeMaxFraction-n)*i,a=this._getColorsSize();this._drawCircle(t,e,xi(a),a.border,o)},fa.prototype._redrawSurfaceGraphPoint=function(t,e){var r=e.pointRight,i=e.pointTop,n=e.pointCross;if(void 0!==e&&void 0!==r&&void 0!==i&&void 0!==n){var o,a,s,l=!0;if(this.showGrayBottom||this.showShadow){var h=yo.subtract(n.trans,e.trans),c=yo.subtract(i.trans,r.trans),u=yo.crossProduct(h,c);if(this.showPerspective){var f=yo.avg(yo.avg(e.trans,n.trans),yo.avg(r.trans,i.trans));s=-yo.dotProduct(u.normalize(),f.normalize())}else s=u.z/u.length();l=s>0}if(l||!this.showGrayBottom){var d=((e.point.value+r.point.value+i.point.value+n.point.value)/4-this.valueRange.min)*this.scale.value,p=this.showShadow?(1+s)/2:1;o=this._colormap(d,p)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,r,n,i];this._polygon(t,v,o,a)}},fa.prototype._drawGridLine=function(t,e,r){if(void 0!==e&&void 0!==r){var i=((e.point.value+r.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(i,1),this._line(t,e.screen,r.screen)}},fa.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},fa.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},fa.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var r=this.dataPoints[t];this._pointDrawingMethod.call(this,e,r)}},fa.prototype._storeMousePosition=function(t){this.startMouseX=da(t),this.startMouseY=pa(t),this._startCameraOffset=this.camera.getOffset()},fa.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},co(document,"mousemove",e.onmousemove),co(document,"mouseup",e.onmouseup),fo(t)}},fa.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=Pi(da(t))-this.startMouseX,r=Pi(pa(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var i=.5*this.frame.clientWidth,n=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/i*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+r/n*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,l=this.startArmRotation.vertical+r/200,h=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<h&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<h&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(l))<h&&(l=Math.round(l/Math.PI)*Math.PI),Math.abs(Math.cos(l))<h&&(l=(Math.round(l/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,l)}this.redraw();var c=this.getCameraPosition();this.emit("cameraPositionChange",c),fo(t)},fa.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,uo(document,"mousemove",this.onmousemove),uo(document,"mouseup",this.onmouseup),fo(t)},fa.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),r=da(t)-e.left,i=pa(t)-e.top,n=this._dataPointFromXY(r,i);n&&(this.onclick_callback&&this.onclick_callback(n.point.data),this.emit("click",n.point.data))}fo(t)}},fa.prototype._onTooltip=function(t){var e=this.tooltipDelay,r=this.frame.getBoundingClientRect(),i=da(t)-r.left,n=pa(t)-r.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(i,n);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=wt((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(i,n);t&&a._showTooltip(t)}),e)}},fa.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},co(document,"touchmove",e.ontouchmove),co(document,"touchend",e.ontouchend),this._onMouseDown(t)},fa.prototype._onTouchMove=function(t){this._onMouseMove(t)},fa.prototype._onTouchEnd=function(t){this.touchDown=!1,uo(document,"touchmove",this.ontouchmove),uo(document,"touchend",this.ontouchend),this._onMouseUp(t)},fa.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var r=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(r),this.redraw(),this._hideTooltip()}var i=this.getCameraPosition();this.emit("cameraPositionChange",i),fo(t)}},fa.prototype._insideTriangle=function(t,e){var r=e[0],i=e[1],n=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((i.x-r.x)*(t.y-r.y)-(i.y-r.y)*(t.x-r.x)),s=o((n.x-i.x)*(t.y-i.y)-(n.y-i.y)*(t.x-i.x)),l=o((r.x-n.x)*(t.y-n.y)-(r.y-n.y)*(t.x-n.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=l&&s!=l||0!=a&&0!=l&&a!=l)},fa.prototype._dataPointFromXY=function(t,e){var r,i=null,n=null,o=null,a=new mo(t,e);if(this.style===fa.STYLE.BAR||this.style===fa.STYLE.BARCOLOR||this.style===fa.STYLE.BARSIZE)for(r=this.dataPoints.length-1;r>=0;r--){var s=(i=this.dataPoints[r]).surfaces;if(s)for(var l=s.length-1;l>=0;l--){var h=s[l].corners,c=[h[0].screen,h[1].screen,h[2].screen],u=[h[2].screen,h[3].screen,h[0].screen];if(this._insideTriangle(a,c)||this._insideTriangle(a,u))return i}}else for(r=0;r<this.dataPoints.length;r++){var f=(i=this.dataPoints[r]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),v=Math.sqrt(d*d+p*p);(null===o||v<o)&&v<100&&(o=v,n=i)}}return n},fa.prototype.hasBars=function(t){return t==fa.STYLE.BAR||t==fa.STYLE.BARCOLOR||t==fa.STYLE.BARSIZE},fa.prototype._showTooltip=function(t){var e,r,i;this.tooltip?(e=this.tooltip.dom.content,r=this.tooltip.dom.line,i=this.tooltip.dom.dot):(e=document.createElement("div"),ft(e.style,{},this.tooltipStyle.content),e.style.position="absolute",r=document.createElement("div"),ft(r.style,{},this.tooltipStyle.line),r.style.position="absolute",i=document.createElement("div"),ft(i.style,{},this.tooltipStyle.dot),i.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:r,dot:i}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(r),this.frame.appendChild(i);var n=e.offsetWidth,o=e.offsetHeight,a=r.offsetHeight,s=i.offsetWidth,l=i.offsetHeight,h=t.screen.x-n/2;h=Math.min(Math.max(h,10),this.frame.clientWidth-10-n),r.style.left=t.screen.x+"px",r.style.top=t.screen.y-a+"px",e.style.left=h+"px",e.style.top=t.screen.y-a-o+"px",i.style.left=t.screen.x-s/2+"px",i.style.top=t.screen.y-l/2+"px"},fa.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},fa.prototype.setCameraPosition=function(t){Go(t,this),this.redraw()},fa.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()};export{fa as Graph3d,Oo as Graph3dCamera,ca as Graph3dFilter,mo as Graph3dPoint2d,yo as Graph3dPoint3d,go as Graph3dSlider,xo as Graph3dStepNumber};
//# sourceMappingURL=vis-graph3d.min.js.map
