/**
 * vis-graph3d
 * https://visjs.github.io/vis-graph3d/
 *
 * Create interactive, animated 3d graphs. Surfaces, lines, dots and block styling out of the box.
 *
 * @version 5.9.8
 * @date    2020-06-15T13:24:29.180Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t=t||self).vis=t.vis||{})}(this,(function(t){var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function n(t,e,n){return t(n={path:e,exports:{},require:function(t,e){return i(null==e&&n.path)}},n.exports),n.exports}function r(t){return t&&t.default||t}function i(){throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs")}var o=function(t){return t&&t.Math==Math&&t},a=o("object"==typeof globalThis&&globalThis)||o("object"==typeof window&&window)||o("object"==typeof self&&self)||o("object"==typeof e&&e)||Function("return this")(),s=function(t){try{return!!t()}catch(t){return!0}},l=!s((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),u={}.propertyIsEnumerable,h=Object.getOwnPropertyDescriptor,c={f:h&&!u.call({1:2},1)?function(t){var e=h(this,t);return!!e&&e.enumerable}:u},f=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},d={}.toString,p=function(t){return d.call(t).slice(8,-1)},v="".split,y=s((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==p(t)?v.call(t,""):Object(t)}:Object,m=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},g=function(t){return y(m(t))},_=function(t){return"object"==typeof t?null!==t:"function"==typeof t},w=function(t,e){if(!_(t))return t;var n,r;if(e&&"function"==typeof(n=t.toString)&&!_(r=n.call(t)))return r;if("function"==typeof(n=t.valueOf)&&!_(r=n.call(t)))return r;if(!e&&"function"==typeof(n=t.toString)&&!_(r=n.call(t)))return r;throw TypeError("Can't convert object to primitive value")},b={}.hasOwnProperty,x=function(t,e){return b.call(t,e)},S=a.document,k=_(S)&&_(S.createElement),D=function(t){return k?S.createElement(t):{}},M=!l&&!s((function(){return 7!=Object.defineProperty(D("div"),"a",{get:function(){return 7}}).a})),O=Object.getOwnPropertyDescriptor,T={f:l?O:function(t,e){if(t=g(t),e=w(e,!0),M)try{return O(t,e)}catch(t){}if(x(t,e))return f(!c.f.call(t,e),t[e])}},C=/#|\.prototype\./,L=function(t,e){var n=A[P(t)];return n==Y||n!=E&&("function"==typeof e?s(e):!!e)},P=L.normalize=function(t){return String(t).replace(C,".").toLowerCase()},A=L.data={},E=L.NATIVE="N",Y=L.POLYFILL="P",R=L,I={},N=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},j=function(t,e,n){if(N(t),void 0===e)return t;switch(n){case 0:return function(){return t.call(e)};case 1:return function(n){return t.call(e,n)};case 2:return function(n,r){return t.call(e,n,r)};case 3:return function(n,r,i){return t.call(e,n,r,i)}}return function(){return t.apply(e,arguments)}},z=function(t){if(!_(t))throw TypeError(String(t)+" is not an object");return t},W=Object.defineProperty,F={f:l?W:function(t,e,n){if(z(t),e=w(e,!0),z(n),M)try{return W(t,e,n)}catch(t){}if("get"in n||"set"in n)throw TypeError("Accessors not supported");return"value"in n&&(t[e]=n.value),t}},G=l?function(t,e,n){return F.f(t,e,f(1,n))}:function(t,e,n){return t[e]=n,t},U=T.f,V=function(t){var e=function(e,n,r){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,n)}return new t(e,n,r)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},B=function(t,e){var n,r,i,o,s,l,u,h,c=t.target,f=t.global,d=t.stat,p=t.proto,v=f?a:d?a[c]:(a[c]||{}).prototype,y=f?I:I[c]||(I[c]={}),m=y.prototype;for(i in e)n=!R(f?i:c+(d?".":"#")+i,t.forced)&&v&&x(v,i),s=y[i],n&&(l=t.noTargetGet?(h=U(v,i))&&h.value:v[i]),o=n&&l?l:e[i],n&&typeof s==typeof o||(u=t.bind&&n?j(o,a):t.wrap&&n?V(o):p&&"function"==typeof o?j(Function.call,o):o,(t.sham||o&&o.sham||s&&s.sham)&&G(u,"sham",!0),y[i]=u,p&&(x(I,r=c+"Prototype")||G(I,r,{}),I[r][i]=o,t.real&&m&&!m[i]&&G(m,i,o)))},H=Math.ceil,Z=Math.floor,X=function(t){return isNaN(t=+t)?0:(t>0?Z:H)(t)},q=Math.min,$=function(t){return t>0?q(X(t),9007199254740991):0},J=Math.max,Q=Math.min,K=function(t,e){var n=X(t);return n<0?J(n+e,0):Q(n,e)},tt=function(t){return function(e,n,r){var i,o=g(e),a=$(o.length),s=K(r,a);if(t&&n!=n){for(;a>s;)if((i=o[s++])!=i)return!0}else for(;a>s;s++)if((t||s in o)&&o[s]===n)return t||s||0;return!t&&-1}},et={includes:tt(!0),indexOf:tt(!1)},nt={},rt=et.indexOf,it=function(t,e){var n,r=g(t),i=0,o=[];for(n in r)!x(nt,n)&&x(r,n)&&o.push(n);for(;e.length>i;)x(r,n=e[i++])&&(~rt(o,n)||o.push(n));return o},ot=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],at=Object.keys||function(t){return it(t,ot)},st={f:Object.getOwnPropertySymbols},lt=function(t){return Object(m(t))},ut=Object.assign,ht=Object.defineProperty,ct=!ut||s((function(){if(l&&1!==ut({b:1},ut(ht({},"a",{enumerable:!0,get:function(){ht(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},n=Symbol();return t[n]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=ut({},t)[n]||"abcdefghijklmnopqrst"!=at(ut({},e)).join("")}))?function(t,e){for(var n=lt(t),r=arguments.length,i=1,o=st.f,a=c.f;r>i;)for(var s,u=y(arguments[i++]),h=o?at(u).concat(o(u)):at(u),f=h.length,d=0;f>d;)s=h[d++],l&&!a.call(u,s)||(n[s]=u[s]);return n}:ut;B({target:"Object",stat:!0,forced:Object.assign!==ct},{assign:ct});var ft=I.Object.assign,dt=function(t){return"function"==typeof t?t:void 0},pt=function(t,e){return arguments.length<2?dt(I[t])||dt(a[t]):I[t]&&I[t][e]||a[t]&&a[t][e]},vt=pt("navigator","userAgent")||"",yt=[].slice,mt=/MSIE .\./.test(vt),gt=function(t){return function(e,n){var r=arguments.length>2,i=r?yt.call(arguments,2):void 0;return t(r?function(){("function"==typeof e?e:Function(e)).apply(this,i)}:e,n)}};B({global:!0,bind:!0,forced:mt},{setTimeout:gt(a.setTimeout),setInterval:gt(a.setInterval)});var _t,wt,bt=I.setTimeout,xt=Array.isArray||function(t){return"Array"==p(t)},St=function(t,e,n){var r=w(e);r in t?F.f(t,r,f(0,n)):t[r]=n},kt=a["__core-js_shared__"]||function(t,e){try{G(a,t,e)}catch(n){a[t]=e}return e}("__core-js_shared__",{}),Dt=n((function(t){(t.exports=function(t,e){return kt[t]||(kt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),Mt=0,Ot=Math.random(),Tt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++Mt+Ot).toString(36)},Ct=!!Object.getOwnPropertySymbols&&!s((function(){return!String(Symbol())})),Lt=Ct&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Pt=Dt("wks"),At=a.Symbol,Et=Lt?At:At&&At.withoutSetter||Tt,Yt=function(t){return x(Pt,t)||(Ct&&x(At,t)?Pt[t]=At[t]:Pt[t]=Et("Symbol."+t)),Pt[t]},Rt=Yt("species"),It=function(t,e){var n;return xt(t)&&("function"!=typeof(n=t.constructor)||n!==Array&&!xt(n.prototype)?_(n)&&null===(n=n[Rt])&&(n=void 0):n=void 0),new(void 0===n?Array:n)(0===e?0:e)},Nt=a.process,jt=Nt&&Nt.versions,zt=jt&&jt.v8;zt?wt=(_t=zt.split("."))[0]+_t[1]:vt&&(!(_t=vt.match(/Edge\/(\d+)/))||_t[1]>=74)&&(_t=vt.match(/Chrome\/(\d+)/))&&(wt=_t[1]);var Wt=wt&&+wt,Ft=Yt("species"),Gt=function(t){return Wt>=51||!s((function(){var e=[];return(e.constructor={})[Ft]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Ut=Yt("isConcatSpreadable"),Vt=Wt>=51||!s((function(){var t=[];return t[Ut]=!1,t.concat()[0]!==t})),Bt=Gt("concat"),Ht=function(t){if(!_(t))return!1;var e=t[Ut];return void 0!==e?!!e:xt(t)};B({target:"Array",proto:!0,forced:!Vt||!Bt},{concat:function(t){var e,n,r,i,o,a=lt(this),s=It(a,0),l=0;for(e=-1,r=arguments.length;e<r;e++)if(Ht(o=-1===e?a:arguments[e])){if(l+(i=$(o.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(n=0;n<i;n++,l++)n in o&&St(s,l,o[n])}else{if(l>=9007199254740991)throw TypeError("Maximum allowed index exceeded");St(s,l++,o)}return s.length=l,s}});var Zt=function(t){return I[t+"Prototype"]},Xt=Zt("Array").concat,qt=Array.prototype,$t=function(t){var e=t.concat;return t===qt||t instanceof Array&&e===qt.concat?Xt:e};B({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var Jt=I.Number.isNaN;B({target:"Array",stat:!0},{isArray:xt});var Qt=I.Array.isArray,Kt=Qt,te={f:Yt},ee=F.f,ne=function(t){var e=I.Symbol||(I.Symbol={});x(e,t)||ee(e,t,{value:te.f(t)})};ne("iterator");var re=function(t){return function(e,n){var r,i,o=String(m(e)),a=X(n),s=o.length;return a<0||a>=s?t?"":void 0:(r=o.charCodeAt(a))<55296||r>56319||a+1===s||(i=o.charCodeAt(a+1))<56320||i>57343?t?o.charAt(a):r:t?o.slice(a,a+2):i-56320+(r-55296<<10)+65536}},ie={codeAt:re(!1),charAt:re(!0)},oe=Function.toString;"function"!=typeof kt.inspectSource&&(kt.inspectSource=function(t){return oe.call(t)});var ae,se,le,ue=kt.inspectSource,he=a.WeakMap,ce="function"==typeof he&&/native code/.test(ue(he)),fe=Dt("keys"),de=function(t){return fe[t]||(fe[t]=Tt(t))},pe=a.WeakMap;if(ce){var ve=new pe,ye=ve.get,me=ve.has,ge=ve.set;ae=function(t,e){return ge.call(ve,t,e),e},se=function(t){return ye.call(ve,t)||{}},le=function(t){return me.call(ve,t)}}else{var _e=de("state");nt[_e]=!0,ae=function(t,e){return G(t,_e,e),e},se=function(t){return x(t,_e)?t[_e]:{}},le=function(t){return x(t,_e)}}var we,be,xe,Se={set:ae,get:se,has:le,enforce:function(t){return le(t)?se(t):ae(t,{})},getterFor:function(t){return function(e){var n;if(!_(e)||(n=se(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return n}}},ke=!s((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),De=de("IE_PROTO"),Me=Object.prototype,Oe=ke?Object.getPrototypeOf:function(t){return t=lt(t),x(t,De)?t[De]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?Me:null},Te=(Yt("iterator"),!1);[].keys&&("next"in(xe=[].keys())?(be=Oe(Oe(xe)))!==Object.prototype&&(we=be):Te=!0),null==we&&(we={});var Ce,Le={IteratorPrototype:we,BUGGY_SAFARI_ITERATORS:Te},Pe=l?Object.defineProperties:function(t,e){z(t);for(var n,r=at(e),i=r.length,o=0;i>o;)F.f(t,n=r[o++],e[n]);return t},Ae=pt("document","documentElement"),Ee=de("IE_PROTO"),Ye=function(){},Re=function(t){return"<script>"+t+"<\/script>"},Ie=function(){try{Ce=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;Ie=Ce?function(t){t.write(Re("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Ce):((e=D("iframe")).style.display="none",Ae.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(Re("document.F=Object")),t.close(),t.F);for(var n=ot.length;n--;)delete Ie.prototype[ot[n]];return Ie()};nt[Ee]=!0;var Ne=Object.create||function(t,e){var n;return null!==t?(Ye.prototype=z(t),n=new Ye,Ye.prototype=null,n[Ee]=t):n=Ie(),void 0===e?n:Pe(n,e)},je={};je[Yt("toStringTag")]="z";var ze="[object z]"===String(je),We=Yt("toStringTag"),Fe="Arguments"==p(function(){return arguments}()),Ge=ze?p:function(t){var e,n,r;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(n=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),We))?n:Fe?p(e):"Object"==(r=p(e))&&"function"==typeof e.callee?"Arguments":r},Ue=ze?{}.toString:function(){return"[object "+Ge(this)+"]"},Ve=F.f,Be=Yt("toStringTag"),He=function(t,e,n,r){if(t){var i=n?t:t.prototype;x(i,Be)||Ve(i,Be,{configurable:!0,value:e}),r&&!ze&&G(i,"toString",Ue)}},Ze={},Xe=Le.IteratorPrototype,qe=function(){return this},$e=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,n={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(n,[]),e=n instanceof Array}catch(t){}return function(n,r){return z(n),function(t){if(!_(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(r),e?t.call(n,r):n.__proto__=r,n}}():void 0),Je=function(t,e,n,r){r&&r.enumerable?t[e]=n:G(t,e,n)},Qe=Le.IteratorPrototype,Ke=Le.BUGGY_SAFARI_ITERATORS,tn=Yt("iterator"),en=function(){return this},nn=function(t,e,n,r,i,o,a){!function(t,e,n){var r=e+" Iterator";t.prototype=Ne(Xe,{next:f(1,n)}),He(t,r,!1,!0),Ze[r]=qe}(n,e,r);var s,l,u,h=function(t){if(t===i&&y)return y;if(!Ke&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new n(this,t)}}return function(){return new n(this)}},c=e+" Iterator",d=!1,p=t.prototype,v=p[tn]||p["@@iterator"]||i&&p[i],y=!Ke&&v||h(i),m="Array"==e&&p.entries||v;if(m&&(s=Oe(m.call(new t)),Qe!==Object.prototype&&s.next&&(He(s,c,!0,!0),Ze[c]=en)),"values"==i&&v&&"values"!==v.name&&(d=!0,y=function(){return v.call(this)}),a&&p[tn]!==y&&G(p,tn,y),Ze[e]=y,i)if(l={values:h("values"),keys:o?y:h("keys"),entries:h("entries")},a)for(u in l)(Ke||d||!(u in p))&&Je(p,u,l[u]);else B({target:e,proto:!0,forced:Ke||d},l);return l},rn=ie.charAt,on=Se.set,an=Se.getterFor("String Iterator");nn(String,"String",(function(t){on(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=an(this),n=e.string,r=e.index;return r>=n.length?{value:void 0,done:!0}:(t=rn(n,r),e.index+=t.length,{value:t,done:!1})}));var sn=Se.set,ln=Se.getterFor("Array Iterator");nn(Array,"Array",(function(t,e){sn(this,{type:"Array Iterator",target:g(t),index:0,kind:e})}),(function(){var t=ln(this),e=t.target,n=t.kind,r=t.index++;return!e||r>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==n?{value:r,done:!1}:"values"==n?{value:e[r],done:!1}:{value:[r,e[r]],done:!1}}),"values");Ze.Arguments=Ze.Array;var un=Yt("toStringTag");for(var hn in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var cn=a[hn],fn=cn&&cn.prototype;fn&&Ge(fn)!==un&&G(fn,un,hn),Ze[hn]=Ze.Array}var dn=te.f("iterator"),pn=dn,vn=Object.freeze({__proto__:null}),yn=ot.concat("length","prototype"),mn={f:Object.getOwnPropertyNames||function(t){return it(t,yn)}},gn=mn.f,_n={}.toString,wn="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],bn={f:function(t){return wn&&"[object Window]"==_n.call(t)?function(t){try{return gn(t)}catch(t){return wn.slice()}}(t):gn(g(t))}},xn=[].push,Sn=function(t){var e=1==t,n=2==t,r=3==t,i=4==t,o=6==t,a=5==t||o;return function(s,l,u,h){for(var c,f,d=lt(s),p=y(d),v=j(l,u,3),m=$(p.length),g=0,_=h||It,w=e?_(s,m):n?_(s,0):void 0;m>g;g++)if((a||g in p)&&(f=v(c=p[g],g,d),t))if(e)w[g]=f;else if(f)switch(t){case 3:return!0;case 5:return c;case 6:return g;case 2:xn.call(w,c)}else if(i)return!1;return o?-1:r||i?i:w}},kn={forEach:Sn(0),map:Sn(1),filter:Sn(2),some:Sn(3),every:Sn(4),find:Sn(5),findIndex:Sn(6)},Dn=kn.forEach,Mn=de("hidden"),On=Yt("toPrimitive"),Tn=Se.set,Cn=Se.getterFor("Symbol"),Ln=Object.prototype,Pn=a.Symbol,An=pt("JSON","stringify"),En=T.f,Yn=F.f,Rn=bn.f,In=c.f,Nn=Dt("symbols"),jn=Dt("op-symbols"),zn=Dt("string-to-symbol-registry"),Wn=Dt("symbol-to-string-registry"),Fn=Dt("wks"),Gn=a.QObject,Un=!Gn||!Gn.prototype||!Gn.prototype.findChild,Vn=l&&s((function(){return 7!=Ne(Yn({},"a",{get:function(){return Yn(this,"a",{value:7}).a}})).a}))?function(t,e,n){var r=En(Ln,e);r&&delete Ln[e],Yn(t,e,n),r&&t!==Ln&&Yn(Ln,e,r)}:Yn,Bn=function(t,e){var n=Nn[t]=Ne(Pn.prototype);return Tn(n,{type:"Symbol",tag:t,description:e}),l||(n.description=e),n},Hn=Lt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Pn},Zn=function(t,e,n){t===Ln&&Zn(jn,e,n),z(t);var r=w(e,!0);return z(n),x(Nn,r)?(n.enumerable?(x(t,Mn)&&t[Mn][r]&&(t[Mn][r]=!1),n=Ne(n,{enumerable:f(0,!1)})):(x(t,Mn)||Yn(t,Mn,f(1,{})),t[Mn][r]=!0),Vn(t,r,n)):Yn(t,r,n)},Xn=function(t,e){z(t);var n=g(e),r=at(n).concat(Qn(n));return Dn(r,(function(e){l&&!qn.call(n,e)||Zn(t,e,n[e])})),t},qn=function(t){var e=w(t,!0),n=In.call(this,e);return!(this===Ln&&x(Nn,e)&&!x(jn,e))&&(!(n||!x(this,e)||!x(Nn,e)||x(this,Mn)&&this[Mn][e])||n)},$n=function(t,e){var n=g(t),r=w(e,!0);if(n!==Ln||!x(Nn,r)||x(jn,r)){var i=En(n,r);return!i||!x(Nn,r)||x(n,Mn)&&n[Mn][r]||(i.enumerable=!0),i}},Jn=function(t){var e=Rn(g(t)),n=[];return Dn(e,(function(t){x(Nn,t)||x(nt,t)||n.push(t)})),n},Qn=function(t){var e=t===Ln,n=Rn(e?jn:g(t)),r=[];return Dn(n,(function(t){!x(Nn,t)||e&&!x(Ln,t)||r.push(Nn[t])})),r};if(Ct||(Je((Pn=function(){if(this instanceof Pn)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Tt(t),n=function(t){this===Ln&&n.call(jn,t),x(this,Mn)&&x(this[Mn],e)&&(this[Mn][e]=!1),Vn(this,e,f(1,t))};return l&&Un&&Vn(Ln,e,{configurable:!0,set:n}),Bn(e,t)}).prototype,"toString",(function(){return Cn(this).tag})),Je(Pn,"withoutSetter",(function(t){return Bn(Tt(t),t)})),c.f=qn,F.f=Zn,T.f=$n,mn.f=bn.f=Jn,st.f=Qn,te.f=function(t){return Bn(Yt(t),t)},l&&Yn(Pn.prototype,"description",{configurable:!0,get:function(){return Cn(this).description}})),B({global:!0,wrap:!0,forced:!Ct,sham:!Ct},{Symbol:Pn}),Dn(at(Fn),(function(t){ne(t)})),B({target:"Symbol",stat:!0,forced:!Ct},{for:function(t){var e=String(t);if(x(zn,e))return zn[e];var n=Pn(e);return zn[e]=n,Wn[n]=e,n},keyFor:function(t){if(!Hn(t))throw TypeError(t+" is not a symbol");if(x(Wn,t))return Wn[t]},useSetter:function(){Un=!0},useSimple:function(){Un=!1}}),B({target:"Object",stat:!0,forced:!Ct,sham:!l},{create:function(t,e){return void 0===e?Ne(t):Xn(Ne(t),e)},defineProperty:Zn,defineProperties:Xn,getOwnPropertyDescriptor:$n}),B({target:"Object",stat:!0,forced:!Ct},{getOwnPropertyNames:Jn,getOwnPropertySymbols:Qn}),B({target:"Object",stat:!0,forced:s((function(){st.f(1)}))},{getOwnPropertySymbols:function(t){return st.f(lt(t))}}),An){var Kn=!Ct||s((function(){var t=Pn();return"[null]"!=An([t])||"{}"!=An({a:t})||"{}"!=An(Object(t))}));B({target:"JSON",stat:!0,forced:Kn},{stringify:function(t,e,n){for(var r,i=[t],o=1;arguments.length>o;)i.push(arguments[o++]);if(r=e,(_(e)||void 0!==t)&&!Hn(t))return xt(e)||(e=function(t,e){if("function"==typeof r&&(e=r.call(this,t,e)),!Hn(e))return e}),i[1]=e,An.apply(null,i)}})}Pn.prototype[On]||G(Pn.prototype,On,Pn.prototype.valueOf),He(Pn,"Symbol"),nt[Mn]=!0,ne("asyncIterator");var tr=Object.freeze({__proto__:null});ne("hasInstance"),ne("isConcatSpreadable"),ne("match"),ne("matchAll"),ne("replace"),ne("search"),ne("species"),ne("split"),ne("toPrimitive"),ne("toStringTag"),ne("unscopables"),He(Math,"Math",!0),He(a.JSON,"JSON",!0),r(vn),r(tr);var er=I.Symbol;ne("asyncDispose"),ne("dispose"),ne("observable"),ne("patternMatch"),ne("replaceAll");var nr=er,rr=n((function(t){function e(n){return t.exports=e="function"==typeof nr&&"symbol"==typeof pn?function(t){return typeof t}:function(t){return t&&"function"==typeof nr&&t.constructor===nr&&t!==nr.prototype?"symbol":typeof t},e(n)}t.exports=e})),ir=function(t,e){var n=[][t];return!!n&&s((function(){n.call(null,e||function(){throw 1},1)}))},or=Object.defineProperty,ar={},sr=function(t){throw t},lr=function(t,e){if(x(ar,t))return ar[t];e||(e={});var n=[][t],r=!!x(e,"ACCESSORS")&&e.ACCESSORS,i=x(e,0)?e[0]:sr,o=x(e,1)?e[1]:void 0;return ar[t]=!!n&&!s((function(){if(r&&!l)return!0;var t={length:-1};r?or(t,1,{enumerable:!0,get:sr}):t[1]=1,n.call(t,i,o)}))},ur=kn.forEach,hr=ir("forEach"),cr=lr("forEach"),fr=hr&&cr?[].forEach:function(t){return ur(this,t,arguments.length>1?arguments[1]:void 0)};B({target:"Array",proto:!0,forced:[].forEach!=fr},{forEach:fr});var dr=Zt("Array").forEach,pr=Array.prototype,vr={DOMTokenList:!0,NodeList:!0},yr=function(t){var e=t.forEach;return t===pr||t instanceof Array&&e===pr.forEach||vr.hasOwnProperty(Ge(t))?dr:e},mr=Zt("Array").values,gr=Array.prototype,_r={DOMTokenList:!0,NodeList:!0},wr=function(t){var e=t.values;return t===gr||t instanceof Array&&e===gr.values||_r.hasOwnProperty(Ge(t))?mr:e};B({target:"Array",proto:!0},{fill:function(t){for(var e=lt(this),n=$(e.length),r=arguments.length,i=K(r>1?arguments[1]:void 0,n),o=r>2?arguments[2]:void 0,a=void 0===o?n:K(o,n);a>i;)e[i++]=t;return e}});var br=Zt("Array").fill,xr=Array.prototype,Sr=function(t){var e=t.fill;return t===xr||t instanceof Array&&e===xr.fill?br:e},kr="\t\n\v\f\r                　\u2028\u2029\ufeff",Dr="["+kr+"]",Mr=RegExp("^"+Dr+Dr+"*"),Or=RegExp(Dr+Dr+"*$"),Tr=function(t){return function(e){var n=String(m(e));return 1&t&&(n=n.replace(Mr,"")),2&t&&(n=n.replace(Or,"")),n}},Cr={start:Tr(1),end:Tr(2),trim:Tr(3)},Lr=Cr.trim,Pr=a.parseFloat,Ar=1/Pr(kr+"-0")!=-1/0?function(t){var e=Lr(String(t)),n=Pr(e);return 0===n&&"-"==e.charAt(0)?-0:n}:Pr;B({global:!0,forced:parseFloat!=Ar},{parseFloat:Ar});var Er=I.parseFloat,Yr=kn.filter,Rr=Gt("filter"),Ir=lr("filter");B({target:"Array",proto:!0,forced:!Rr||!Ir},{filter:function(t){return Yr(this,t,arguments.length>1?arguments[1]:void 0)}});var Nr=Zt("Array").filter,jr=Array.prototype,zr=function(t){var e=t.filter;return t===jr||t instanceof Array&&e===jr.filter?Nr:e},Wr=et.indexOf,Fr=[].indexOf,Gr=!!Fr&&1/[1].indexOf(1,-0)<0,Ur=ir("indexOf"),Vr=lr("indexOf",{ACCESSORS:!0,1:0});B({target:"Array",proto:!0,forced:Gr||!Ur||!Vr},{indexOf:function(t){return Gr?Fr.apply(this,arguments)||0:Wr(this,t,arguments.length>1?arguments[1]:void 0)}});var Br=Zt("Array").indexOf,Hr=Array.prototype,Zr=function(t){var e=t.indexOf;return t===Hr||t instanceof Array&&e===Hr.indexOf?Br:e},Xr=[],qr=Xr.sort,$r=s((function(){Xr.sort(void 0)})),Jr=s((function(){Xr.sort(null)})),Qr=ir("sort");B({target:"Array",proto:!0,forced:$r||!Jr||!Qr},{sort:function(t){return void 0===t?qr.call(lt(this)):qr.call(lt(this),N(t))}});var Kr=Zt("Array").sort,ti=Array.prototype,ei=function(t){var e=t.sort;return t===ti||t instanceof Array&&e===ti.sort?Kr:e},ni=n((function(t){function e(t){if(t)return function(t){for(var n in e.prototype)t[n]=e.prototype[n];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function n(){this.off(t,n),e.apply(this,arguments)}return n.fn=e,this.on(t,n),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var n,r=this._callbacks["$"+t];if(!r)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i=0;i<r.length;i++)if((n=r[i])===e||n.fn===e){r.splice(i,1);break}return 0===r.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),n=this._callbacks["$"+t],r=1;r<arguments.length;r++)e[r-1]=arguments[r];if(n){r=0;for(var i=(n=n.slice(0)).length;r<i;++r)n[r].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}));B({target:"Object",stat:!0,forced:!l,sham:!l},{defineProperty:F.f});var ri=n((function(t){var e=I.Object,n=t.exports=function(t,n,r){return e.defineProperty(t,n,r)};e.defineProperty.sham&&(n.sham=!0)})),ii=ri;B({target:"Object",stat:!0,forced:!l,sham:!l},{defineProperties:Pe});var oi=n((function(t){var e=I.Object,n=t.exports=function(t,n){return e.defineProperties(t,n)};e.defineProperties.sham&&(n.sham=!0)})),ai=pt("Reflect","ownKeys")||function(t){var e=mn.f(z(t)),n=st.f;return n?e.concat(n(t)):e};B({target:"Object",stat:!0,sham:!l},{getOwnPropertyDescriptors:function(t){for(var e,n,r=g(t),i=T.f,o=ai(r),a={},s=0;o.length>s;)void 0!==(n=i(r,e=o[s++]))&&St(a,e,n);return a}});var si=I.Object.getOwnPropertyDescriptors,li=T.f,ui=s((function(){li(1)}));B({target:"Object",stat:!0,forced:!l||ui,sham:!l},{getOwnPropertyDescriptor:function(t,e){return li(g(t),e)}});var hi=n((function(t){var e=I.Object,n=t.exports=function(t,n){return e.getOwnPropertyDescriptor(t,n)};e.getOwnPropertyDescriptor.sham&&(n.sham=!0)})),ci=I.Object.getOwnPropertySymbols,fi=Yt("iterator"),di=function(t){if(null!=t)return t[fi]||t["@@iterator"]||Ze[Ge(t)]},pi=function(t){var e=di(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return z(e.call(t))},vi=di,yi=function(t,e,n,r){try{return r?e(z(n)[0],n[1]):e(n)}catch(e){var i=t.return;throw void 0!==i&&z(i.call(t)),e}},mi=Yt("iterator"),gi=Array.prototype,_i=function(t){return void 0!==t&&(Ze.Array===t||gi[mi]===t)},wi=Yt("iterator"),bi=!1;try{var xi=0,Si={next:function(){return{done:!!xi++}},return:function(){bi=!0}};Si[wi]=function(){return this},Array.from(Si,(function(){throw 2}))}catch(t){}var ki=!function(t,e){if(!e&&!bi)return!1;var n=!1;try{var r={};r[wi]=function(){return{next:function(){return{done:n=!0}}}},t(r)}catch(t){}return n}((function(t){Array.from(t)}));B({target:"Array",stat:!0,forced:ki},{from:function(t){var e,n,r,i,o,a,s=lt(t),l="function"==typeof this?this:Array,u=arguments.length,h=u>1?arguments[1]:void 0,c=void 0!==h,f=di(s),d=0;if(c&&(h=j(h,u>2?arguments[2]:void 0,2)),null==f||l==Array&&_i(f))for(n=new l(e=$(s.length));e>d;d++)a=c?h(s[d],d):s[d],St(n,d,a);else for(o=(i=f.call(s)).next,n=new l;!(r=o.call(i)).done;d++)a=c?yi(i,h,[r.value,d],!0):r.value,St(n,d,a);return n.length=d,n}});var Di=I.Array.from,Mi=Di;B({target:"Object",stat:!0,sham:!l},{create:Ne});var Oi=I.Object,Ti=function(t,e){return Oi.create(t,e)},Ci=Ti,Li=ri;var Pi,Ai=function(t,e,n){return e in t?Li(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}):t[e]=n,t},Ei=Cr.trim;B({target:"String",proto:!0,forced:(Pi="trim",s((function(){return!!kr[Pi]()||"​᠎"!="​᠎"[Pi]()||kr[Pi].name!==Pi})))},{trim:function(){return Ei(this)}});Zt("String").trim;var Yi=Cr.trim,Ri=a.parseInt,Ii=/^[+-]?0[Xx]/,Ni=8!==Ri(kr+"08")||22!==Ri(kr+"0x16")?function(t,e){var n=Yi(String(t));return Ri(n,e>>>0||(Ii.test(n)?16:10))}:Ri;B({global:!0,forced:parseInt!=Ni},{parseInt:Ni});var ji=I.parseInt,zi=c.f,Wi=function(t){return function(e){for(var n,r=g(e),i=at(r),o=i.length,a=0,s=[];o>a;)n=i[a++],l&&!zi.call(r,n)||s.push(t?[n,r[n]]:r[n]);return s}},Fi={entries:Wi(!0),values:Wi(!1)}.values;B({target:"Object",stat:!0},{values:function(t){return Fi(t)}});I.Object.values;var Gi=s((function(){Oe(1)}));B({target:"Object",stat:!0,forced:Gi,sham:!ke},{getPrototypeOf:function(t){return Oe(lt(t))}});var Ui=I.Object.getPrototypeOf,Vi=Ui,Bi=Qt;var Hi=function(t){if(Bi(t))return t},Zi=Yt("iterator"),Xi=function(t){var e=Object(t);return void 0!==e[Zi]||"@@iterator"in e||Ze.hasOwnProperty(Ge(e))};var qi=function(t,e){if(void 0!==nr&&Xi(Object(t))){var n=[],r=!0,i=!1,o=void 0;try{for(var a,s=pi(t);!(r=(a=s.next()).done)&&(n.push(a.value),!e||n.length!==e);r=!0);}catch(t){i=!0,o=t}finally{try{r||null==s.return||s.return()}finally{if(i)throw o}}return n}},$i=Di,Ji=Gt("slice"),Qi=lr("slice",{ACCESSORS:!0,0:0,1:2}),Ki=Yt("species"),to=[].slice,eo=Math.max;B({target:"Array",proto:!0,forced:!Ji||!Qi},{slice:function(t,e){var n,r,i,o=g(this),a=$(o.length),s=K(t,a),l=K(void 0===e?a:e,a);if(xt(o)&&("function"!=typeof(n=o.constructor)||n!==Array&&!xt(n.prototype)?_(n)&&null===(n=n[Ki])&&(n=void 0):n=void 0,n===Array||void 0===n))return to.call(o,s,l);for(r=new(void 0===n?Array:n)(eo(l-s,0)),i=0;s<l;s++,i++)s in o&&St(r,i,o[s]);return r.length=i,r}});var no=Zt("Array").slice,ro=Array.prototype,io=function(t){var e=t.slice;return t===ro||t instanceof Array&&e===ro.slice?no:e},oo=io;var ao=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,r=new Array(e);n<e;n++)r[n]=t[n];return r};var so=function(t,e){var n;if(t){if("string"==typeof t)return ao(t,e);var r=oo(n=Object.prototype.toString.call(t)).call(n,8,-1);return"Object"===r&&t.constructor&&(r=t.constructor.name),"Map"===r||"Set"===r?$i(t):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?ao(t,e):void 0}};var lo=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var uo=function(t,e){return Hi(t)||qi(t,e)||so(t,e)||lo()};B({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});I.Date.now;var ho=s((function(){at(1)}));B({target:"Object",stat:!0,forced:ho},{keys:function(t){return at(lt(t))}});var co=I.Object.keys,fo=kn.map,po=Gt("map"),vo=lr("map");B({target:"Array",proto:!0,forced:!po||!vo},{map:function(t){return fo(this,t,arguments.length>1?arguments[1]:void 0)}});var yo=Zt("Array").map,mo=Array.prototype,go=function(t){var e=t.map;return t===mo||t instanceof Array&&e===mo.map?yo:e};B({target:"Reflect",stat:!0},{ownKeys:ai});var _o=I.Reflect.ownKeys,wo=io;var bo=function(t){if(Bi(t))return ao(t)};var xo=function(t){if(void 0!==nr&&Xi(Object(t)))return $i(t)};var So=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var ko=function(t){return bo(t)||xo(t)||so(t)||So()},Do=er;function Mo(t,e){var n;if(void 0===Do||null==vi(t)){if(Kt(t)||(n=function(t,e){var n;if(!t)return;if("string"==typeof t)return Oo(t,e);var r=wo(n=Object.prototype.toString.call(t)).call(n,8,-1);"Object"===r&&t.constructor&&(r=t.constructor.name);if("Map"===r||"Set"===r)return Mi(t);if("Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r))return Oo(t,e)}(t))||e&&t&&"number"==typeof t.length){n&&(t=n);var r=0,i=function(){};return{s:i,n:function(){return r>=t.length?{done:!0}:{done:!1,value:t[r++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){n=pi(t)},n:function(){var t=n.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==n.return||n.return()}finally{if(s)throw o}}}}function Oo(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,r=new Array(e);n<e;n++)r[n]=t[n];return r}
/**
	 * vis-util
	 * https://github.com/visjs/vis-util
	 *
	 * utilitie collection for visjs
	 *
	 * @version 4.3.1
	 * @date    2020-06-15T12:58:12.015Z
	 *
	 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
	 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
	 *
	 * @license
	 * vis.js is dual licensed under both
	 *
	 *   1. The Apache 2.0 License
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 *   and
	 *
	 *   2. The MIT License
	 *      http://opensource.org/licenses/MIT
	 *
	 * vis.js may be distributed under either license.
	 */var To=Do("DELETE");function Co(){var t=Lo.apply(void 0,arguments);return Ao(t),console.log(t),t}function Lo(){for(var t=arguments.length,e=new Array(t),n=0;n<t;n++)e[n]=arguments[n];if(e.length<2)return e[0];var r;if(e.length>2)return Lo.apply(void 0,$t(r=[Co(e[0],e[1])]).call(r,ko(wo(e).call(e,2))));var i,o=e[0],a=e[1],s=Mo(_o(a));try{for(s.s();!(i=s.n()).done;){var l=i.value;Object.prototype.propertyIsEnumerable.call(a,a[l])||(a[l]===To?delete o[l]:null===o[l]||null===a[l]||"object"!==rr(o[l])||"object"!==rr(a[l])||Kt(o[l])||Kt(a[l])?o[l]=Po(a[l]):o[l]=Lo(o[l],a[l]))}}catch(t){s.e(t)}finally{s.f()}return o}function Po(t){return Kt(t)?go(t).call(t,(function(t){return Po(t)})):"object"===rr(t)&&null!==t?Lo({},t):t}function Ao(t){for(var e=0,n=co(t);e<n.length;e++){var r=n[e];t[r]===To?delete t[r]:"object"===rr(t[r])&&null!==t[r]&&Ao(t[r])}}var Eo=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Yo=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;function Ro(t){return t instanceof Number||"number"==typeof t}function Io(t){return t instanceof String||"string"==typeof t}function No(t,e,n,r){var i=!1;!0===r&&(i=null===e[n]&&void 0!==t[n]),i?delete t[n]:t[n]=e[n]}function jo(t,e){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)||!0===n)if("object"===rr(e[i])&&null!==e[i]&&Vi(e[i])===Object.prototype)void 0===t[i]?t[i]=jo({},e[i],n):"object"===rr(t[i])&&null!==t[i]&&Vi(t[i])===Object.prototype?jo(t[i],e[i],n):No(t,e,i,r);else if(Kt(e[i])){var o;t[i]=wo(o=e[i]).call(o)}else No(t,e,i,r);return t}function zo(t){var e=rr(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Kt(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}function Wo(t,e){var n;return $t(n=[]).call(n,ko(t),[e])}function Fo(t){return wo(t).call(t)}function Go(t,e,n,r){var i;t.addEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Zr(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,n,r)):t.attachEvent("on"+e,n)}function Uo(t,e,n,r){var i;t.removeEventListener?(void 0===r&&(r=!1),"mousewheel"===e&&Zr(i=navigator.userAgent).call(i,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,n,r)):t.detachEvent("on"+e,n)}function Vo(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)}function Bo(t,e,n){var r,i,o,a=Math.floor(6*t),s=6*t-a,l=n*(1-e),u=n*(1-s*e),h=n*(1-(1-s)*e);switch(a%6){case 0:r=n,i=h,o=l;break;case 1:r=u,i=n,o=l;break;case 2:r=l,i=n,o=h;break;case 3:r=l,i=u,o=n;break;case 4:r=h,i=l,o=n;break;case 5:r=n,i=l,o=u}return{r:Math.floor(255*r),g:Math.floor(255*i),b:Math.floor(255*o)}}function Ho(t,e,n){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0,this.z=void 0!==n?n:0}Ho.subtract=function(t,e){var n=new Ho;return n.x=t.x-e.x,n.y=t.y-e.y,n.z=t.z-e.z,n},Ho.add=function(t,e){var n=new Ho;return n.x=t.x+e.x,n.y=t.y+e.y,n.z=t.z+e.z,n},Ho.avg=function(t,e){return new Ho((t.x+e.x)/2,(t.y+e.y)/2,(t.z+e.z)/2)},Ho.scalarProduct=function(t,e){return new Ho(t.x*e,t.y*e,t.z*e)},Ho.dotProduct=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},Ho.crossProduct=function(t,e){var n=new Ho;return n.x=t.y*e.z-t.z*e.y,n.y=t.z*e.x-t.x*e.z,n.z=t.x*e.y-t.y*e.x,n},Ho.prototype.length=function(){return Math.sqrt(this.x*this.x+this.y*this.y+this.z*this.z)},Ho.prototype.normalize=function(){return Ho.scalarProduct(this,1/this.length())};var Zo=Ho;var Xo=function(t,e){this.x=void 0!==t?t:0,this.y=void 0!==e?e:0};function qo(t,e){if(void 0===t)throw new Error("No container element defined");if(this.container=t,this.visible=!e||null==e.visible||e.visible,this.visible){this.frame=document.createElement("DIV"),this.frame.style.width="100%",this.frame.style.position="relative",this.container.appendChild(this.frame),this.frame.prev=document.createElement("INPUT"),this.frame.prev.type="BUTTON",this.frame.prev.value="Prev",this.frame.appendChild(this.frame.prev),this.frame.play=document.createElement("INPUT"),this.frame.play.type="BUTTON",this.frame.play.value="Play",this.frame.appendChild(this.frame.play),this.frame.next=document.createElement("INPUT"),this.frame.next.type="BUTTON",this.frame.next.value="Next",this.frame.appendChild(this.frame.next),this.frame.bar=document.createElement("INPUT"),this.frame.bar.type="BUTTON",this.frame.bar.style.position="absolute",this.frame.bar.style.border="1px solid red",this.frame.bar.style.width="100px",this.frame.bar.style.height="6px",this.frame.bar.style.borderRadius="2px",this.frame.bar.style.MozBorderRadius="2px",this.frame.bar.style.border="1px solid #7F7F7F",this.frame.bar.style.backgroundColor="#E5E5E5",this.frame.appendChild(this.frame.bar),this.frame.slide=document.createElement("INPUT"),this.frame.slide.type="BUTTON",this.frame.slide.style.margin="0px",this.frame.slide.value=" ",this.frame.slide.style.position="relative",this.frame.slide.style.left="-100px",this.frame.appendChild(this.frame.slide);var n=this;this.frame.slide.onmousedown=function(t){n._onMouseDown(t)},this.frame.prev.onclick=function(t){n.prev(t)},this.frame.play.onclick=function(t){n.togglePlay(t)},this.frame.next.onclick=function(t){n.next(t)}}this.onChangeCallback=void 0,this.values=[],this.index=void 0,this.playTimeout=void 0,this.playInterval=1e3,this.playLoop=!0}function $o(t,e,n,r){this._start=0,this._end=0,this._step=1,this.prettyStep=!0,this.precision=5,this._current=0,this.setRange(t,e,n,r)}qo.prototype.prev=function(){var t=this.getIndex();t>0&&(t--,this.setIndex(t))},qo.prototype.next=function(){var t=this.getIndex();t<wr(this).length-1&&(t++,this.setIndex(t))},qo.prototype.playNext=function(){var t=new Date,e=this.getIndex();e<wr(this).length-1?(e++,this.setIndex(e)):this.playLoop&&(e=0,this.setIndex(e));var n=new Date-t,r=Math.max(this.playInterval-n,0),i=this;this.playTimeout=bt((function(){i.playNext()}),r)},qo.prototype.togglePlay=function(){void 0===this.playTimeout?this.play():this.stop()},qo.prototype.play=function(){this.playTimeout||(this.playNext(),this.frame&&(this.frame.play.value="Stop"))},qo.prototype.stop=function(){clearInterval(this.playTimeout),this.playTimeout=void 0,this.frame&&(this.frame.play.value="Play")},qo.prototype.setOnChangeCallback=function(t){this.onChangeCallback=t},qo.prototype.setPlayInterval=function(t){this.playInterval=t},qo.prototype.getPlayInterval=function(){return this.playInterval},qo.prototype.setPlayLoop=function(t){this.playLoop=t},qo.prototype.onChange=function(){void 0!==this.onChangeCallback&&this.onChangeCallback()},qo.prototype.redraw=function(){if(this.frame){this.frame.bar.style.top=this.frame.clientHeight/2-this.frame.bar.offsetHeight/2+"px",this.frame.bar.style.width=this.frame.clientWidth-this.frame.prev.clientWidth-this.frame.play.clientWidth-this.frame.next.clientWidth-30+"px";var t=this.indexToLeft(this.index);this.frame.slide.style.left=t+"px"}},qo.prototype.setValues=function(t){this.values=t,wr(this).length>0?this.setIndex(0):this.index=void 0},qo.prototype.setIndex=function(t){if(!(t<wr(this).length))throw new Error("Index out of range");this.index=t,this.redraw(),this.onChange()},qo.prototype.getIndex=function(){return this.index},qo.prototype.get=function(){return wr(this)[this.index]},qo.prototype._onMouseDown=function(t){if(t.which?1===t.which:1===t.button){this.startClientX=t.clientX,this.startSlideX=Er(this.frame.slide.style.left),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Go(document,"mousemove",this.onmousemove),Go(document,"mouseup",this.onmouseup),Vo(t)}},qo.prototype.leftToIndex=function(t){var e=Er(this.frame.bar.style.width)-this.frame.slide.clientWidth-10,n=t-3,r=Math.round(n/e*(wr(this).length-1));return r<0&&(r=0),r>wr(this).length-1&&(r=wr(this).length-1),r},qo.prototype.indexToLeft=function(t){var e=Er(this.frame.bar.style.width)-this.frame.slide.clientWidth-10;return t/(wr(this).length-1)*e+3},qo.prototype._onMouseMove=function(t){var e=t.clientX-this.startClientX,n=this.startSlideX+e,r=this.leftToIndex(n);this.setIndex(r),Vo()},qo.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",Uo(document,"mousemove",this.onmousemove),Uo(document,"mouseup",this.onmouseup),Vo()},$o.prototype.isNumeric=function(t){return!isNaN(Er(t))&&isFinite(t)},$o.prototype.setRange=function(t,e,n,r){if(!this.isNumeric(t))throw new Error("Parameter 'start' is not numeric; value: "+t);if(!this.isNumeric(e))throw new Error("Parameter 'end' is not numeric; value: "+t);if(!this.isNumeric(n))throw new Error("Parameter 'step' is not numeric; value: "+t);this._start=t||0,this._end=e||0,this.setStep(n,r)},$o.prototype.setStep=function(t,e){void 0===t||t<=0||(void 0!==e&&(this.prettyStep=e),!0===this.prettyStep?this._step=$o.calculatePrettyStep(t):this._step=t)},$o.calculatePrettyStep=function(t){var e=function(t){return Math.log(t)/Math.LN10},n=Math.pow(10,Math.round(e(t))),r=2*Math.pow(10,Math.round(e(t/2))),i=5*Math.pow(10,Math.round(e(t/5))),o=n;return Math.abs(r-t)<=Math.abs(o-t)&&(o=r),Math.abs(i-t)<=Math.abs(o-t)&&(o=i),o<=0&&(o=1),o},$o.prototype.getCurrent=function(){return Er(this._current.toPrecision(this.precision))},$o.prototype.getStep=function(){return this._step},$o.prototype.start=function(t){void 0===t&&(t=!1),this._current=this._start-this._start%this._step,t&&this.getCurrent()<this._start&&this.next()},$o.prototype.next=function(){this._current+=this._step},$o.prototype.end=function(){return this._current>this._end};var Jo=$o,Qo=[].reverse,Ko=[1,2];B({target:"Array",proto:!0,forced:String(Ko)===String(Ko.reverse())},{reverse:function(){return xt(this)&&(this.length=this.length),Qo.call(this)}});var ta=Zt("Array").reverse,ea=Array.prototype,na=function(t){var e=t.reverse;return t===ea||t instanceof Array&&e===ea.reverse?ta:e},ra=Math.sign||function(t){return 0==(t=+t)||t!=t?t:t<0?-1:1};B({target:"Math",stat:!0},{sign:ra});var ia=I.Math.sign;function oa(){this.armLocation=new Zo,this.armRotation={},this.armRotation.horizontal=0,this.armRotation.vertical=0,this.armLength=1.7,this.cameraOffset=new Zo,this.offsetMultiplier=.6,this.cameraLocation=new Zo,this.cameraRotation=new Zo(.5*Math.PI,0,0),this.calculateCameraOrientation()}oa.prototype.setOffset=function(t,e){var n=Math.abs,r=ia,i=this.offsetMultiplier,o=this.armLength*i;n(t)>o&&(t=r(t)*o),n(e)>o&&(e=r(e)*o),this.cameraOffset.x=t,this.cameraOffset.y=e,this.calculateCameraOrientation()},oa.prototype.getOffset=function(){return this.cameraOffset},oa.prototype.setArmLocation=function(t,e,n){this.armLocation.x=t,this.armLocation.y=e,this.armLocation.z=n,this.calculateCameraOrientation()},oa.prototype.setArmRotation=function(t,e){void 0!==t&&(this.armRotation.horizontal=t),void 0!==e&&(this.armRotation.vertical=e,this.armRotation.vertical<0&&(this.armRotation.vertical=0),this.armRotation.vertical>.5*Math.PI&&(this.armRotation.vertical=.5*Math.PI)),void 0===t&&void 0===e||this.calculateCameraOrientation()},oa.prototype.getArmRotation=function(){var t={};return t.horizontal=this.armRotation.horizontal,t.vertical=this.armRotation.vertical,t},oa.prototype.setArmLength=function(t){void 0!==t&&(this.armLength=t,this.armLength<.71&&(this.armLength=.71),this.armLength>5&&(this.armLength=5),this.setOffset(this.cameraOffset.x,this.cameraOffset.y),this.calculateCameraOrientation())},oa.prototype.getArmLength=function(){return this.armLength},oa.prototype.getCameraLocation=function(){return this.cameraLocation},oa.prototype.getCameraRotation=function(){return this.cameraRotation},oa.prototype.calculateCameraOrientation=function(){this.cameraLocation.x=this.armLocation.x-this.armLength*Math.sin(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.y=this.armLocation.y-this.armLength*Math.cos(this.armRotation.horizontal)*Math.cos(this.armRotation.vertical),this.cameraLocation.z=this.armLocation.z+this.armLength*Math.sin(this.armRotation.vertical),this.cameraRotation.x=Math.PI/2-this.armRotation.vertical,this.cameraRotation.y=0,this.cameraRotation.z=-this.armRotation.horizontal;var t=this.cameraRotation.x,e=this.cameraRotation.z,n=this.cameraOffset.x,r=this.cameraOffset.y,i=Math.sin,o=Math.cos;this.cameraLocation.x=this.cameraLocation.x+n*o(e)+r*-i(e)*o(t),this.cameraLocation.y=this.cameraLocation.y+n*i(e)+r*o(e)*o(t),this.cameraLocation.z=this.cameraLocation.z+r*i(t)};var aa={BAR:0,BARCOLOR:1,BARSIZE:2,DOT:3,DOTLINE:4,DOTCOLOR:5,DOTSIZE:6,GRID:7,LINE:8,SURFACE:9},sa={dot:aa.DOT,"dot-line":aa.DOTLINE,"dot-color":aa.DOTCOLOR,"dot-size":aa.DOTSIZE,line:aa.LINE,grid:aa.GRID,surface:aa.SURFACE,bar:aa.BAR,"bar-color":aa.BARCOLOR,"bar-size":aa.BARSIZE},la=["width","height","filterLabel","legendLabel","xLabel","yLabel","zLabel","xValueLabel","yValueLabel","zValueLabel","showXAxis","showYAxis","showZAxis","showGrayBottom","showGrid","showPerspective","showShadow","showSurfaceGrid","keepAspectRatio","rotateAxisLabels","verticalRatio","dotSizeRatio","dotSizeMinFraction","dotSizeMaxFraction","showAnimationControls","animationInterval","animationPreload","animationAutoStart","axisColor","axisFontSize","axisFontType","gridColor","xCenter","yCenter","zoomable","tooltipDelay","ctrlToZoom"],ua=["xBarWidth","yBarWidth","valueMin","valueMax","xMin","xMax","xStep","yMin","yMax","yStep","zMin","zMax","zStep"],ha=void 0;function ca(t){for(var e in t)if(t.hasOwnProperty(e))return!1;return!0}function fa(t,e){return void 0===t||""===t?e:t+(void 0===(n=e)||""===n||"string"!=typeof n?n:n.charAt(0).toUpperCase()+wo(n).call(n,1));var n}function da(t,e,n,r){for(var i,o=0;o<n.length;++o)e[fa(r,i=n[o])]=t[i]}function pa(t,e,n,r){for(var i,o=0;o<n.length;++o)void 0!==t[i=n[o]]&&(e[fa(r,i)]=t[i])}function va(t,e){if(void 0!==t.backgroundColor&&function(t,e){var n="white",r="gray",i=1;if("string"==typeof t)n=t,r="none",i=0;else{if("object"!==rr(t))throw new Error("Unsupported type of backgroundColor");void 0!==Sr(t)&&(n=Sr(t)),void 0!==t.stroke&&(r=t.stroke),void 0!==t.strokeWidth&&(i=t.strokeWidth)}e.frame.style.backgroundColor=n,e.frame.style.borderColor=r,e.frame.style.borderWidth=i+"px",e.frame.style.borderStyle="solid"}(t.backgroundColor,e),function(t,e){if(void 0===t)return;void 0===e.dataColor&&(e.dataColor={});"string"==typeof t?(e.dataColor.fill=t,e.dataColor.stroke=t):(Sr(t)&&(e.dataColor.fill=Sr(t)),t.stroke&&(e.dataColor.stroke=t.stroke),void 0!==t.strokeWidth&&(e.dataColor.strokeWidth=t.strokeWidth))}(t.dataColor,e),function(t,e){if(void 0===t)return;var n;if("string"==typeof t){if(-1===(n=function(t){var e=sa[t];if(void 0===e)return-1;return e}(t)))throw new Error("Style '"+t+"' is invalid")}else{if(!function(t){var e=!1;for(var n in aa)if(aa[n]===t){e=!0;break}return e}(t))throw new Error("Style '"+t+"' is invalid");n=t}e.style=n}(t.style,e),void 0!==t.surfaceColors){if(console.warn("`options.surfaceColors` is deprecated and may be removed in a future version. Please use `options.colormap` instead. Note that the `colormap` option uses the inverse array ordering (running from vMin to vMax)."),void 0!==t.colormap)throw new Error("The `colormap` and `surfaceColors` options are mutually exclusive.");"surface"!==e.style?console.warn("Ignoring `surfaceColors` in graph style `"+e.style+"` for backward compatibility (only effective in `surface` plots)."):function(t,e){if(void 0===t||!0===t)return;if(!1===t)return void(e.surfaceColors=void 0);void 0===e.surfaceColors&&(e.surfaceColors={});var n;if(Kt(t))n=ya(t);else{if("object"!==rr(t))throw new Error("Unsupported type of surfaceColors");n=ma(t.hue)}na(n).call(n),e.colormap=n}(t.surfaceColors,e)}else!function(t,e){if(void 0===t)return;var n;if(Kt(t))n=ya(t);else if("object"===rr(t))n=ma(t.hue);else{if("function"!=typeof t)throw new Error("Unsupported type of colormap");n=t}e.colormap=n}(t.colormap,e);!function(t,e){if(void 0===t){if(void 0===ha.showLegend){var n=e.style===aa.DOTCOLOR||e.style===aa.DOTSIZE;e.showLegend=n}}else e.showLegend=t}(t.showLegend,e),ga(t.cameraPosition,e),void 0!==t.tooltip&&(e.showTooltip=t.tooltip),null!=t.onclick&&(e.onclick_callback=t.onclick,console.warn("`options.onclick` is deprecated and may be removed in a future version. Please use `Graph3d.on('click', handler)` instead.")),void 0!==t.tooltipStyle&&function(t,e,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Kt(n))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<t.length;i++){var o=t[i];if(Object.prototype.hasOwnProperty.call(n,o))if(n[o]&&n[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?jo(e[o],n[o],!1,r):No(e,n,o,r);else{if(Kt(n[o]))throw new TypeError("Arrays are not supported by deepExtend");No(e,n,o,r)}}}(["tooltipStyle"],e,t)}function ya(t){if(t.length<2)throw new Error("Colormap array length must be 2 or above.");return go(t).call(t,(function(t){if(!function(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}(t))throw new Error("Invalid hex color code supplied to colormap.");return function(t){var e;switch(t.length){case 3:case 4:return(e=Yo.exec(t))?{r:ji(e[1]+e[1],16),g:ji(e[2]+e[2],16),b:ji(e[3]+e[3],16)}:null;case 6:case 7:return(e=Eo.exec(t))?{r:ji(e[1],16),g:ji(e[2],16),b:ji(e[3],16)}:null;default:return null}}(t)}))}function ma(t){if(void 0===t)throw new Error("Unsupported type of colormap");if(!(t.saturation>=0&&t.saturation<=100))throw new Error("Saturation is out of bounds. Expected range is 0-100.");if(!(t.brightness>=0&&t.brightness<=100))throw new Error("Brightness is out of bounds. Expected range is 0-100.");if(!(t.colorStops>=2))throw new Error("colorStops is out of bounds. Expected 2 or above.");for(var e=(t.end-t.start)/(t.colorStops-1),n=[],r=0;r<t.colorStops;++r){var i=(t.start+e*r)%360/360;n.push(Bo(i<0?i+1:i,t.saturation/100,t.brightness/100))}return n}function ga(t,e){var n=t;void 0!==n&&(void 0===e.camera&&(e.camera=new oa),e.camera.setArmRotation(n.horizontal,n.vertical),e.camera.setArmLength(n.distance))}var _a=pt("JSON","stringify"),wa=/[\uD800-\uDFFF]/g,ba=/^[\uD800-\uDBFF]$/,xa=/^[\uDC00-\uDFFF]$/,Sa=function(t,e,n){var r=n.charAt(e-1),i=n.charAt(e+1);return ba.test(t)&&!xa.test(i)||xa.test(t)&&!ba.test(r)?"\\u"+t.charCodeAt(0).toString(16):t},ka=s((function(){return'"\\udf06\\ud834"'!==_a("\udf06\ud834")||'"\\udead"'!==_a("\udead")}));_a&&B({target:"JSON",stat:!0,forced:ka},{stringify:function(t,e,n){var r=_a.apply(null,arguments);return"string"==typeof r?r.replace(wa,Sa):r}}),I.JSON||(I.JSON={stringify:JSON.stringify});var Da=function(t,e,n){return I.JSON.stringify.apply(null,arguments)};var Ma=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function Oa(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Li(t,r.key,r)}}var Ta,Ca=function(t,e,n){return e&&Oa(t.prototype,e),n&&Oa(t,n),t},La=!1,Pa="background: #FFeeee; color: #dd0000",Aa=function(){function t(){Ma(this,t)}return Ca(t,null,[{key:"validate",value:function(e,n,r){La=!1,Ta=n;var i=n;return void 0!==r&&(i=n[r]),t.parse(e,i,[]),La}},{key:"parse",value:function(e,n,r){for(var i in e)e.hasOwnProperty(i)&&t.check(i,e,n,r)}},{key:"check",value:function(e,n,r,i){if(void 0!==r[e]||void 0!==r.__any__){var o=e,a=!0;void 0===r[e]&&void 0!==r.__any__&&(o="__any__",a="object"===t.getType(n[e]));var s=r[o];a&&void 0!==s.__type__&&(s=s.__type__),t.checkFields(e,n,r,o,s,i)}else t.getSuggestion(e,r,i)}},{key:"checkFields",value:function(e,n,r,i,o,a){var s=function(n){console.log("%c"+n+t.printLocation(a,e),Pa)},l=t.getType(n[e]),u=o[l];void 0!==u?"array"===t.getType(u)&&-1===Zr(u).call(u,n[e])?(s('Invalid option detected in "'+e+'". Allowed values are:'+t.print(u)+' not "'+n[e]+'". '),La=!0):"object"===l&&"__any__"!==i&&(a=Wo(a,e),t.parse(n[e],r[i],a)):void 0===o.any&&(s('Invalid type received for "'+e+'". Expected: '+t.print(co(o))+". Received ["+l+'] "'+n[e]+'"'),La=!0)}},{key:"getType",value:function(t){var e=rr(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Kt(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,n,r){var i,o=t.findInOptions(e,n,r,!1),a=t.findInOptions(e,Ta,[],!0);i=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':a.distance<=4&&o.distance>a.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(a.path,a.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(co(n))+t.printLocation(r,e),console.log('%cUnknown option detected: "'+e+'"'+i,Pa),La=!0}},{key:"findInOptions",value:function(e,n,r){var i=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,a="",s=[],l=e.toLowerCase(),u=void 0;for(var h in n){var c=void 0;if(void 0!==n[h].__type__&&!0===i){var f=t.findInOptions(e,n[h],Wo(r,h));o>f.distance&&(a=f.closestMatch,s=f.path,o=f.distance,u=f.indexMatch)}else{var d;-1!==Zr(d=h.toLowerCase()).call(d,l)&&(u=h),o>(c=t.levenshteinDistance(e,h))&&(a=h,s=Fo(r),o=c)}}return{closestMatch:a,path:s,distance:o,indexMatch:u}}},{key:"printLocation",value:function(t,e){for(var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",r="\n\n"+n+"options = {\n",i=0;i<t.length;i++){for(var o=0;o<i+1;o++)r+="  ";r+=t[i]+": {\n"}for(var a=0;a<t.length+1;a++)r+="  ";r+=e+"\n";for(var s=0;s<t.length+1;s++){for(var l=0;l<t.length-s;l++)r+="  ";r+="}\n"}return r+"\n\n"}},{key:"print",value:function(t){return Da(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var n,r,i=[];for(n=0;n<=e.length;n++)i[n]=[n];for(r=0;r<=t.length;r++)i[0][r]=r;for(n=1;n<=e.length;n++)for(r=1;r<=t.length;r++)e.charAt(n-1)==t.charAt(r-1)?i[n][r]=i[n-1][r-1]:i[n][r]=Math.min(i[n-1][r-1]+1,Math.min(i[n][r-1]+1,i[n-1][r]+1));return i[e.length][t.length]}}]),t}(),Ea="string",Ya="boolean",Ra="number",Ia="object",Na={fill:{string:Ea},stroke:{string:Ea},strokeWidth:{number:Ra},__type__:{string:Ea,object:Ia,undefined:"undefined"}},ja={animationAutoStart:{boolean:Ya,undefined:"undefined"},animationInterval:{number:Ra},animationPreload:{boolean:Ya},axisColor:{string:Ea},axisFontSize:{number:Ra},axisFontType:{string:Ea},backgroundColor:Na,xBarWidth:{number:Ra,undefined:"undefined"},yBarWidth:{number:Ra,undefined:"undefined"},cameraPosition:{distance:{number:Ra},horizontal:{number:Ra},vertical:{number:Ra},__type__:{object:Ia}},zoomable:{boolean:Ya},ctrlToZoom:{boolean:Ya},xCenter:{string:Ea},yCenter:{string:Ea},colormap:{hue:{start:{number:Ra},end:{number:Ra},saturation:{number:Ra},brightness:{number:Ra},colorStops:{number:Ra},__type__:{object:Ia}},__type__:{array:"array",object:Ia,function:"function",undefined:"undefined"}},dataColor:Na,dotSizeMinFraction:{number:Ra},dotSizeMaxFraction:{number:Ra},dotSizeRatio:{number:Ra},filterLabel:{string:Ea},gridColor:{string:Ea},onclick:{function:"function"},keepAspectRatio:{boolean:Ya},xLabel:{string:Ea},yLabel:{string:Ea},zLabel:{string:Ea},legendLabel:{string:Ea},xMin:{number:Ra,undefined:"undefined"},yMin:{number:Ra,undefined:"undefined"},zMin:{number:Ra,undefined:"undefined"},xMax:{number:Ra,undefined:"undefined"},yMax:{number:Ra,undefined:"undefined"},zMax:{number:Ra,undefined:"undefined"},showAnimationControls:{boolean:Ya,undefined:"undefined"},showGrayBottom:{boolean:Ya},showGrid:{boolean:Ya},showLegend:{boolean:Ya,undefined:"undefined"},showPerspective:{boolean:Ya},showShadow:{boolean:Ya},showSurfaceGrid:{boolean:Ya},showXAxis:{boolean:Ya},showYAxis:{boolean:Ya},showZAxis:{boolean:Ya},rotateAxisLabels:{boolean:Ya},surfaceColors:{hue:{start:{number:Ra},end:{number:Ra},saturation:{number:Ra},brightness:{number:Ra},colorStops:{number:Ra},__type__:{object:Ia}},__type__:{boolean:Ya,array:"array",object:Ia,undefined:"undefined"}},xStep:{number:Ra,undefined:"undefined"},yStep:{number:Ra,undefined:"undefined"},zStep:{number:Ra,undefined:"undefined"},style:{number:Ra,string:["bar","bar-color","bar-size","dot","dot-line","dot-color","dot-size","line","grid","surface"]},tooltip:{boolean:Ya,function:"function"},tooltipDelay:{number:Ra},tooltipStyle:{content:{color:{string:Ea},background:{string:Ea},border:{string:Ea},borderRadius:{string:Ea},boxShadow:{string:Ea},padding:{string:Ea},__type__:{object:Ia}},line:{borderLeft:{string:Ea},height:{string:Ea},width:{string:Ea},pointerEvents:{string:Ea},__type__:{object:Ia}},dot:{border:{string:Ea},borderRadius:{string:Ea},height:{string:Ea},width:{string:Ea},pointerEvents:{string:Ea},__type__:{object:Ia}},__type__:{object:Ia}},xValueLabel:{function:"function"},yValueLabel:{function:"function"},zValueLabel:{function:"function"},valueMax:{number:Ra,undefined:"undefined"},valueMin:{number:Ra,undefined:"undefined"},verticalRatio:{number:Ra},height:{string:Ea},width:{string:Ea},__type__:{object:Ia}};var za=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t},Wa=[].slice,Fa={},Ga=function(t,e,n){if(!(e in Fa)){for(var r=[],i=0;i<e;i++)r[i]="a["+i+"]";Fa[e]=Function("C,a","return new C("+r.join(",")+")")}return Fa[e](t,n)},Ua=Function.bind||function(t){var e=N(this),n=Wa.call(arguments,1),r=function(){var i=n.concat(Wa.call(arguments));return this instanceof r?Ga(e,i.length,i):e.apply(t,i)};return _(e.prototype)&&(r.prototype=e.prototype),r},Va=pt("Reflect","construct"),Ba=s((function(){function t(){}return!(Va((function(){}),[],t)instanceof t)})),Ha=!s((function(){Va((function(){}))})),Za=Ba||Ha;B({target:"Reflect",stat:!0,forced:Za,sham:Za},{construct:function(t,e){N(t),z(e);var n=arguments.length<3?t:N(arguments[2]);if(Ha&&!Ba)return Va(t,e,n);if(t==n){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var r=[null];return r.push.apply(r,e),new(Ua.apply(t,r))}var i=n.prototype,o=Ne(_(i)?i:Object.prototype),a=Function.apply.call(t,o,e);return _(a)?a:o}});var Xa=I.Reflect.construct,qa=Zt("Array").entries,$a=Array.prototype,Ja={DOMTokenList:!0,NodeList:!0},Qa=function(t){var e=t.entries;return t===$a||t instanceof Array&&e===$a.entries||Ja.hasOwnProperty(Ge(t))?qa:e},Ka=Zt("Array").keys,ts=Array.prototype,es={DOMTokenList:!0,NodeList:!0},ns=function(t){var e=t.keys;return t===ts||t instanceof Array&&e===ts.keys||es.hasOwnProperty(Ge(t))?Ka:e},rs=kn.some,is=ir("some"),os=lr("some");B({target:"Array",proto:!0,forced:!is||!os},{some:function(t){return rs(this,t,arguments.length>1?arguments[1]:void 0)}});var as=Zt("Array").some,ss=Array.prototype,ls=function(t){var e=t.some;return t===ss||t instanceof Array&&e===ss.some?as:e},us=Ti;B({target:"Object",stat:!0},{setPrototypeOf:$e});var hs=I.Object.setPrototypeOf,cs=n((function(t){function e(n,r){return t.exports=e=hs||function(t,e){return t.__proto__=e,t},e(n,r)}t.exports=e}));var fs=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=us(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&cs(t,e)};var ds=function(t,e){return!e||"object"!==rr(e)&&"function"!=typeof e?za(t):e},ps=Ui,vs=n((function(t){function e(n){return t.exports=e=hs?ps:function(t){return t.__proto__||ps(t)},e(n)}t.exports=e})),ys=!s((function(){return Object.isExtensible(Object.preventExtensions({}))})),ms=n((function(t){var e=F.f,n=Tt("meta"),r=0,i=Object.isExtensible||function(){return!0},o=function(t){e(t,n,{value:{objectID:"O"+ ++r,weakData:{}}})},a=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!_(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!x(t,n)){if(!i(t))return"F";if(!e)return"E";o(t)}return t[n].objectID},getWeakData:function(t,e){if(!x(t,n)){if(!i(t))return!0;if(!e)return!1;o(t)}return t[n].weakData},onFreeze:function(t){return ys&&a.REQUIRED&&i(t)&&!x(t,n)&&o(t),t}};nt[n]=!0})),gs=n((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,n,r,i,o){var a,s,l,u,h,c,f,d=j(n,r,i?2:1);if(o)a=t;else{if("function"!=typeof(s=di(t)))throw TypeError("Target is not iterable");if(_i(s)){for(l=0,u=$(t.length);u>l;l++)if((h=i?d(z(f=t[l])[0],f[1]):d(t[l]))&&h instanceof e)return h;return new e(!1)}a=s.call(t)}for(c=a.next;!(f=c.call(a)).done;)if("object"==typeof(h=yi(a,d,f.value,i))&&h&&h instanceof e)return h;return new e(!1)}).stop=function(t){return new e(!0,t)}})),_s=function(t,e,n){if(!(t instanceof e))throw TypeError("Incorrect "+(n?n+" ":"")+"invocation");return t},ws=F.f,bs=kn.forEach,xs=Se.set,Ss=Se.getterFor,ks=function(t,e,n){var r,i=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),u=i?"set":"add",h=a[t],c=h&&h.prototype,f={};if(l&&"function"==typeof h&&(o||c.forEach&&!s((function(){(new h).entries().next()})))){r=e((function(e,n){xs(_s(e,r,t),{type:t,collection:new h}),null!=n&&gs(n,e[u],e,i)}));var d=Ss(t);bs(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;!(t in c)||o&&"clear"==t||G(r.prototype,t,(function(n,r){var i=d(this).collection;if(!e&&o&&!_(n))return"get"==t&&void 0;var a=i[t](0===n?0:n,r);return e?this:a}))})),o||ws(r.prototype,"size",{configurable:!0,get:function(){return d(this).collection.size}})}else r=n.getConstructor(e,t,i,u),ms.REQUIRED=!0;return He(r,t,!1,!0),f[t]=r,B({global:!0,forced:!0},f),o||n.setStrong(r,t,i),r},Ds=function(t,e,n){for(var r in e)n&&n.unsafe&&t[r]?t[r]=e[r]:Je(t,r,e[r],n);return t},Ms=Yt("species"),Os=F.f,Ts=ms.fastKey,Cs=Se.set,Ls=Se.getterFor,Ps={getConstructor:function(t,e,n,r){var i=t((function(t,o){_s(t,i,e),Cs(t,{type:e,index:Ne(null),first:void 0,last:void 0,size:0}),l||(t.size=0),null!=o&&gs(o,t[r],t,n)})),o=Ls(e),a=function(t,e,n){var r,i,a=o(t),u=s(t,e);return u?u.value=n:(a.last=u={index:i=Ts(e,!0),key:e,value:n,previous:r=a.last,next:void 0,removed:!1},a.first||(a.first=u),r&&(r.next=u),l?a.size++:t.size++,"F"!==i&&(a.index[i]=u)),t},s=function(t,e){var n,r=o(t),i=Ts(e);if("F"!==i)return r.index[i];for(n=r.first;n;n=n.next)if(n.key==e)return n};return Ds(i.prototype,{clear:function(){for(var t=o(this),e=t.index,n=t.first;n;)n.removed=!0,n.previous&&(n.previous=n.previous.next=void 0),delete e[n.index],n=n.next;t.first=t.last=void 0,l?t.size=0:this.size=0},delete:function(t){var e=o(this),n=s(this,t);if(n){var r=n.next,i=n.previous;delete e.index[n.index],n.removed=!0,i&&(i.next=r),r&&(r.previous=i),e.first==n&&(e.first=r),e.last==n&&(e.last=i),l?e.size--:this.size--}return!!n},forEach:function(t){for(var e,n=o(this),r=j(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:n.first;)for(r(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!s(this,t)}}),Ds(i.prototype,n?{get:function(t){var e=s(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),l&&Os(i.prototype,"size",{get:function(){return o(this).size}}),i},setStrong:function(t,e,n){var r=e+" Iterator",i=Ls(e),o=Ls(r);nn(t,e,(function(t,e){Cs(this,{type:r,target:t,state:i(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,n=t.last;n&&n.removed;)n=n.previous;return t.target&&(t.last=n=n?n.next:t.state.first)?"keys"==e?{value:n.key,done:!1}:"values"==e?{value:n.value,done:!1}:{value:[n.key,n.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),n?"entries":"values",!n,!0),function(t){var e=pt(t),n=F.f;l&&e&&!e[Ms]&&n(e,Ms,{configurable:!0,get:function(){return this}})}(e)}},As=(ks("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ps),I.Set),Es=(ks("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),Ps),I.Map),Ys=n((function(t){var e=function(t){var e=Object.prototype,n=e.hasOwnProperty,r="function"==typeof Symbol?Symbol:{},i=r.iterator||"@@iterator",o=r.asyncIterator||"@@asyncIterator",a=r.toStringTag||"@@toStringTag";function s(t,e,n,r){var i=e&&e.prototype instanceof h?e:h,o=Object.create(i.prototype),a=new x(r||[]);return o._invoke=function(t,e,n){var r="suspendedStart";return function(i,o){if("executing"===r)throw new Error("Generator is already running");if("completed"===r){if("throw"===i)throw o;return k()}for(n.method=i,n.arg=o;;){var a=n.delegate;if(a){var s=_(a,n);if(s){if(s===u)continue;return s}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if("suspendedStart"===r)throw r="completed",n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);r="executing";var h=l(t,e,n);if("normal"===h.type){if(r=n.done?"completed":"suspendedYield",h.arg===u)continue;return{value:h.arg,done:n.done}}"throw"===h.type&&(r="completed",n.method="throw",n.arg=h.arg)}}}(t,n,a),o}function l(t,e,n){try{return{type:"normal",arg:t.call(e,n)}}catch(t){return{type:"throw",arg:t}}}t.wrap=s;var u={};function h(){}function c(){}function f(){}var d={};d[i]=function(){return this};var p=Object.getPrototypeOf,v=p&&p(p(S([])));v&&v!==e&&n.call(v,i)&&(d=v);var y=f.prototype=h.prototype=Object.create(d);function m(t){["next","throw","return"].forEach((function(e){t[e]=function(t){return this._invoke(e,t)}}))}function g(t,e){var r;this._invoke=function(i,o){function a(){return new e((function(r,a){!function r(i,o,a,s){var u=l(t[i],t,o);if("throw"!==u.type){var h=u.arg,c=h.value;return c&&"object"==typeof c&&n.call(c,"__await")?e.resolve(c.__await).then((function(t){r("next",t,a,s)}),(function(t){r("throw",t,a,s)})):e.resolve(c).then((function(t){h.value=t,a(h)}),(function(t){return r("throw",t,a,s)}))}s(u.arg)}(i,o,r,a)}))}return r=r?r.then(a,a):a()}}function _(t,e){var n=t.iterator[e.method];if(void 0===n){if(e.delegate=null,"throw"===e.method){if(t.iterator.return&&(e.method="return",e.arg=void 0,_(t,e),"throw"===e.method))return u;e.method="throw",e.arg=new TypeError("The iterator does not provide a 'throw' method")}return u}var r=l(n,t.iterator,e.arg);if("throw"===r.type)return e.method="throw",e.arg=r.arg,e.delegate=null,u;var i=r.arg;return i?i.done?(e[t.resultName]=i.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,u):i:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,u)}function w(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function b(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function x(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(w,this),this.reset(!0)}function S(t){if(t){var e=t[i];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var r=-1,o=function e(){for(;++r<t.length;)if(n.call(t,r))return e.value=t[r],e.done=!1,e;return e.value=void 0,e.done=!0,e};return o.next=o}}return{next:k}}function k(){return{value:void 0,done:!0}}return c.prototype=y.constructor=f,f.constructor=c,f[a]=c.displayName="GeneratorFunction",t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===c||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,f):(t.__proto__=f,a in t||(t[a]="GeneratorFunction")),t.prototype=Object.create(y),t},t.awrap=function(t){return{__await:t}},m(g.prototype),g.prototype[o]=function(){return this},t.AsyncIterator=g,t.async=function(e,n,r,i,o){void 0===o&&(o=Promise);var a=new g(s(e,n,r,i),o);return t.isGeneratorFunction(n)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},m(y),y[a]="Generator",y[i]=function(){return this},y.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var n in t)e.push(n);return e.reverse(),function n(){for(;e.length;){var r=e.pop();if(r in t)return n.value=r,n.done=!1,n}return n.done=!0,n}},t.values=S,x.prototype={constructor:x,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,this.tryEntries.forEach(b),!t)for(var e in this)"t"===e.charAt(0)&&n.call(this,e)&&!isNaN(+e.slice(1))&&(this[e]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function r(n,r){return a.type="throw",a.arg=t,e.next=n,r&&(e.method="next",e.arg=void 0),!!r}for(var i=this.tryEntries.length-1;i>=0;--i){var o=this.tryEntries[i],a=o.completion;if("root"===o.tryLoc)return r("end");if(o.tryLoc<=this.prev){var s=n.call(o,"catchLoc"),l=n.call(o,"finallyLoc");if(s&&l){if(this.prev<o.catchLoc)return r(o.catchLoc,!0);if(this.prev<o.finallyLoc)return r(o.finallyLoc)}else if(s){if(this.prev<o.catchLoc)return r(o.catchLoc,!0)}else{if(!l)throw new Error("try statement without catch or finally");if(this.prev<o.finallyLoc)return r(o.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var i=this.tryEntries[r];if(i.tryLoc<=this.prev&&n.call(i,"finallyLoc")&&this.prev<i.finallyLoc){var o=i;break}}o&&("break"===t||"continue"===t)&&o.tryLoc<=e&&e<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=t,a.arg=e,o?(this.method="next",this.next=o.finallyLoc,u):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),u},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.finallyLoc===t)return this.complete(n.completion,n.afterLoc),b(n),u}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var n=this.tryEntries[e];if(n.tryLoc===t){var r=n.completion;if("throw"===r.type){var i=r.arg;b(n)}return i}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,n){return this.delegate={iterator:S(t),resultName:e,nextLoc:n},"next"===this.method&&(this.arg=void 0),u}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),Rs=dn,Is=Gt("splice"),Ns=lr("splice",{ACCESSORS:!0,0:0,1:2}),js=Math.max,zs=Math.min;B({target:"Array",proto:!0,forced:!Is||!Ns},{splice:function(t,e){var n,r,i,o,a,s,l=lt(this),u=$(l.length),h=K(t,u),c=arguments.length;if(0===c?n=r=0:1===c?(n=0,r=u-h):(n=c-2,r=zs(js(X(e),0),u-h)),u+n-r>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(i=It(l,r),o=0;o<r;o++)(a=h+o)in l&&St(i,o,l[a]);if(i.length=r,n<r){for(o=h;o<u-r;o++)s=o+n,(a=o+r)in l?l[s]=l[a]:delete l[s];for(o=u;o>u-r+n;o--)delete l[o-1]}else if(n>r)for(o=u-r;o>h;o--)s=o+n-1,(a=o+r-1)in l?l[s]=l[a]:delete l[s];for(o=0;o<n;o++)l[o+h]=arguments[o+2];return l.length=u-r+n,i}});var Ws=Zt("Array").splice,Fs=Array.prototype,Gs=function(t){var e=t.splice;return t===Fs||t instanceof Array&&e===Fs.splice?Ws:e},Us=function(t,e,n,r,i,o,a,s){for(var l,u=i,h=0,c=!!a&&j(a,s,3);h<r;){if(h in n){if(l=c?c(n[h],h,e):n[h],o>0&&xt(l))u=Us(t,e,l,$(l.length),u,o-1)-1;else{if(u>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[u]=l}u++}h++}return u},Vs=Us;B({target:"Array",proto:!0},{flatMap:function(t){var e,n=lt(this),r=$(n.length);return N(t),(e=It(n,0)).length=Vs(e,n,n,r,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var Bs=Zt("Array").flatMap,Hs=Array.prototype,Zs=function(t){var e=t.flatMap;return t===Hs||t instanceof Array&&e===Hs.flatMap?Bs:e},Xs=function(t){return function(e,n,r,i){N(n);var o=lt(e),a=y(o),s=$(o.length),l=t?s-1:0,u=t?-1:1;if(r<2)for(;;){if(l in a){i=a[l],l+=u;break}if(l+=u,t?l<0:s<=l)throw TypeError("Reduce of empty array with no initial value")}for(;t?l>=0:s>l;l+=u)l in a&&(i=n(i,a[l],l,o));return i}},qs={left:Xs(!1),right:Xs(!0)}.left,$s=ir("reduce"),Js=lr("reduce",{1:0});B({target:"Array",proto:!0,forced:!$s||!Js},{reduce:function(t){return qs(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Qs=Zt("Array").reduce,Ks=Array.prototype,tl=function(t){var e=t.reduce;return t===Ks||t instanceof Array&&e===Ks.reduce?Qs:e};B({target:"Function",proto:!0},{bind:Ua});var el=Zt("Function").bind,nl=Function.prototype,rl=function(t){var e=t.bind;return t===nl||t instanceof Function&&e===nl.bind?el:e},il="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),ol=new Uint8Array(16);function al(){if(!il)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return il(ol)}for(var sl=[],ll=0;ll<256;++ll)sl.push((ll+256).toString(16).substr(1));function ul(t,e,n){"string"==typeof t&&(e="binary"===t?new Uint8Array(16):null,t=null);var r=(t=t||{}).random||(t.rng||al)();if(r[6]=15&r[6]|64,r[8]=63&r[8]|128,e){for(var i=n||0,o=0;o<16;++o)e[i+o]=r[o];return e}return function(t,e){var n=e||0,r=sl;return(r[t[n+0]]+r[t[n+1]]+r[t[n+2]]+r[t[n+3]]+"-"+r[t[n+4]]+r[t[n+5]]+"-"+r[t[n+6]]+r[t[n+7]]+"-"+r[t[n+8]]+r[t[n+9]]+"-"+r[t[n+10]]+r[t[n+11]]+r[t[n+12]]+r[t[n+13]]+r[t[n+14]]+r[t[n+15]]).toLowerCase()}(r)}var hl=n((function(t,e){t.exports=function(){var e,n;function r(){return e.apply(null,arguments)}function o(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function a(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function s(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function l(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(s(t,e))return!1;return!0}function u(t){return void 0===t}function h(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function c(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function f(t,e){var n,r=[];for(n=0;n<t.length;++n)r.push(e(t[n],n));return r}function d(t,e){for(var n in e)s(e,n)&&(t[n]=e[n]);return s(e,"toString")&&(t.toString=e.toString),s(e,"valueOf")&&(t.valueOf=e.valueOf),t}function p(t,e,n,r){return De(t,e,n,r,!0).utc()}function v(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function y(t){if(null==t._isValid){var e=v(t),r=n.call(e.parsedDateParts,(function(t){return null!=t})),i=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidEra&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&r);if(t._strict&&(i=i&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return i;t._isValid=i}return t._isValid}function m(t){var e=p(NaN);return null!=t?d(v(e),t):v(e).userInvalidated=!0,e}n=Array.prototype.some?Array.prototype.some:function(t){var e,n=Object(this),r=n.length>>>0;for(e=0;e<r;e++)if(e in n&&t.call(this,n[e],e,n))return!0;return!1};var g=r.momentProperties=[],_=!1;function w(t,e){var n,r,i;if(u(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),u(e._i)||(t._i=e._i),u(e._f)||(t._f=e._f),u(e._l)||(t._l=e._l),u(e._strict)||(t._strict=e._strict),u(e._tzm)||(t._tzm=e._tzm),u(e._isUTC)||(t._isUTC=e._isUTC),u(e._offset)||(t._offset=e._offset),u(e._pf)||(t._pf=v(e)),u(e._locale)||(t._locale=e._locale),g.length>0)for(n=0;n<g.length;n++)u(i=e[r=g[n]])||(t[r]=i);return t}function b(t){w(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===_&&(_=!0,r.updateOffset(this),_=!1)}function x(t){return t instanceof b||null!=t&&null!=t._isAMomentObject}function S(t){!1===r.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function k(t,e){var n=!0;return d((function(){if(null!=r.deprecationHandler&&r.deprecationHandler(null,t),n){var i,o,a,l=[];for(o=0;o<arguments.length;o++){if(i="","object"==typeof arguments[o]){for(a in i+="\n["+o+"] ",arguments[0])s(arguments[0],a)&&(i+=a+": "+arguments[0][a]+", ");i=i.slice(0,-2)}else i=arguments[o];l.push(i)}S(t+"\nArguments: "+Array.prototype.slice.call(l).join("")+"\n"+(new Error).stack),n=!1}return e.apply(this,arguments)}),e)}var D,M={};function O(t,e){null!=r.deprecationHandler&&r.deprecationHandler(t,e),M[t]||(S(e),M[t]=!0)}function T(t){return"undefined"!=typeof Function&&t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function C(t,e){var n,r=d({},t);for(n in e)s(e,n)&&(a(t[n])&&a(e[n])?(r[n]={},d(r[n],t[n]),d(r[n],e[n])):null!=e[n]?r[n]=e[n]:delete r[n]);for(n in t)s(t,n)&&!s(e,n)&&a(t[n])&&(r[n]=d({},r[n]));return r}function L(t){null!=t&&this.set(t)}function P(t,e,n){var r=""+Math.abs(t),i=e-r.length;return(t>=0?n?"+":"":"-")+Math.pow(10,Math.max(0,i)).toString().substr(1)+r}r.suppressDeprecationWarnings=!1,r.deprecationHandler=null,D=Object.keys?Object.keys:function(t){var e,n=[];for(e in t)s(t,e)&&n.push(e);return n};var A=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,E=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,Y={},R={};function I(t,e,n,r){var i=r;"string"==typeof r&&(i=function(){return this[r]()}),t&&(R[t]=i),e&&(R[e[0]]=function(){return P(i.apply(this,arguments),e[1],e[2])}),n&&(R[n]=function(){return this.localeData().ordinal(i.apply(this,arguments),t)})}function N(t,e){return t.isValid()?(e=j(e,t.localeData()),Y[e]=Y[e]||function(t){var e,n,r,i=t.match(A);for(e=0,n=i.length;e<n;e++)R[i[e]]?i[e]=R[i[e]]:i[e]=(r=i[e]).match(/\[[\s\S]/)?r.replace(/^\[|\]$/g,""):r.replace(/\\/g,"");return function(e){var r,o="";for(r=0;r<n;r++)o+=T(i[r])?i[r].call(e,t):i[r];return o}}(e),Y[e](t)):t.localeData().invalidDate()}function j(t,e){var n=5;function r(t){return e.longDateFormat(t)||t}for(E.lastIndex=0;n>=0&&E.test(t);)t=t.replace(E,r),E.lastIndex=0,n-=1;return t}var z={};function W(t,e){var n=t.toLowerCase();z[n]=z[n+"s"]=z[e]=t}function F(t){return"string"==typeof t?z[t]||z[t.toLowerCase()]:void 0}function G(t){var e,n,r={};for(n in t)s(t,n)&&(e=F(n))&&(r[e]=t[n]);return r}var U={};function V(t,e){U[t]=e}function B(t){return t%4==0&&t%100!=0||t%400==0}function H(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function Z(t){var e=+t,n=0;return 0!==e&&isFinite(e)&&(n=H(e)),n}function X(t,e){return function(n){return null!=n?($(this,t,n),r.updateOffset(this,e),this):q(this,t)}}function q(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function $(t,e,n){t.isValid()&&!isNaN(n)&&("FullYear"===e&&B(t.year())&&1===t.month()&&29===t.date()?(n=Z(n),t._d["set"+(t._isUTC?"UTC":"")+e](n,t.month(),xt(n,t.month()))):t._d["set"+(t._isUTC?"UTC":"")+e](n))}var J,Q=/\d/,K=/\d\d/,tt=/\d{3}/,et=/\d{4}/,nt=/[+-]?\d{6}/,rt=/\d\d?/,it=/\d\d\d\d?/,ot=/\d\d\d\d\d\d?/,at=/\d{1,3}/,st=/\d{1,4}/,lt=/[+-]?\d{1,6}/,ut=/\d+/,ht=/[+-]?\d+/,ct=/Z|[+-]\d\d:?\d\d/gi,ft=/Z|[+-]\d\d(?::?\d\d)?/gi,dt=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;function pt(t,e,n){J[t]=T(e)?e:function(t,r){return t&&n?n:e}}function vt(t,e){return s(J,t)?J[t](e._strict,e._locale):new RegExp(yt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,n,r,i){return e||n||r||i}))))}function yt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}J={};var mt,gt={};function _t(t,e){var n,r=e;for("string"==typeof t&&(t=[t]),h(e)&&(r=function(t,n){n[e]=Z(t)}),n=0;n<t.length;n++)gt[t[n]]=r}function wt(t,e){_t(t,(function(t,n,r,i){r._w=r._w||{},e(t,r._w,r,i)}))}function bt(t,e,n){null!=e&&s(gt,t)&&gt[t](e,n._a,n,t)}function xt(t,e){if(isNaN(t)||isNaN(e))return NaN;var n,r=(e%(n=12)+n)%n;return t+=(e-r)/12,1===r?B(t)?29:28:31-r%7%2}mt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},I("M",["MM",2],"Mo",(function(){return this.month()+1})),I("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),I("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),W("month","M"),V("month",8),pt("M",rt),pt("MM",rt,K),pt("MMM",(function(t,e){return e.monthsShortRegex(t)})),pt("MMMM",(function(t,e){return e.monthsRegex(t)})),_t(["M","MM"],(function(t,e){e[1]=Z(t)-1})),_t(["MMM","MMMM"],(function(t,e,n,r){var i=n._locale.monthsParse(t,r,n._strict);null!=i?e[1]=i:v(n).invalidMonth=t}));var St="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),kt="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),Dt=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Mt=dt,Ot=dt;function Tt(t,e,n){var r,i,o,a=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],r=0;r<12;++r)o=p([2e3,r]),this._shortMonthsParse[r]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[r]=this.months(o,"").toLocaleLowerCase();return n?"MMM"===e?-1!==(i=mt.call(this._shortMonthsParse,a))?i:null:-1!==(i=mt.call(this._longMonthsParse,a))?i:null:"MMM"===e?-1!==(i=mt.call(this._shortMonthsParse,a))||-1!==(i=mt.call(this._longMonthsParse,a))?i:null:-1!==(i=mt.call(this._longMonthsParse,a))||-1!==(i=mt.call(this._shortMonthsParse,a))?i:null}function Ct(t,e){var n;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=Z(e);else if(!h(e=t.localeData().monthsParse(e)))return t;return n=Math.min(t.date(),xt(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,n),t}function Lt(t){return null!=t?(Ct(this,t),r.updateOffset(this,!0),this):q(this,"Month")}function Pt(){function t(t,e){return e.length-t.length}var e,n,r=[],i=[],o=[];for(e=0;e<12;e++)n=p([2e3,e]),r.push(this.monthsShort(n,"")),i.push(this.months(n,"")),o.push(this.months(n,"")),o.push(this.monthsShort(n,""));for(r.sort(t),i.sort(t),o.sort(t),e=0;e<12;e++)r[e]=yt(r[e]),i[e]=yt(i[e]);for(e=0;e<24;e++)o[e]=yt(o[e]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+i.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+r.join("|")+")","i")}function At(t){return B(t)?366:365}I("Y",0,0,(function(){var t=this.year();return t<=9999?P(t,4):"+"+t})),I(0,["YY",2],0,(function(){return this.year()%100})),I(0,["YYYY",4],0,"year"),I(0,["YYYYY",5],0,"year"),I(0,["YYYYYY",6,!0],0,"year"),W("year","y"),V("year",1),pt("Y",ht),pt("YY",rt,K),pt("YYYY",st,et),pt("YYYYY",lt,nt),pt("YYYYYY",lt,nt),_t(["YYYYY","YYYYYY"],0),_t("YYYY",(function(t,e){e[0]=2===t.length?r.parseTwoDigitYear(t):Z(t)})),_t("YY",(function(t,e){e[0]=r.parseTwoDigitYear(t)})),_t("Y",(function(t,e){e[0]=parseInt(t,10)})),r.parseTwoDigitYear=function(t){return Z(t)+(Z(t)>68?1900:2e3)};var Et=X("FullYear",!0);function Yt(t,e,n,r,i,o,a){var s;return t<100&&t>=0?(s=new Date(t+400,e,n,r,i,o,a),isFinite(s.getFullYear())&&s.setFullYear(t)):s=new Date(t,e,n,r,i,o,a),s}function Rt(t){var e,n;return t<100&&t>=0?((n=Array.prototype.slice.call(arguments))[0]=t+400,e=new Date(Date.UTC.apply(null,n)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)):e=new Date(Date.UTC.apply(null,arguments)),e}function It(t,e,n){var r=7+e-n;return-(7+Rt(t,0,r).getUTCDay()-e)%7+r-1}function Nt(t,e,n,r,i){var o,a,s=1+7*(e-1)+(7+n-r)%7+It(t,r,i);return s<=0?a=At(o=t-1)+s:s>At(t)?(o=t+1,a=s-At(t)):(o=t,a=s),{year:o,dayOfYear:a}}function jt(t,e,n){var r,i,o=It(t.year(),e,n),a=Math.floor((t.dayOfYear()-o-1)/7)+1;return a<1?r=a+zt(i=t.year()-1,e,n):a>zt(t.year(),e,n)?(r=a-zt(t.year(),e,n),i=t.year()+1):(i=t.year(),r=a),{week:r,year:i}}function zt(t,e,n){var r=It(t,e,n),i=It(t+1,e,n);return(At(t)-r+i)/7}function Wt(t,e){return t.slice(e,7).concat(t.slice(0,e))}I("w",["ww",2],"wo","week"),I("W",["WW",2],"Wo","isoWeek"),W("week","w"),W("isoWeek","W"),V("week",5),V("isoWeek",5),pt("w",rt),pt("ww",rt,K),pt("W",rt),pt("WW",rt,K),wt(["w","ww","W","WW"],(function(t,e,n,r){e[r.substr(0,1)]=Z(t)})),I("d",0,"do","day"),I("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),I("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),I("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),I("e",0,0,"weekday"),I("E",0,0,"isoWeekday"),W("day","d"),W("weekday","e"),W("isoWeekday","E"),V("day",11),V("weekday",11),V("isoWeekday",11),pt("d",rt),pt("e",rt),pt("E",rt),pt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),pt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),pt("dddd",(function(t,e){return e.weekdaysRegex(t)})),wt(["dd","ddd","dddd"],(function(t,e,n,r){var i=n._locale.weekdaysParse(t,r,n._strict);null!=i?e.d=i:v(n).invalidWeekday=t})),wt(["d","e","E"],(function(t,e,n,r){e[r]=Z(t)}));var Ft="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Gt="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Ut="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),Vt=dt,Bt=dt,Ht=dt;function Zt(t,e,n){var r,i,o,a=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],r=0;r<7;++r)o=p([2e3,1]).day(r),this._minWeekdaysParse[r]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[r]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[r]=this.weekdays(o,"").toLocaleLowerCase();return n?"dddd"===e?-1!==(i=mt.call(this._weekdaysParse,a))?i:null:"ddd"===e?-1!==(i=mt.call(this._shortWeekdaysParse,a))?i:null:-1!==(i=mt.call(this._minWeekdaysParse,a))?i:null:"dddd"===e?-1!==(i=mt.call(this._weekdaysParse,a))||-1!==(i=mt.call(this._shortWeekdaysParse,a))||-1!==(i=mt.call(this._minWeekdaysParse,a))?i:null:"ddd"===e?-1!==(i=mt.call(this._shortWeekdaysParse,a))||-1!==(i=mt.call(this._weekdaysParse,a))||-1!==(i=mt.call(this._minWeekdaysParse,a))?i:null:-1!==(i=mt.call(this._minWeekdaysParse,a))||-1!==(i=mt.call(this._weekdaysParse,a))||-1!==(i=mt.call(this._shortWeekdaysParse,a))?i:null}function Xt(){function t(t,e){return e.length-t.length}var e,n,r,i,o,a=[],s=[],l=[],u=[];for(e=0;e<7;e++)n=p([2e3,1]).day(e),r=yt(this.weekdaysMin(n,"")),i=yt(this.weekdaysShort(n,"")),o=yt(this.weekdays(n,"")),a.push(r),s.push(i),l.push(o),u.push(r),u.push(i),u.push(o);a.sort(t),s.sort(t),l.sort(t),u.sort(t),this._weekdaysRegex=new RegExp("^("+u.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+a.join("|")+")","i")}function qt(){return this.hours()%12||12}function $t(t,e){I(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function Jt(t,e){return e._meridiemParse}I("H",["HH",2],0,"hour"),I("h",["hh",2],0,qt),I("k",["kk",2],0,(function(){return this.hours()||24})),I("hmm",0,0,(function(){return""+qt.apply(this)+P(this.minutes(),2)})),I("hmmss",0,0,(function(){return""+qt.apply(this)+P(this.minutes(),2)+P(this.seconds(),2)})),I("Hmm",0,0,(function(){return""+this.hours()+P(this.minutes(),2)})),I("Hmmss",0,0,(function(){return""+this.hours()+P(this.minutes(),2)+P(this.seconds(),2)})),$t("a",!0),$t("A",!1),W("hour","h"),V("hour",13),pt("a",Jt),pt("A",Jt),pt("H",rt),pt("h",rt),pt("k",rt),pt("HH",rt,K),pt("hh",rt,K),pt("kk",rt,K),pt("hmm",it),pt("hmmss",ot),pt("Hmm",it),pt("Hmmss",ot),_t(["H","HH"],3),_t(["k","kk"],(function(t,e,n){var r=Z(t);e[3]=24===r?0:r})),_t(["a","A"],(function(t,e,n){n._isPm=n._locale.isPM(t),n._meridiem=t})),_t(["h","hh"],(function(t,e,n){e[3]=Z(t),v(n).bigHour=!0})),_t("hmm",(function(t,e,n){var r=t.length-2;e[3]=Z(t.substr(0,r)),e[4]=Z(t.substr(r)),v(n).bigHour=!0})),_t("hmmss",(function(t,e,n){var r=t.length-4,i=t.length-2;e[3]=Z(t.substr(0,r)),e[4]=Z(t.substr(r,2)),e[5]=Z(t.substr(i)),v(n).bigHour=!0})),_t("Hmm",(function(t,e,n){var r=t.length-2;e[3]=Z(t.substr(0,r)),e[4]=Z(t.substr(r))})),_t("Hmmss",(function(t,e,n){var r=t.length-4,i=t.length-2;e[3]=Z(t.substr(0,r)),e[4]=Z(t.substr(r,2)),e[5]=Z(t.substr(i))}));var Qt,Kt=X("Hours",!0),te={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:St,monthsShort:kt,week:{dow:0,doy:6},weekdays:Ft,weekdaysMin:Ut,weekdaysShort:Gt,meridiemParse:/[ap]\.?m?\.?/i},ee={},ne={};function re(t,e){var n,r=Math.min(t.length,e.length);for(n=0;n<r;n+=1)if(t[n]!==e[n])return n;return r}function ie(t){return t?t.toLowerCase().replace("_","-"):t}function oe(e){var n=null;if(void 0===ee[e]&&t&&t.exports)try{n=Qt._abbr,i(),ae(n)}catch(t){ee[e]=null}return ee[e]}function ae(t,e){var n;return t&&((n=u(e)?le(t):se(t,e))?Qt=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),Qt._abbr}function se(t,e){if(null!==e){var n,r=te;if(e.abbr=t,null!=ee[t])O("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),r=ee[t]._config;else if(null!=e.parentLocale)if(null!=ee[e.parentLocale])r=ee[e.parentLocale]._config;else{if(null==(n=oe(e.parentLocale)))return ne[e.parentLocale]||(ne[e.parentLocale]=[]),ne[e.parentLocale].push({name:t,config:e}),null;r=n._config}return ee[t]=new L(C(r,e)),ne[t]&&ne[t].forEach((function(t){se(t.name,t.config)})),ae(t),ee[t]}return delete ee[t],null}function le(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return Qt;if(!o(t)){if(e=oe(t))return e;t=[t]}return function(t){for(var e,n,r,i,o=0;o<t.length;){for(e=(i=ie(t[o]).split("-")).length,n=(n=ie(t[o+1]))?n.split("-"):null;e>0;){if(r=oe(i.slice(0,e).join("-")))return r;if(n&&n.length>=e&&re(i,n)>=e-1)break;e--}o++}return Qt}(t)}function ue(t){var e,n=t._a;return n&&-2===v(t).overflow&&(e=n[1]<0||n[1]>11?1:n[2]<1||n[2]>xt(n[0],n[1])?2:n[3]<0||n[3]>24||24===n[3]&&(0!==n[4]||0!==n[5]||0!==n[6])?3:n[4]<0||n[4]>59?4:n[5]<0||n[5]>59?5:n[6]<0||n[6]>999?6:-1,v(t)._overflowDayOfYear&&(e<0||e>2)&&(e=2),v(t)._overflowWeeks&&-1===e&&(e=7),v(t)._overflowWeekday&&-1===e&&(e=8),v(t).overflow=e),t}var he=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,ce=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,fe=/Z|[+-]\d\d(?::?\d\d)?/,de=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],pe=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],ve=/^\/?Date\((-?\d+)/i,ye=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,me={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function ge(t){var e,n,r,i,o,a,s=t._i,l=he.exec(s)||ce.exec(s);if(l){for(v(t).iso=!0,e=0,n=de.length;e<n;e++)if(de[e][1].exec(l[1])){i=de[e][0],r=!1!==de[e][2];break}if(null==i)return void(t._isValid=!1);if(l[3]){for(e=0,n=pe.length;e<n;e++)if(pe[e][1].exec(l[3])){o=(l[2]||" ")+pe[e][0];break}if(null==o)return void(t._isValid=!1)}if(!r&&null!=o)return void(t._isValid=!1);if(l[4]){if(!fe.exec(l[4]))return void(t._isValid=!1);a="Z"}t._f=i+(o||"")+(a||""),Se(t)}else t._isValid=!1}function _e(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}function we(t){var e,n,r,i,o,a,s,l,u=ye.exec(t._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(u){if(n=u[4],r=u[3],i=u[2],o=u[5],a=u[6],s=u[7],l=[_e(n),kt.indexOf(r),parseInt(i,10),parseInt(o,10),parseInt(a,10)],s&&l.push(parseInt(s,10)),e=l,!function(t,e,n){return!t||Gt.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(v(n).weekdayMismatch=!0,n._isValid=!1,!1)}(u[1],e,t))return;t._a=e,t._tzm=function(t,e,n){if(t)return me[t];if(e)return 0;var r=parseInt(n,10),i=r%100;return(r-i)/100*60+i}(u[8],u[9],u[10]),t._d=Rt.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),v(t).rfc2822=!0}else t._isValid=!1}function be(t,e,n){return null!=t?t:null!=e?e:n}function xe(t){var e,n,i,o,a,s=[];if(!t._d){for(i=function(t){var e=new Date(r.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[2]&&null==t._a[1]&&function(t){var e,n,r,i,o,a,s,l,u;null!=(e=t._w).GG||null!=e.W||null!=e.E?(o=1,a=4,n=be(e.GG,t._a[0],jt(Me(),1,4).year),r=be(e.W,1),((i=be(e.E,1))<1||i>7)&&(l=!0)):(o=t._locale._week.dow,a=t._locale._week.doy,u=jt(Me(),o,a),n=be(e.gg,t._a[0],u.year),r=be(e.w,u.week),null!=e.d?((i=e.d)<0||i>6)&&(l=!0):null!=e.e?(i=e.e+o,(e.e<0||e.e>6)&&(l=!0)):i=o),r<1||r>zt(n,o,a)?v(t)._overflowWeeks=!0:null!=l?v(t)._overflowWeekday=!0:(s=Nt(n,r,i,o,a),t._a[0]=s.year,t._dayOfYear=s.dayOfYear)}(t),null!=t._dayOfYear&&(a=be(t._a[0],i[0]),(t._dayOfYear>At(a)||0===t._dayOfYear)&&(v(t)._overflowDayOfYear=!0),n=Rt(a,0,t._dayOfYear),t._a[1]=n.getUTCMonth(),t._a[2]=n.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=s[e]=i[e];for(;e<7;e++)t._a[e]=s[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[3]&&0===t._a[4]&&0===t._a[5]&&0===t._a[6]&&(t._nextDay=!0,t._a[3]=0),t._d=(t._useUTC?Rt:Yt).apply(null,s),o=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[3]=24),t._w&&void 0!==t._w.d&&t._w.d!==o&&(v(t).weekdayMismatch=!0)}}function Se(t){if(t._f!==r.ISO_8601)if(t._f!==r.RFC_2822){t._a=[],v(t).empty=!0;var e,n,i,o,a,s,l=""+t._i,u=l.length,h=0;for(i=j(t._f,t._locale).match(A)||[],e=0;e<i.length;e++)o=i[e],(n=(l.match(vt(o,t))||[])[0])&&((a=l.substr(0,l.indexOf(n))).length>0&&v(t).unusedInput.push(a),l=l.slice(l.indexOf(n)+n.length),h+=n.length),R[o]?(n?v(t).empty=!1:v(t).unusedTokens.push(o),bt(o,n,t)):t._strict&&!n&&v(t).unusedTokens.push(o);v(t).charsLeftOver=u-h,l.length>0&&v(t).unusedInput.push(l),t._a[3]<=12&&!0===v(t).bigHour&&t._a[3]>0&&(v(t).bigHour=void 0),v(t).parsedDateParts=t._a.slice(0),v(t).meridiem=t._meridiem,t._a[3]=function(t,e,n){var r;return null==n?e:null!=t.meridiemHour?t.meridiemHour(e,n):null!=t.isPM?((r=t.isPM(n))&&e<12&&(e+=12),r||12!==e||(e=0),e):e}(t._locale,t._a[3],t._meridiem),null!==(s=v(t).era)&&(t._a[0]=t._locale.erasConvertYear(s,t._a[0])),xe(t),ue(t)}else we(t);else ge(t)}function ke(t){var e=t._i,n=t._f;return t._locale=t._locale||le(t._l),null===e||void 0===n&&""===e?m({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),x(e)?new b(ue(e)):(c(e)?t._d=e:o(n)?function(t){var e,n,r,i,o,a,s=!1;if(0===t._f.length)return v(t).invalidFormat=!0,void(t._d=new Date(NaN));for(i=0;i<t._f.length;i++)o=0,a=!1,e=w({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[i],Se(e),y(e)&&(a=!0),o+=v(e).charsLeftOver,o+=10*v(e).unusedTokens.length,v(e).score=o,s?o<r&&(r=o,n=e):(null==r||o<r||a)&&(r=o,n=e,a&&(s=!0));d(t,n||e)}(t):n?Se(t):function(t){var e=t._i;u(e)?t._d=new Date(r.now()):c(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=ve.exec(t._i);null===e?(ge(t),!1===t._isValid&&(delete t._isValid,we(t),!1===t._isValid&&(delete t._isValid,t._strict?t._isValid=!1:r.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):o(e)?(t._a=f(e.slice(0),(function(t){return parseInt(t,10)})),xe(t)):a(e)?function(t){if(!t._d){var e=G(t._i),n=void 0===e.day?e.date:e.day;t._a=f([e.year,e.month,n,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),xe(t)}}(t):h(e)?t._d=new Date(e):r.createFromInputFallback(t)}(t),y(t)||(t._d=null),t))}function De(t,e,n,r,i){var s,u={};return!0!==e&&!1!==e||(r=e,e=void 0),!0!==n&&!1!==n||(r=n,n=void 0),(a(t)&&l(t)||o(t)&&0===t.length)&&(t=void 0),u._isAMomentObject=!0,u._useUTC=u._isUTC=i,u._l=n,u._i=t,u._f=e,u._strict=r,(s=new b(ue(ke(u))))._nextDay&&(s.add(1,"d"),s._nextDay=void 0),s}function Me(t,e,n,r){return De(t,e,n,r,!1)}r.createFromInputFallback=k("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),r.ISO_8601=function(){},r.RFC_2822=function(){};var Oe=k("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Me.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:m()})),Te=k("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Me.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:m()}));function Ce(t,e){var n,r;if(1===e.length&&o(e[0])&&(e=e[0]),!e.length)return Me();for(n=e[0],r=1;r<e.length;++r)e[r].isValid()&&!e[r][t](n)||(n=e[r]);return n}var Le=["year","quarter","month","week","day","hour","minute","second","millisecond"];function Pe(t){var e=G(t),n=e.year||0,r=e.quarter||0,i=e.month||0,o=e.week||e.isoWeek||0,a=e.day||0,l=e.hour||0,u=e.minute||0,h=e.second||0,c=e.millisecond||0;this._isValid=function(t){var e,n,r=!1;for(e in t)if(s(t,e)&&(-1===mt.call(Le,e)||null!=t[e]&&isNaN(t[e])))return!1;for(n=0;n<Le.length;++n)if(t[Le[n]]){if(r)return!1;parseFloat(t[Le[n]])!==Z(t[Le[n]])&&(r=!0)}return!0}(e),this._milliseconds=+c+1e3*h+6e4*u+1e3*l*60*60,this._days=+a+7*o,this._months=+i+3*r+12*n,this._data={},this._locale=le(),this._bubble()}function Ae(t){return t instanceof Pe}function Ee(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function Ye(t,e){I(t,0,0,(function(){var t=this.utcOffset(),n="+";return t<0&&(t=-t,n="-"),n+P(~~(t/60),2)+e+P(~~t%60,2)}))}Ye("Z",":"),Ye("ZZ",""),pt("Z",ft),pt("ZZ",ft),_t(["Z","ZZ"],(function(t,e,n){n._useUTC=!0,n._tzm=Ie(ft,t)}));var Re=/([\+\-]|\d\d)/gi;function Ie(t,e){var n,r,i=(e||"").match(t);return null===i?null:0===(r=60*(n=((i[i.length-1]||[])+"").match(Re)||["-",0,0])[1]+Z(n[2]))?0:"+"===n[0]?r:-r}function Ne(t,e){var n,i;return e._isUTC?(n=e.clone(),i=(x(t)||c(t)?t.valueOf():Me(t).valueOf())-n.valueOf(),n._d.setTime(n._d.valueOf()+i),r.updateOffset(n,!1),n):Me(t).local()}function je(t){return-Math.round(t._d.getTimezoneOffset())}function ze(){return!!this.isValid()&&this._isUTC&&0===this._offset}r.updateOffset=function(){};var We=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,Fe=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Ge(t,e){var n,r,i,o,a,l,u=t,c=null;return Ae(t)?u={ms:t._milliseconds,d:t._days,M:t._months}:h(t)||!isNaN(+t)?(u={},e?u[e]=+t:u.milliseconds=+t):(c=We.exec(t))?(n="-"===c[1]?-1:1,u={y:0,d:Z(c[2])*n,h:Z(c[3])*n,m:Z(c[4])*n,s:Z(c[5])*n,ms:Z(Ee(1e3*c[6]))*n}):(c=Fe.exec(t))?(n="-"===c[1]?-1:1,u={y:Ue(c[2],n),M:Ue(c[3],n),w:Ue(c[4],n),d:Ue(c[5],n),h:Ue(c[6],n),m:Ue(c[7],n),s:Ue(c[8],n)}):null==u?u={}:"object"==typeof u&&("from"in u||"to"in u)&&(o=Me(u.from),a=Me(u.to),i=o.isValid()&&a.isValid()?(a=Ne(a,o),o.isBefore(a)?l=Ve(o,a):((l=Ve(a,o)).milliseconds=-l.milliseconds,l.months=-l.months),l):{milliseconds:0,months:0},(u={}).ms=i.milliseconds,u.M=i.months),r=new Pe(u),Ae(t)&&s(t,"_locale")&&(r._locale=t._locale),Ae(t)&&s(t,"_isValid")&&(r._isValid=t._isValid),r}function Ue(t,e){var n=t&&parseFloat(t.replace(",","."));return(isNaN(n)?0:n)*e}function Ve(t,e){var n={};return n.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(n.months,"M").isAfter(e)&&--n.months,n.milliseconds=+e-+t.clone().add(n.months,"M"),n}function Be(t,e){return function(n,r){var i;return null===r||isNaN(+r)||(O(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),i=n,n=r,r=i),He(this,Ge(n,r),t),this}}function He(t,e,n,i){var o=e._milliseconds,a=Ee(e._days),s=Ee(e._months);t.isValid()&&(i=null==i||i,s&&Ct(t,q(t,"Month")+s*n),a&&$(t,"Date",q(t,"Date")+a*n),o&&t._d.setTime(t._d.valueOf()+o*n),i&&r.updateOffset(t,a||s))}Ge.fn=Pe.prototype,Ge.invalid=function(){return Ge(NaN)};var Ze=Be(1,"add"),Xe=Be(-1,"subtract");function qe(t){return"string"==typeof t||t instanceof String}function $e(t){return x(t)||c(t)||qe(t)||h(t)||function(t){var e=o(t),n=!1;return e&&(n=0===t.filter((function(e){return!h(e)&&qe(t)})).length),e&&n}(t)||function(t){var e,n,r=a(t)&&!l(t),i=!1,o=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"];for(e=0;e<o.length;e+=1)n=o[e],i=i||s(t,n);return r&&i}(t)||null==t}function Je(t){var e,n=a(t)&&!l(t),r=!1,i=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"];for(e=0;e<i.length;e+=1)r=r||s(t,i[e]);return n&&r}function Qe(t,e){if(t.date()<e.date())return-Qe(e,t);var n=12*(e.year()-t.year())+(e.month()-t.month()),r=t.clone().add(n,"months");return-(n+(e-r<0?(e-r)/(r-t.clone().add(n-1,"months")):(e-r)/(t.clone().add(n+1,"months")-r)))||0}function Ke(t){var e;return void 0===t?this._locale._abbr:(null!=(e=le(t))&&(this._locale=e),this)}r.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",r.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var tn=k("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function en(){return this._locale}function nn(t,e){return(t%e+e)%e}function rn(t,e,n){return t<100&&t>=0?new Date(t+400,e,n)-126227808e5:new Date(t,e,n).valueOf()}function on(t,e,n){return t<100&&t>=0?Date.UTC(t+400,e,n)-126227808e5:Date.UTC(t,e,n)}function an(t,e){return e.erasAbbrRegex(t)}function sn(){var t,e,n=[],r=[],i=[],o=[],a=this.eras();for(t=0,e=a.length;t<e;++t)r.push(yt(a[t].name)),n.push(yt(a[t].abbr)),i.push(yt(a[t].narrow)),o.push(yt(a[t].name)),o.push(yt(a[t].abbr)),o.push(yt(a[t].narrow));this._erasRegex=new RegExp("^("+o.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+r.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+n.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+i.join("|")+")","i")}function ln(t,e){I(0,[t,t.length],0,e)}function un(t,e,n,r,i){var o;return null==t?jt(this,r,i).year:(e>(o=zt(t,r,i))&&(e=o),hn.call(this,t,e,n,r,i))}function hn(t,e,n,r,i){var o=Nt(t,e,n,r,i),a=Rt(o.year,0,o.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}I("N",0,0,"eraAbbr"),I("NN",0,0,"eraAbbr"),I("NNN",0,0,"eraAbbr"),I("NNNN",0,0,"eraName"),I("NNNNN",0,0,"eraNarrow"),I("y",["y",1],"yo","eraYear"),I("y",["yy",2],0,"eraYear"),I("y",["yyy",3],0,"eraYear"),I("y",["yyyy",4],0,"eraYear"),pt("N",an),pt("NN",an),pt("NNN",an),pt("NNNN",(function(t,e){return e.erasNameRegex(t)})),pt("NNNNN",(function(t,e){return e.erasNarrowRegex(t)})),_t(["N","NN","NNN","NNNN","NNNNN"],(function(t,e,n,r){var i=n._locale.erasParse(t,r,n._strict);i?v(n).era=i:v(n).invalidEra=t})),pt("y",ut),pt("yy",ut),pt("yyy",ut),pt("yyyy",ut),pt("yo",(function(t,e){return e._eraYearOrdinalRegex||ut})),_t(["y","yy","yyy","yyyy"],0),_t(["yo"],(function(t,e,n,r){var i;n._locale._eraYearOrdinalRegex&&(i=t.match(n._locale._eraYearOrdinalRegex)),n._locale.eraYearOrdinalParse?e[0]=n._locale.eraYearOrdinalParse(t,i):e[0]=parseInt(t,10)})),I(0,["gg",2],0,(function(){return this.weekYear()%100})),I(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),ln("gggg","weekYear"),ln("ggggg","weekYear"),ln("GGGG","isoWeekYear"),ln("GGGGG","isoWeekYear"),W("weekYear","gg"),W("isoWeekYear","GG"),V("weekYear",1),V("isoWeekYear",1),pt("G",ht),pt("g",ht),pt("GG",rt,K),pt("gg",rt,K),pt("GGGG",st,et),pt("gggg",st,et),pt("GGGGG",lt,nt),pt("ggggg",lt,nt),wt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,n,r){e[r.substr(0,2)]=Z(t)})),wt(["gg","GG"],(function(t,e,n,i){e[i]=r.parseTwoDigitYear(t)})),I("Q",0,"Qo","quarter"),W("quarter","Q"),V("quarter",7),pt("Q",Q),_t("Q",(function(t,e){e[1]=3*(Z(t)-1)})),I("D",["DD",2],"Do","date"),W("date","D"),V("date",9),pt("D",rt),pt("DD",rt,K),pt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),_t(["D","DD"],2),_t("Do",(function(t,e){e[2]=Z(t.match(rt)[0])}));var cn=X("Date",!0);I("DDD",["DDDD",3],"DDDo","dayOfYear"),W("dayOfYear","DDD"),V("dayOfYear",4),pt("DDD",at),pt("DDDD",tt),_t(["DDD","DDDD"],(function(t,e,n){n._dayOfYear=Z(t)})),I("m",["mm",2],0,"minute"),W("minute","m"),V("minute",14),pt("m",rt),pt("mm",rt,K),_t(["m","mm"],4);var fn=X("Minutes",!1);I("s",["ss",2],0,"second"),W("second","s"),V("second",15),pt("s",rt),pt("ss",rt,K),_t(["s","ss"],5);var dn,pn,vn=X("Seconds",!1);for(I("S",0,0,(function(){return~~(this.millisecond()/100)})),I(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),I(0,["SSS",3],0,"millisecond"),I(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),I(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),I(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),I(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),I(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),I(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),W("millisecond","ms"),V("millisecond",16),pt("S",at,Q),pt("SS",at,K),pt("SSS",at,tt),dn="SSSS";dn.length<=9;dn+="S")pt(dn,ut);function yn(t,e){e[6]=Z(1e3*("0."+t))}for(dn="S";dn.length<=9;dn+="S")_t(dn,yn);pn=X("Milliseconds",!1),I("z",0,0,"zoneAbbr"),I("zz",0,0,"zoneName");var mn=b.prototype;function gn(t){return t}mn.add=Ze,mn.calendar=function(t,e){1===arguments.length&&($e(arguments[0])?(t=arguments[0],e=void 0):Je(arguments[0])&&(e=arguments[0],t=void 0));var n=t||Me(),i=Ne(n,this).startOf("day"),o=r.calendarFormat(this,i)||"sameElse",a=e&&(T(e[o])?e[o].call(this,n):e[o]);return this.format(a||this.localeData().calendar(o,this,Me(n)))},mn.clone=function(){return new b(this)},mn.diff=function(t,e,n){var r,i,o;if(!this.isValid())return NaN;if(!(r=Ne(t,this)).isValid())return NaN;switch(i=6e4*(r.utcOffset()-this.utcOffset()),e=F(e)){case"year":o=Qe(this,r)/12;break;case"month":o=Qe(this,r);break;case"quarter":o=Qe(this,r)/3;break;case"second":o=(this-r)/1e3;break;case"minute":o=(this-r)/6e4;break;case"hour":o=(this-r)/36e5;break;case"day":o=(this-r-i)/864e5;break;case"week":o=(this-r-i)/6048e5;break;default:o=this-r}return n?o:H(o)},mn.endOf=function(t){var e,n;if(void 0===(t=F(t))||"millisecond"===t||!this.isValid())return this;switch(n=this._isUTC?on:rn,t){case"year":e=n(this.year()+1,0,1)-1;break;case"quarter":e=n(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=n(this.year(),this.month()+1,1)-1;break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=n(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=36e5-nn(e+(this._isUTC?0:6e4*this.utcOffset()),36e5)-1;break;case"minute":e=this._d.valueOf(),e+=6e4-nn(e,6e4)-1;break;case"second":e=this._d.valueOf(),e+=1e3-nn(e,1e3)-1}return this._d.setTime(e),r.updateOffset(this,!0),this},mn.format=function(t){t||(t=this.isUtc()?r.defaultFormatUtc:r.defaultFormat);var e=N(this,t);return this.localeData().postformat(e)},mn.from=function(t,e){return this.isValid()&&(x(t)&&t.isValid()||Me(t).isValid())?Ge({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},mn.fromNow=function(t){return this.from(Me(),t)},mn.to=function(t,e){return this.isValid()&&(x(t)&&t.isValid()||Me(t).isValid())?Ge({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},mn.toNow=function(t){return this.to(Me(),t)},mn.get=function(t){return T(this[t=F(t)])?this[t]():this},mn.invalidAt=function(){return v(this).overflow},mn.isAfter=function(t,e){var n=x(t)?t:Me(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=F(e)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(e).valueOf())},mn.isBefore=function(t,e){var n=x(t)?t:Me(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=F(e)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(e).valueOf()<n.valueOf())},mn.isBetween=function(t,e,n,r){var i=x(t)?t:Me(t),o=x(e)?e:Me(e);return!!(this.isValid()&&i.isValid()&&o.isValid())&&(("("===(r=r||"()")[0]?this.isAfter(i,n):!this.isBefore(i,n))&&(")"===r[1]?this.isBefore(o,n):!this.isAfter(o,n)))},mn.isSame=function(t,e){var n,r=x(t)?t:Me(t);return!(!this.isValid()||!r.isValid())&&("millisecond"===(e=F(e)||"millisecond")?this.valueOf()===r.valueOf():(n=r.valueOf(),this.clone().startOf(e).valueOf()<=n&&n<=this.clone().endOf(e).valueOf()))},mn.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},mn.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},mn.isValid=function(){return y(this)},mn.lang=tn,mn.locale=Ke,mn.localeData=en,mn.max=Te,mn.min=Oe,mn.parsingFlags=function(){return d({},v(this))},mn.set=function(t,e){if("object"==typeof t){var n,r=function(t){var e,n=[];for(e in t)s(t,e)&&n.push({unit:e,priority:U[e]});return n.sort((function(t,e){return t.priority-e.priority})),n}(t=G(t));for(n=0;n<r.length;n++)this[r[n].unit](t[r[n].unit])}else if(T(this[t=F(t)]))return this[t](e);return this},mn.startOf=function(t){var e,n;if(void 0===(t=F(t))||"millisecond"===t||!this.isValid())return this;switch(n=this._isUTC?on:rn,t){case"year":e=n(this.year(),0,1);break;case"quarter":e=n(this.year(),this.month()-this.month()%3,1);break;case"month":e=n(this.year(),this.month(),1);break;case"week":e=n(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=n(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=nn(e+(this._isUTC?0:6e4*this.utcOffset()),36e5);break;case"minute":e=this._d.valueOf(),e-=nn(e,6e4);break;case"second":e=this._d.valueOf(),e-=nn(e,1e3)}return this._d.setTime(e),r.updateOffset(this,!0),this},mn.subtract=Xe,mn.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},mn.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},mn.toDate=function(){return new Date(this.valueOf())},mn.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,n=e?this.clone().utc():this;return n.year()<0||n.year()>9999?N(n,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):T(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",N(n,"Z")):N(n,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},mn.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t,e,n,r="moment",i="";return this.isLocal()||(r=0===this.utcOffset()?"moment.utc":"moment.parseZone",i="Z"),t="["+r+'("]',e=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",n=i+'[")]',this.format(t+e+"-MM-DD[T]HH:mm:ss.SSS"+n)},"undefined"!=typeof Symbol&&null!=Symbol.for&&(mn[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),mn.toJSON=function(){return this.isValid()?this.toISOString():null},mn.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},mn.unix=function(){return Math.floor(this.valueOf()/1e3)},mn.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},mn.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},mn.eraName=function(){var t,e,n,r=this.localeData().eras();for(t=0,e=r.length;t<e;++t){if(n=this.startOf("day").valueOf(),r[t].since<=n&&n<=r[t].until)return r[t].name;if(r[t].until<=n&&n<=r[t].since)return r[t].name}return""},mn.eraNarrow=function(){var t,e,n,r=this.localeData().eras();for(t=0,e=r.length;t<e;++t){if(n=this.startOf("day").valueOf(),r[t].since<=n&&n<=r[t].until)return r[t].narrow;if(r[t].until<=n&&n<=r[t].since)return r[t].narrow}return""},mn.eraAbbr=function(){var t,e,n,r=this.localeData().eras();for(t=0,e=r.length;t<e;++t){if(n=this.startOf("day").valueOf(),r[t].since<=n&&n<=r[t].until)return r[t].abbr;if(r[t].until<=n&&n<=r[t].since)return r[t].abbr}return""},mn.eraYear=function(){var t,e,n,i,o=this.localeData().eras();for(t=0,e=o.length;t<e;++t)if(n=o[t].since<=o[t].until?1:-1,i=this.startOf("day").valueOf(),o[t].since<=i&&i<=o[t].until||o[t].until<=i&&i<=o[t].since)return(this.year()-r(o[t].since).year())*n+o[t].offset;return this.year()},mn.year=Et,mn.isLeapYear=function(){return B(this.year())},mn.weekYear=function(t){return un.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},mn.isoWeekYear=function(t){return un.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},mn.quarter=mn.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},mn.month=Lt,mn.daysInMonth=function(){return xt(this.year(),this.month())},mn.week=mn.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},mn.isoWeek=mn.isoWeeks=function(t){var e=jt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},mn.weeksInYear=function(){var t=this.localeData()._week;return zt(this.year(),t.dow,t.doy)},mn.weeksInWeekYear=function(){var t=this.localeData()._week;return zt(this.weekYear(),t.dow,t.doy)},mn.isoWeeksInYear=function(){return zt(this.year(),1,4)},mn.isoWeeksInISOWeekYear=function(){return zt(this.isoWeekYear(),1,4)},mn.date=cn,mn.day=mn.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},mn.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},mn.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},mn.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},mn.hour=mn.hours=Kt,mn.minute=mn.minutes=fn,mn.second=mn.seconds=vn,mn.millisecond=mn.milliseconds=pn,mn.utcOffset=function(t,e,n){var i,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=Ie(ft,t)))return this}else Math.abs(t)<16&&!n&&(t*=60);return!this._isUTC&&e&&(i=je(this)),this._offset=t,this._isUTC=!0,null!=i&&this.add(i,"m"),o!==t&&(!e||this._changeInProgress?He(this,Ge(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,r.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:je(this)},mn.utc=function(t){return this.utcOffset(0,t)},mn.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(je(this),"m")),this},mn.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=Ie(ct,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},mn.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?Me(t).utcOffset():0,(this.utcOffset()-t)%60==0)},mn.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},mn.isLocal=function(){return!!this.isValid()&&!this._isUTC},mn.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},mn.isUtc=ze,mn.isUTC=ze,mn.zoneAbbr=function(){return this._isUTC?"UTC":""},mn.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},mn.dates=k("dates accessor is deprecated. Use date instead.",cn),mn.months=k("months accessor is deprecated. Use month instead",Lt),mn.years=k("years accessor is deprecated. Use year instead",Et),mn.zone=k("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),mn.isDSTShifted=k("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!u(this._isDSTShifted))return this._isDSTShifted;var t,e={};return w(e,this),(e=ke(e))._a?(t=e._isUTC?p(e._a):Me(e._a),this._isDSTShifted=this.isValid()&&function(t,e,n){var r,i=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),a=0;for(r=0;r<i;r++)(n&&t[r]!==e[r]||!n&&Z(t[r])!==Z(e[r]))&&a++;return a+o}(e._a,t.toArray())>0):this._isDSTShifted=!1,this._isDSTShifted}));var _n=L.prototype;function wn(t,e,n,r){var i=le(),o=p().set(r,e);return i[n](o,t)}function bn(t,e,n){if(h(t)&&(e=t,t=void 0),t=t||"",null!=e)return wn(t,e,n,"month");var r,i=[];for(r=0;r<12;r++)i[r]=wn(t,r,n,"month");return i}function xn(t,e,n,r){"boolean"==typeof t?(h(e)&&(n=e,e=void 0),e=e||""):(n=e=t,t=!1,h(e)&&(n=e,e=void 0),e=e||"");var i,o=le(),a=t?o._week.dow:0,s=[];if(null!=n)return wn(e,(n+a)%7,r,"day");for(i=0;i<7;i++)s[i]=wn(e,(i+a)%7,r,"day");return s}_n.calendar=function(t,e,n){var r=this._calendar[t]||this._calendar.sameElse;return T(r)?r.call(e,n):r},_n.longDateFormat=function(t){var e=this._longDateFormat[t],n=this._longDateFormat[t.toUpperCase()];return e||!n?e:(this._longDateFormat[t]=n.match(A).map((function(t){return"MMMM"===t||"MM"===t||"DD"===t||"dddd"===t?t.slice(1):t})).join(""),this._longDateFormat[t])},_n.invalidDate=function(){return this._invalidDate},_n.ordinal=function(t){return this._ordinal.replace("%d",t)},_n.preparse=gn,_n.postformat=gn,_n.relativeTime=function(t,e,n,r){var i=this._relativeTime[n];return T(i)?i(t,e,n,r):i.replace(/%d/i,t)},_n.pastFuture=function(t,e){var n=this._relativeTime[t>0?"future":"past"];return T(n)?n(e):n.replace(/%s/i,e)},_n.set=function(t){var e,n;for(n in t)s(t,n)&&(T(e=t[n])?this[n]=e:this["_"+n]=e);this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},_n.eras=function(t,e){var n,i,o,a=this._eras||le("en")._eras;for(n=0,i=a.length;n<i;++n){switch(typeof a[n].since){case"string":o=r(a[n].since).startOf("day"),a[n].since=o.valueOf()}switch(typeof a[n].until){case"undefined":a[n].until=1/0;break;case"string":o=r(a[n].until).startOf("day").valueOf(),a[n].until=o.valueOf()}}return a},_n.erasParse=function(t,e,n){var r,i,o,a,s,l=this.eras();for(t=t.toUpperCase(),r=0,i=l.length;r<i;++r)if(o=l[r].name.toUpperCase(),a=l[r].abbr.toUpperCase(),s=l[r].narrow.toUpperCase(),n)switch(e){case"N":case"NN":case"NNN":if(a===t)return l[r];break;case"NNNN":if(o===t)return l[r];break;case"NNNNN":if(s===t)return l[r]}else if([o,a,s].indexOf(t)>=0)return l[r]},_n.erasConvertYear=function(t,e){var n=t.since<=t.until?1:-1;return void 0===e?r(t.since).year():r(t.since).year()+(e-t.offset)*n},_n.erasAbbrRegex=function(t){return s(this,"_erasAbbrRegex")||sn.call(this),t?this._erasAbbrRegex:this._erasRegex},_n.erasNameRegex=function(t){return s(this,"_erasNameRegex")||sn.call(this),t?this._erasNameRegex:this._erasRegex},_n.erasNarrowRegex=function(t){return s(this,"_erasNarrowRegex")||sn.call(this),t?this._erasNarrowRegex:this._erasRegex},_n.months=function(t,e){return t?o(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||Dt).test(e)?"format":"standalone"][t.month()]:o(this._months)?this._months:this._months.standalone},_n.monthsShort=function(t,e){return t?o(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[Dt.test(e)?"format":"standalone"][t.month()]:o(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},_n.monthsParse=function(t,e,n){var r,i,o;if(this._monthsParseExact)return Tt.call(this,t,e,n);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),r=0;r<12;r++){if(i=p([2e3,r]),n&&!this._longMonthsParse[r]&&(this._longMonthsParse[r]=new RegExp("^"+this.months(i,"").replace(".","")+"$","i"),this._shortMonthsParse[r]=new RegExp("^"+this.monthsShort(i,"").replace(".","")+"$","i")),n||this._monthsParse[r]||(o="^"+this.months(i,"")+"|^"+this.monthsShort(i,""),this._monthsParse[r]=new RegExp(o.replace(".",""),"i")),n&&"MMMM"===e&&this._longMonthsParse[r].test(t))return r;if(n&&"MMM"===e&&this._shortMonthsParse[r].test(t))return r;if(!n&&this._monthsParse[r].test(t))return r}},_n.monthsRegex=function(t){return this._monthsParseExact?(s(this,"_monthsRegex")||Pt.call(this),t?this._monthsStrictRegex:this._monthsRegex):(s(this,"_monthsRegex")||(this._monthsRegex=Ot),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},_n.monthsShortRegex=function(t){return this._monthsParseExact?(s(this,"_monthsRegex")||Pt.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(s(this,"_monthsShortRegex")||(this._monthsShortRegex=Mt),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},_n.week=function(t){return jt(t,this._week.dow,this._week.doy).week},_n.firstDayOfYear=function(){return this._week.doy},_n.firstDayOfWeek=function(){return this._week.dow},_n.weekdays=function(t,e){var n=o(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Wt(n,this._week.dow):t?n[t.day()]:n},_n.weekdaysMin=function(t){return!0===t?Wt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},_n.weekdaysShort=function(t){return!0===t?Wt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},_n.weekdaysParse=function(t,e,n){var r,i,o;if(this._weekdaysParseExact)return Zt.call(this,t,e,n);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),r=0;r<7;r++){if(i=p([2e3,1]).day(r),n&&!this._fullWeekdaysParse[r]&&(this._fullWeekdaysParse[r]=new RegExp("^"+this.weekdays(i,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[r]=new RegExp("^"+this.weekdaysShort(i,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[r]=new RegExp("^"+this.weekdaysMin(i,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[r]||(o="^"+this.weekdays(i,"")+"|^"+this.weekdaysShort(i,"")+"|^"+this.weekdaysMin(i,""),this._weekdaysParse[r]=new RegExp(o.replace(".",""),"i")),n&&"dddd"===e&&this._fullWeekdaysParse[r].test(t))return r;if(n&&"ddd"===e&&this._shortWeekdaysParse[r].test(t))return r;if(n&&"dd"===e&&this._minWeekdaysParse[r].test(t))return r;if(!n&&this._weekdaysParse[r].test(t))return r}},_n.weekdaysRegex=function(t){return this._weekdaysParseExact?(s(this,"_weekdaysRegex")||Xt.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(s(this,"_weekdaysRegex")||(this._weekdaysRegex=Vt),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},_n.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(s(this,"_weekdaysRegex")||Xt.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(s(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=Bt),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},_n.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(s(this,"_weekdaysRegex")||Xt.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(s(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Ht),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},_n.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},_n.meridiem=function(t,e,n){return t>11?n?"pm":"PM":n?"am":"AM"},ae("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===Z(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),r.lang=k("moment.lang is deprecated. Use moment.locale instead.",ae),r.langData=k("moment.langData is deprecated. Use moment.localeData instead.",le);var Sn=Math.abs;function kn(t,e,n,r){var i=Ge(e,n);return t._milliseconds+=r*i._milliseconds,t._days+=r*i._days,t._months+=r*i._months,t._bubble()}function Dn(t){return t<0?Math.floor(t):Math.ceil(t)}function Mn(t){return 4800*t/146097}function On(t){return 146097*t/4800}function Tn(t){return function(){return this.as(t)}}var Cn=Tn("ms"),Ln=Tn("s"),Pn=Tn("m"),An=Tn("h"),En=Tn("d"),Yn=Tn("w"),Rn=Tn("M"),In=Tn("Q"),Nn=Tn("y");function jn(t){return function(){return this.isValid()?this._data[t]:NaN}}var zn=jn("milliseconds"),Wn=jn("seconds"),Fn=jn("minutes"),Gn=jn("hours"),Un=jn("days"),Vn=jn("months"),Bn=jn("years"),Hn=Math.round,Zn={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function Xn(t,e,n,r,i){return i.relativeTime(e||1,!!n,t,r)}var qn=Math.abs;function $n(t){return(t>0)-(t<0)||+t}function Jn(){if(!this.isValid())return this.localeData().invalidDate();var t,e,n,r,i,o,a,s,l=qn(this._milliseconds)/1e3,u=qn(this._days),h=qn(this._months),c=this.asSeconds();return c?(t=H(l/60),e=H(t/60),l%=60,t%=60,n=H(h/12),h%=12,r=l?l.toFixed(3).replace(/\.?0+$/,""):"",i=c<0?"-":"",o=$n(this._months)!==$n(c)?"-":"",a=$n(this._days)!==$n(c)?"-":"",s=$n(this._milliseconds)!==$n(c)?"-":"",i+"P"+(n?o+n+"Y":"")+(h?o+h+"M":"")+(u?a+u+"D":"")+(e||t||l?"T":"")+(e?s+e+"H":"")+(t?s+t+"M":"")+(l?s+r+"S":"")):"P0D"}var Qn=Pe.prototype;return Qn.isValid=function(){return this._isValid},Qn.abs=function(){var t=this._data;return this._milliseconds=Sn(this._milliseconds),this._days=Sn(this._days),this._months=Sn(this._months),t.milliseconds=Sn(t.milliseconds),t.seconds=Sn(t.seconds),t.minutes=Sn(t.minutes),t.hours=Sn(t.hours),t.months=Sn(t.months),t.years=Sn(t.years),this},Qn.add=function(t,e){return kn(this,t,e,1)},Qn.subtract=function(t,e){return kn(this,t,e,-1)},Qn.as=function(t){if(!this.isValid())return NaN;var e,n,r=this._milliseconds;if("month"===(t=F(t))||"quarter"===t||"year"===t)switch(e=this._days+r/864e5,n=this._months+Mn(e),t){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(e=this._days+Math.round(On(this._months)),t){case"week":return e/7+r/6048e5;case"day":return e+r/864e5;case"hour":return 24*e+r/36e5;case"minute":return 1440*e+r/6e4;case"second":return 86400*e+r/1e3;case"millisecond":return Math.floor(864e5*e)+r;default:throw new Error("Unknown unit "+t)}},Qn.asMilliseconds=Cn,Qn.asSeconds=Ln,Qn.asMinutes=Pn,Qn.asHours=An,Qn.asDays=En,Qn.asWeeks=Yn,Qn.asMonths=Rn,Qn.asQuarters=In,Qn.asYears=Nn,Qn.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*Z(this._months/12):NaN},Qn._bubble=function(){var t,e,n,r,i,o=this._milliseconds,a=this._days,s=this._months,l=this._data;return o>=0&&a>=0&&s>=0||o<=0&&a<=0&&s<=0||(o+=864e5*Dn(On(s)+a),a=0,s=0),l.milliseconds=o%1e3,t=H(o/1e3),l.seconds=t%60,e=H(t/60),l.minutes=e%60,n=H(e/60),l.hours=n%24,a+=H(n/24),i=H(Mn(a)),s+=i,a-=Dn(On(i)),r=H(s/12),s%=12,l.days=a,l.months=s,l.years=r,this},Qn.clone=function(){return Ge(this)},Qn.get=function(t){return t=F(t),this.isValid()?this[t+"s"]():NaN},Qn.milliseconds=zn,Qn.seconds=Wn,Qn.minutes=Fn,Qn.hours=Gn,Qn.days=Un,Qn.weeks=function(){return H(this.days()/7)},Qn.months=Vn,Qn.years=Bn,Qn.humanize=function(t,e){if(!this.isValid())return this.localeData().invalidDate();var n,r,i=!1,o=Zn;return"object"==typeof t&&(e=t,t=!1),"boolean"==typeof t&&(i=t),"object"==typeof e&&(o=Object.assign({},Zn,e),null!=e.s&&null==e.ss&&(o.ss=e.s-1)),n=this.localeData(),r=function(t,e,n,r){var i=Ge(t).abs(),o=Hn(i.as("s")),a=Hn(i.as("m")),s=Hn(i.as("h")),l=Hn(i.as("d")),u=Hn(i.as("M")),h=Hn(i.as("w")),c=Hn(i.as("y")),f=o<=n.ss&&["s",o]||o<n.s&&["ss",o]||a<=1&&["m"]||a<n.m&&["mm",a]||s<=1&&["h"]||s<n.h&&["hh",s]||l<=1&&["d"]||l<n.d&&["dd",l];return null!=n.w&&(f=f||h<=1&&["w"]||h<n.w&&["ww",h]),(f=f||u<=1&&["M"]||u<n.M&&["MM",u]||c<=1&&["y"]||["yy",c])[2]=e,f[3]=+t>0,f[4]=r,Xn.apply(null,f)}(this,!i,o,n),i&&(r=n.pastFuture(+this,r)),n.postformat(r)},Qn.toISOString=Jn,Qn.toString=Jn,Qn.toJSON=Jn,Qn.locale=Ke,Qn.localeData=en,Qn.toIsoString=k("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",Jn),Qn.lang=tn,I("X",0,0,"unix"),I("x",0,0,"valueOf"),pt("x",ht),pt("X",/[+-]?\d+(\.\d{1,3})?/),_t("X",(function(t,e,n){n._d=new Date(1e3*parseFloat(t))})),_t("x",(function(t,e,n){n._d=new Date(Z(t))})),//! moment.js
r.version="2.26.0",e=Me,r.fn=mn,r.min=function(){var t=[].slice.call(arguments,0);return Ce("isBefore",t)},r.max=function(){var t=[].slice.call(arguments,0);return Ce("isAfter",t)},r.now=function(){return Date.now?Date.now():+new Date},r.utc=p,r.unix=function(t){return Me(1e3*t)},r.months=function(t,e){return bn(t,e,"months")},r.isDate=c,r.locale=ae,r.invalid=m,r.duration=Ge,r.isMoment=x,r.weekdays=function(t,e,n){return xn(t,e,n,"weekdays")},r.parseZone=function(){return Me.apply(null,arguments).parseZone()},r.localeData=le,r.isDuration=Ae,r.monthsShort=function(t,e){return bn(t,e,"monthsShort")},r.weekdaysMin=function(t,e,n){return xn(t,e,n,"weekdaysMin")},r.defineLocale=se,r.updateLocale=function(t,e){if(null!=e){var n,r,i=te;null!=ee[t]&&null!=ee[t].parentLocale?ee[t].set(C(ee[t]._config,e)):(null!=(r=oe(t))&&(i=r._config),e=C(i,e),null==r&&(e.abbr=t),(n=new L(e)).parentLocale=ee[t],ee[t]=n),ae(t)}else null!=ee[t]&&(null!=ee[t].parentLocale?(ee[t]=ee[t].parentLocale,t===ae()&&ae(t)):null!=ee[t]&&delete ee[t]);return ee[t]},r.locales=function(){return D(ee)},r.weekdaysShort=function(t,e,n){return xn(t,e,n,"weekdaysShort")},r.normalizeUnits=F,r.relativeTimeRounding=function(t){return void 0===t?Hn:"function"==typeof t&&(Hn=t,!0)},r.relativeTimeThreshold=function(t,e){return void 0!==Zn[t]&&(void 0===e?Zn[t]:(Zn[t]=e,"s"===t&&(Zn.ss=e-1),!0))},r.calendarFormat=function(t,e){var n=t.diff(e,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"},r.prototype=mn,r.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},r}()}));function cl(t,e){var n=co(t);if(ci){var r=ci(t);e&&(r=zr(r).call(r,(function(e){return hi(t,e).enumerable}))),n.push.apply(n,r)}return n}function fl(t){var e=function(){if("undefined"==typeof Reflect||!Xa)return!1;if(Xa.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Xa(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var n,r=vs(t);if(e){var i=vs(this).constructor;n=Xa(r,arguments,i)}else n=r.apply(this,arguments);return ds(this,n)}}function dl(t,e){var n;if(void 0===Do||null==vi(t)){if(Kt(t)||(n=function(t,e){var n;if(!t)return;if("string"==typeof t)return pl(t,e);var r=wo(n=Object.prototype.toString.call(t)).call(n,8,-1);"Object"===r&&t.constructor&&(r=t.constructor.name);if("Map"===r||"Set"===r)return Mi(t);if("Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r))return pl(t,e)}(t))||e&&t&&"number"==typeof t.length){n&&(t=n);var r=0,i=function(){};return{s:i,n:function(){return r>=t.length?{done:!0}:{done:!1,value:t[r++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,a=!0,s=!1;return{s:function(){n=pi(t)},n:function(){var t=n.next();return a=t.done,t},e:function(t){s=!0,o=t},f:function(){try{a||null==n.return||n.return()}finally{if(s)throw o}}}}function pl(t,e){(null==e||e>t.length)&&(e=t.length);for(var n=0,r=new Array(e);n<e;n++)r[n]=t[n];return r}var vl=function(){function t(e,n,r){var i,o,a;Ma(this,t),this._source=e,this._transformers=n,this._target=r,this._listeners={add:rl(i=this._add).call(i,this),remove:rl(o=this._remove).call(o,this),update:rl(a=this._update).call(a,this)}}return Ca(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return tl(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),yl=function(){function t(e){Ma(this,t),this._source=e,this._transformers=[]}return Ca(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return zr(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return go(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return Zs(e).call(e,t)})),this}},{key:"to",value:function(t){return new vl(this._source,this._transformers,t)}}]),t}(),ml=/^\/?Date\((-?\d+)/i;function gl(t){return hl.isMoment(t)}function _l(t,e){var n;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return Io(t)&&!isNaN(Date.parse(t))?hl(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":if(Ro(t))return new Date(t);if(t instanceof Date)return new Date(t.valueOf());if(gl(t))return new Date(t.valueOf());if(Io(t))return(n=ml.exec(t))?new Date(Number(n[1])):hl(new Date(t)).toDate();throw new Error("Cannot convert object of type "+zo(t)+" to type Date");case"Moment":if(Ro(t))return hl(t);if(t instanceof Date)return hl(t.valueOf());if(gl(t))return hl(t);if(Io(t))return n=ml.exec(t),hl(n?Number(n[1]):t);throw new Error("Cannot convert object of type "+zo(t)+" to type Date");case"ISODate":if(Ro(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(gl(t))return t.toDate().toISOString();if(Io(t))return(n=ml.exec(t))?new Date(Number(n[1])).toISOString():hl(t).format();throw new Error("Cannot convert object of type "+zo(t)+" to type ISODate");case"ASPDate":if(Ro(t))return"/Date("+t+")/";if(t instanceof Date||gl(t))return"/Date("+t.valueOf()+")/";if(Io(t))return"/Date("+((n=ml.exec(t))?new Date(Number(n[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+zo(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}}function wl(t){return"string"==typeof t||"number"==typeof t}var bl=function(){function t(e){Ma(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return Ca(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,n=0;n<e.length;n++){var r=e[n];r.original?t[r.name]=r.original:delete t[r.name]}this._extended=null}}},{key:"replace",value:function(t,e){var n=this,r=t[e];if(!r)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];n.queue({args:e,fn:r,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=bt((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;yr(t=Gs(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,n){var r=new t(n);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){r.flush()};var i=[{name:"flush",original:void 0}];if(n&&n.replace)for(var o=0;o<n.replace.length;o++){var a=n.replace[o];i.push({name:a,original:e[a]}),r.replace(e,a)}return r._extended={object:e,methods:i},r}}]),t}(),xl=function(){function t(){Ma(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return Ca(t,[{key:"_trigger",value:function(t,e,n){var r,i;if("*"===t)throw new Error("Cannot trigger event *");yr(r=$t(i=[]).call(i,ko(this._subscribers[t]),ko(this._subscribers["*"]))).call(r,(function(r){r(t,e,null!=n?n:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var n;this._subscribers[t]=zr(n=this._subscribers[t]).call(n,(function(t){return t!==e}))}}]),t}(),Sl=function(){function t(e){Ma(this,t),this._pairs=e}return Ca(t,[{key:Rs,value:Ys.mark((function t(){var e,n,r,i,o;return Ys.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=dl(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=uo(n.value,2),i=r[0],o=r[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:Ys.mark((function t(){var e,n,r,i,o;return Ys.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=dl(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=uo(n.value,2),i=r[0],o=r[1],t.next=7,[i,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:Ys.mark((function t(){var e,n,r,i;return Ys.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=dl(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=uo(n.value,1),i=r[0],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:Ys.mark((function t(){var e,n,r,i;return Ys.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=dl(this._pairs),t.prev=1,e.s();case 3:if((n=e.n()).done){t.next=9;break}return r=uo(n.value,2),i=r[1],t.next=7,i;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return go(t=ko(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return go(t=ko(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return ko(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=Ci(null),n=dl(this._pairs);try{for(n.s();!(t=n.n()).done;){var r=uo(t.value,2),i=r[0],o=r[1];e[i]=o}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"toMap",value:function(){return new Es(this._pairs)}},{key:"toIdSet",value:function(){return new As(this.toIdArray())}},{key:"toItemSet",value:function(){return new As(this.toItemArray())}},{key:"cache",value:function(){return new t(ko(this._pairs))}},{key:"distinct",value:function(t){var e,n=new As,r=dl(this._pairs);try{for(r.s();!(e=r.n()).done;){var i=uo(e.value,2),o=i[0],a=i[1];n.add(t(a,o))}}catch(t){r.e(t)}finally{r.f()}return n}},{key:"filter",value:function(e){var n=this._pairs;return new t(Ai({},Rs,Ys.mark((function t(){var r,i,o,a,s;return Ys.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:r=dl(n),t.prev=1,r.s();case 3:if((i=r.n()).done){t.next=10;break}if(o=uo(i.value,2),a=o[0],s=o[1],!e(s,a)){t.next=8;break}return t.next=8,[a,s];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),r.e(t.t0);case 15:return t.prev=15,r.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,n=dl(this._pairs);try{for(n.s();!(e=n.n()).done;){var r=uo(e.value,2),i=r[0];t(r[1],i)}}catch(t){n.e(t)}finally{n.f()}}},{key:"map",value:function(e){var n=this._pairs;return new t(Ai({},Rs,Ys.mark((function t(){var r,i,o,a,s;return Ys.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:r=dl(n),t.prev=1,r.s();case 3:if((i=r.n()).done){t.next=9;break}return o=uo(i.value,2),a=o[0],s=o[1],t.next=7,[a,e(s,a)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),r.e(t.t0);case 14:return t.prev=14,r.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=pi(this._pairs),n=e.next();if(n.done)return null;for(var r=n.value[1],i=t(n.value[1],n.value[0]);!(n=e.next()).done;){var o=uo(n.value,2),a=o[0],s=o[1],l=t(s,a);l>i&&(i=l,r=s)}return r}},{key:"min",value:function(t){var e=pi(this._pairs),n=e.next();if(n.done)return null;for(var r=n.value[1],i=t(n.value[1],n.value[0]);!(n=e.next()).done;){var o=uo(n.value,2),a=o[0],s=o[1],l=t(s,a);l<i&&(i=l,r=s)}return r}},{key:"reduce",value:function(t,e){var n,r=dl(this._pairs);try{for(r.s();!(n=r.n()).done;){var i=uo(n.value,2),o=i[0];e=t(e,i[1],o)}}catch(t){r.e(t)}finally{r.f()}return e}},{key:"sort",value:function(e){var n=this;return new t(Ai({},Rs,(function(){var t;return pi(ei(t=ko(n._pairs)).call(t,(function(t,n){var r=uo(t,2),i=r[0],o=r[1],a=uo(n,2),s=a[0],l=a[1];return e(o,l,i,s)})))})))}}]),t}(),kl=function(){console.warn("Type coercion has been deprecated. Please, use data pipes instead. See https://visjs.github.io/vis-data/data/datapipe.html#TypeCoercion for more details with working migration example.")},Dl=function(t){fs(n,t);var e=fl(n);function n(t,r){var i;if(Ma(this,n),i=e.call(this),t&&!Kt(t)&&(r=t,t=[]),i._options=r||{},i._data=new Es,i.length=0,i._idProp=i._options.fieldId||"id",i._type={},i._options.type){kl();for(var o=co(i._options.type),a=0,s=o.length;a<s;a++){var l=o[a],u=i._options.type[l];i._type[l]="Date"==u||"ISODate"==u||"ASPDate"==u?"Date":u}}return t&&t.length&&i.add(t),i.setOptions(r),i}return Ca(n,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),delete this._queue):(this._queue||(this._queue=bl.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===rr(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var n,r=this,i=[];if(Kt(t)){var o=go(t).call(t,(function(t){return t[r._idProp]}));if(ls(o).call(o,(function(t){return r._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var a=0,s=t.length;a<s;a++)n=this._addItem(t[a]),i.push(n)}else{if(!t||"object"!==rr(t))throw new Error("Unknown dataType");n=this._addItem(t),i.push(n)}return i.length&&this._trigger("add",{items:i},e),i}},{key:"update",value:function(t,e){var n=this,r=[],i=[],o=[],a=[],s=this._idProp,l=function(t){var e=t[s];if(null!=e&&n._data.has(e)){var l=t,u=ft({},n._data.get(e)),h=n._updateItem(l);i.push(h),a.push(l),o.push(u)}else{var c=n._addItem(t);r.push(c)}};if(Kt(t))for(var u=0,h=t.length;u<h;u++)t[u]&&"object"===rr(t[u])?l(t[u]):console.warn("Ignoring input item, which is not an object at index "+u);else{if(!t||"object"!==rr(t))throw new Error("Unknown dataType");l(t)}if(r.length&&this._trigger("add",{items:r},e),i.length){var c={items:i,oldData:o,data:a};this._trigger("update",c,e)}return $t(r).call(r,i)}},{key:"updateOnly",value:function(t,e){var n,r=this;Kt(t)||(t=[t]);var i=go(n=go(t).call(t,(function(t){var e=r._data.get(t[r._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(n,(function(t){var e=t.oldData,n=t.update,i=e[r._idProp],o=function(t){for(var e,n=arguments.length,r=new Array(n>1?n-1:0),i=1;i<n;i++)r[i-1]=arguments[i];return Co.apply(void 0,$t(e=[{},t]).call(e,r))}(e,n);return r._data.set(i,o),{id:i,oldData:e,updatedData:o}}));if(i.length){var o={items:go(i).call(i,(function(t){return t.id})),oldData:go(i).call(i,(function(t){return t.oldData})),data:go(i).call(i,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var n=void 0,r=void 0,i=void 0;wl(t)?(n=t,i=e):Kt(t)?(r=t,i=e):i=t;var o=i&&"Object"===i.returnType?"Object":"Array",a=i&&i.type||this._options.type,s=i&&zr(i),l=[],u=null,h=null,c=null;if(null!=n)(u=this._getItem(n,a))&&s&&!s(u)&&(u=null);else if(null!=r)for(var f=0,d=r.length;f<d;f++)null==(u=this._getItem(r[f],a))||s&&!s(u)||l.push(u);else for(var p,v=0,y=(h=ko(ns(p=this._data).call(p))).length;v<y;v++)c=h[v],null==(u=this._getItem(c,a))||s&&!s(u)||l.push(u);if(i&&i.order&&null==n&&this._sort(l,i.order),i&&i.fields){var m=i.fields;if(null!=n&&null!=u)u=this._filterFields(u,m);else for(var g=0,_=l.length;g<_;g++)l[g]=this._filterFields(l[g],m)}if("Object"==o){for(var w={},b=0,x=l.length;b<x;b++){var S=l[b];w[S[this._idProp]]=S}return w}return null!=n?u:l}},{key:"getIds",value:function(t){var e,n,r=this._data,i=t&&zr(t),o=t&&t.order,a=t&&t.type||this._options.type,s=ko(ns(r).call(r)),l=[];if(i)if(o){n=[];for(var u=0,h=s.length;u<h;u++){var c=s[u];i(e=this._getItem(c,a))&&n.push(e)}this._sort(n,o);for(var f=0,d=n.length;f<d;f++)l.push(n[f][this._idProp])}else for(var p=0,v=s.length;p<v;p++){var y=s[p];i(e=this._getItem(y,a))&&l.push(e[this._idProp])}else if(o){n=[];for(var m=0,g=s.length;m<g;m++){var _=s[m];n.push(r.get(_))}this._sort(n,o);for(var w=0,b=n.length;w<b;w++)l.push(n[w][this._idProp])}else for(var x=0,S=s.length;x<S;x++){var k=s[x];e=r.get(k),l.push(e[this._idProp])}return l}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var n=e&&zr(e),r=e&&e.type||this._options.type,i=this._data,o=ko(ns(i).call(i));if(e&&e.order)for(var a=this.get(e),s=0,l=a.length;s<l;s++){var u=a[s];t(u,u[this._idProp])}else for(var h=0,c=o.length;h<c;h++){var f=o[h],d=this._getItem(f,r);n&&!n(d)||t(d,f)}}},{key:"map",value:function(t,e){for(var n=e&&zr(e),r=e&&e.type||this._options.type,i=[],o=this._data,a=ko(ns(o).call(o)),s=0,l=a.length;s<l;s++){var u=a[s],h=this._getItem(u,r);n&&!n(h)||i.push(t(h,u))}return e&&e.order&&this._sort(i,e.order),i}},{key:"_filterFields",value:function(t,e){var n;return t?tl(n=Kt(e)?e:co(e)).call(n,(function(e,n){return e[n]=t[n],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var n=e;ei(t).call(t,(function(t,e){var r=t[n],i=e[n];return r>i?1:r<i?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");ei(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var n=[],r=[],i=Kt(t)?t:[t],o=0,a=i.length;o<a;o++){var s=this._remove(i[o]);if(s){var l=s[this._idProp];null!=l&&(n.push(l),r.push(s))}}return n.length&&this._trigger("remove",{items:n,oldData:r},e),n}},{key:"_remove",value:function(t){var e;if(wl(t)?e=t:t&&"object"===rr(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var n=this._data.get(e)||null;return this._data.delete(e),--this.length,n}return null}},{key:"clear",value:function(t){for(var e,n=ko(ns(e=this._data).call(e)),r=[],i=0,o=n.length;i<o;i++)r.push(this._data.get(n[i]));return this._data.clear(),this.length=0,this._trigger("remove",{items:n,oldData:r},t),n}},{key:"max",value:function(t){var e,n,r=null,i=null,o=dl(wr(e=this._data).call(e));try{for(o.s();!(n=o.n()).done;){var a=n.value,s=a[t];"number"==typeof s&&(null==i||s>i)&&(r=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return r||null}},{key:"min",value:function(t){var e,n,r=null,i=null,o=dl(wr(e=this._data).call(e));try{for(o.s();!(n=o.n()).done;){var a=n.value,s=a[t];"number"==typeof s&&(null==i||s<i)&&(r=a,i=s)}}catch(t){o.e(t)}finally{o.f()}return r||null}},{key:"distinct",value:function(t){for(var e=this._data,n=ko(ns(e).call(e)),r=[],i=this._options.type&&this._options.type[t]||null,o=0,a=0,s=n.length;a<s;a++){for(var l=n[a],u=e.get(l)[t],h=!1,c=0;c<o;c++)if(r[c]==u){h=!0;break}h||void 0===u||(r[o]=u,o++)}if(i)for(var f=0,d=r.length;f<d;f++)r[f]=_l(r[f],i);return r}},{key:"_addItem",value:function(t){var e=t[this._idProp];if(null!=e){if(this._data.has(e))throw new Error("Cannot add item: item with id "+e+" already exists")}else e=ul(),t[this._idProp]=e;for(var n={},r=co(t),i=0,o=r.length;i<o;i++){var a=r[i],s=this._type[a];n[a]=_l(t[a],s)}return this._data.set(e,n),++this.length,e}},{key:"_getItem",value:function(t,e){var n,r=this._data.get(t);if(!r)return null;var i=co(r);if(e){kl(),n={};for(var o=0,a=i.length;o<a;o++){var s=i[o],l=r[s];n[s]=_l(l,e[s])}}else n=function(t){for(var e=1;e<arguments.length;e++){var n,r=null!=arguments[e]?arguments[e]:{};if(e%2)yr(n=cl(Object(r),!0)).call(n,(function(e){Ai(t,e,r[e])}));else if(si)oi(t,si(r));else{var i;yr(i=cl(Object(r))).call(i,(function(e){ii(t,e,hi(r,e))}))}}return t}({},r);return null==n[this._idProp]&&(n[this._idProp]=r.id),n}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Da(t)+")");var n=this._data.get(e);if(!n)throw new Error("Cannot update item: no item with id "+e+" found");for(var r=co(t),i=0,o=r.length;i<o;i++){var a=r[i],s=this._type[a];n[a]=_l(t[a],s)}return e}},{key:"stream",value:function(t){if(t){var e=this._data;return new Sl(Ai({},Rs,Ys.mark((function n(){var r,i,o,a;return Ys.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:r=dl(t),n.prev=1,r.s();case 3:if((i=r.n()).done){n.next=11;break}if(o=i.value,null==(a=e.get(o))){n.next=9;break}return n.next=9,[o,a];case 9:n.next=3;break;case 11:n.next=16;break;case 13:n.prev=13,n.t0=n.catch(1),r.e(n.t0);case 16:return n.prev=16,r.f(),n.finish(16);case 19:case"end":return n.stop()}}),n,null,[[1,13,16,19]])}))))}var n;return new Sl(Ai({},Rs,rl(n=Qa(this._data)).call(n,this._data)))}}]),n}(xl),Ml=function(t){fs(n,t);var e=fl(n);function n(t,r){var i,o;return Ma(this,n),(o=e.call(this)).length=0,o._ids=new As,o._options=r||{},o._listener=rl(i=o._onEvent).call(i,za(o)),o.setData(t),o}return Ca(n,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:zr(this._options)}),n=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:n})}if(null!=t){this._data=t;for(var r=this._data.getIds({filter:zr(this._options)}),i=0,o=r.length;i<o;i++){var a=r[i];this._ids.add(a)}this.length=r.length,this._trigger("add",{items:r})}else this._data=new Dl;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:zr(this._options)}),e=ko(this._ids),n={},r=[],i=[],o=[],a=0,s=t.length;a<s;a++){var l=t[a];n[l]=!0,this._ids.has(l)||(r.push(l),this._ids.add(l))}for(var u=0,h=e.length;u<h;u++){var c=e[u],f=this._data.get(c);null==f?console.error("If you see this, report it please."):n[c]||(i.push(c),o.push(f),this._ids.delete(c))}this.length+=r.length-i.length,r.length&&this._trigger("add",{items:r}),i.length&&this._trigger("remove",{items:i,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var n,r=null;wl(t)||Kt(t)?(r=t,n=e):n=t;var i=ft({},this._options,n),o=zr(this._options),a=n&&zr(n);return o&&a&&(i.filter=function(t){return o(t)&&a(t)}),null==r?this._data.get(i):this._data.get(r,i)}},{key:"getIds",value:function(t){if(this._data.length){var e,n=zr(this._options),r=null!=t?zr(t):null;return e=r?n?function(t){return n(t)&&r(t)}:r:n,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var n,r,i=zr(this._options),o=e&&zr(e);r=o?i?function(t){return i(t)&&o(t)}:o:i,yr(n=this._data).call(n,t,{filter:r,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var n,r,i=zr(this._options),o=e&&zr(e);return r=o?i?function(t){return i(t)&&o(t)}:o:i,go(n=this._data).call(n,t,{filter:r,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Ai({},Rs,rl(e=ns(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;(null===(t=this._data)||void 0===t?void 0:t.off)&&this._data.off("*",this._listener);var e="This data view has already been disposed of.";ii(this,"_data",{get:function(){throw new Error(e)},set:function(){throw new Error(e)},configurable:!1})}},{key:"_onEvent",value:function(t,e,n){if(e&&e.items&&this._data){var r=e.items,i=[],o=[],a=[],s=[],l=[],u=[];switch(t){case"add":for(var h=0,c=r.length;h<c;h++){var f=r[h];this.get(f)&&(this._ids.add(f),i.push(f))}break;case"update":for(var d=0,p=r.length;d<p;d++){var v=r[d];this.get(v)?this._ids.has(v)?(o.push(v),l.push(e.data[d]),s.push(e.oldData[d])):(this._ids.add(v),i.push(v)):this._ids.has(v)&&(this._ids.delete(v),a.push(v),u.push(e.oldData[d]))}break;case"remove":for(var y=0,m=r.length;y<m;y++){var g=r[y];this._ids.has(g)&&(this._ids.delete(g),a.push(g),u.push(e.oldData[y]))}}this.length+=i.length-a.length,i.length&&this._trigger("add",{items:i},n),o.length&&this._trigger("update",{items:o,oldData:s,data:l},n),a.length&&this._trigger("remove",{items:a,oldData:u},n)}}}]),n}(xl);function Ol(){this.min=void 0,this.max=void 0}Ol.prototype.adjust=function(t){void 0!==t&&((void 0===this.min||this.min>t)&&(this.min=t),(void 0===this.max||this.max<t)&&(this.max=t))},Ol.prototype.combine=function(t){this.add(t.min),this.add(t.max)},Ol.prototype.expand=function(t){if(void 0!==t){var e=this.min-t,n=this.max+t;if(e>n)throw new Error("Passed expansion value makes range invalid");this.min=e,this.max=n}},Ol.prototype.range=function(){return this.max-this.min},Ol.prototype.center=function(){return(this.min+this.max)/2};var Tl=Ol;function Cl(t,e,n){this.dataGroup=t,this.column=e,this.graph=n,this.index=void 0,this.value=void 0,this.values=t.getDistinctValues(this.column),wr(this).length>0&&this.selectValue(0),this.dataPoints=[],this.loaded=!1,this.onLoadCallback=void 0,n.animationPreload?(this.loaded=!1,this.loadInBackground()):this.loaded=!0}function Ll(){this.dataTable=null}Cl.prototype.isLoaded=function(){return this.loaded},Cl.prototype.getLoadedProgress=function(){for(var t=wr(this).length,e=0;this.dataPoints[e];)e++;return Math.round(e/t*100)},Cl.prototype.getLabel=function(){return this.graph.filterLabel},Cl.prototype.getColumn=function(){return this.column},Cl.prototype.getSelectedValue=function(){if(void 0!==this.index)return wr(this)[this.index]},Cl.prototype.getValues=function(){return wr(this)},Cl.prototype.getValue=function(t){if(t>=wr(this).length)throw new Error("Index out of range");return wr(this)[t]},Cl.prototype._getDataPoints=function(t){if(void 0===t&&(t=this.index),void 0===t)return[];var e;if(this.dataPoints[t])e=this.dataPoints[t];else{var n={};n.column=this.column,n.value=wr(this)[t];var r=new Ml(this.dataGroup.getDataSet(),{filter:function(t){return t[n.column]==n.value}}).get();e=this.dataGroup._getDataPoints(r),this.dataPoints[t]=e}return e},Cl.prototype.setOnLoadCallback=function(t){this.onLoadCallback=t},Cl.prototype.selectValue=function(t){if(t>=wr(this).length)throw new Error("Index out of range");this.index=t,this.value=wr(this)[t]},Cl.prototype.loadInBackground=function(t){void 0===t&&(t=0);var e=this.graph.frame;if(t<wr(this).length){void 0===e.progress&&(e.progress=document.createElement("DIV"),e.progress.style.position="absolute",e.progress.style.color="gray",e.appendChild(e.progress));var n=this.getLoadedProgress();e.progress.innerHTML="Loading animation... "+n+"%",e.progress.style.bottom="60px",e.progress.style.left="10px";var r=this;bt((function(){r.loadInBackground(t+1)}),10),this.loaded=!1}else this.loaded=!0,void 0!==e.progress&&(e.removeChild(e.progress),e.progress=void 0),this.onLoadCallback&&this.onLoadCallback()},Ll.prototype.initializeData=function(t,e,n){if(void 0!==e){var r;if(Kt(e)&&(e=new Dl(e)),!(e instanceof Dl||e instanceof Ml))throw new Error("Array, DataSet, or DataView expected");if(0!=(r=e.get()).length){this.style=n,this.dataSet&&this.dataSet.off("*",this._onChange),this.dataSet=e,this.dataTable=r;var i=this;this._onChange=function(){t.setData(i.dataSet)},this.dataSet.on("*",this._onChange),this.colX="x",this.colY="y",this.colZ="z";var o=t.hasBars(n);if(o&&(void 0!==t.defaultXBarWidth?this.xBarWidth=t.defaultXBarWidth:this.xBarWidth=this.getSmallestDifference(r,this.colX)||1,void 0!==t.defaultYBarWidth?this.yBarWidth=t.defaultYBarWidth:this.yBarWidth=this.getSmallestDifference(r,this.colY)||1),this._initializeRange(r,this.colX,t,o),this._initializeRange(r,this.colY,t,o),this._initializeRange(r,this.colZ,t,!1),r[0].hasOwnProperty("style")){this.colValue="style";var a=this.getColumnRange(r,this.colValue);this._setRangeDefaults(a,t.defaultValueMin,t.defaultValueMax),this.valueRange=a}else this.colValue="z",this.valueRange=this.zRange;return this.getDataTable()[0].hasOwnProperty("filter")&&void 0===this.dataFilter&&(this.dataFilter=new Cl(this,"filter",t),this.dataFilter.setOnLoadCallback((function(){t.redraw()}))),this.dataFilter?this.dataFilter._getDataPoints():this._getDataPoints(this.getDataTable())}}},Ll.prototype._collectRangeSettings=function(t,e){var n;if(-1==Zr(n=["x","y","z"]).call(n,t))throw new Error("Column '"+t+"' invalid");var r=t.toUpperCase();return{barWidth:this[t+"BarWidth"],min:e["default"+r+"Min"],max:e["default"+r+"Max"],step:e["default"+r+"Step"],range_label:t+"Range",step_label:t+"Step"}},Ll.prototype._initializeRange=function(t,e,n,r){var i=this._collectRangeSettings(e,n),o=this.getColumnRange(t,e);r&&"z"!=e&&o.expand(i.barWidth/2),this._setRangeDefaults(o,i.min,i.max),this[i.range_label]=o,this[i.step_label]=void 0!==i.step?i.step:o.range()/5},Ll.prototype.getDistinctValues=function(t,e){void 0===e&&(e=this.dataTable);for(var n=[],r=0;r<e.length;r++){var i=e[r][t]||0;-1===Zr(n).call(n,i)&&n.push(i)}return ei(n).call(n,(function(t,e){return t-e}))},Ll.prototype.getSmallestDifference=function(t,e){for(var n=this.getDistinctValues(t,e),r=null,i=1;i<n.length;i++){var o=n[i]-n[i-1];(null==r||r>o)&&(r=o)}return r},Ll.prototype.getColumnRange=function(t,e){for(var n=new Tl,r=0;r<t.length;r++){var i=t[r][e];n.adjust(i)}return n},Ll.prototype.getNumberOfRows=function(){return this.dataTable.length},Ll.prototype._setRangeDefaults=function(t,e,n){void 0!==e&&(t.min=e),void 0!==n&&(t.max=n),t.max<=t.min&&(t.max=t.min+1)},Ll.prototype.getDataTable=function(){return this.dataTable},Ll.prototype.getDataSet=function(){return this.dataSet},Ll.prototype.getDataPoints=function(t){for(var e=[],n=0;n<t.length;n++){var r=new Zo;r.x=t[n][this.colX]||0,r.y=t[n][this.colY]||0,r.z=t[n][this.colZ]||0,r.data=t[n],r.value=t[n][this.colValue]||0;var i={};i.point=r,i.bottom=new Zo(r.x,r.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Ll.prototype.initDataAsMatrix=function(t){var e,n,r,i,o=this.getDistinctValues(this.colX,t),a=this.getDistinctValues(this.colY,t),s=this.getDataPoints(t),l=[];for(r=0;r<s.length;r++){i=s[r];var u=Zr(o).call(o,i.point.x),h=Zr(a).call(a,i.point.y);void 0===l[u]&&(l[u]=[]),l[u][h]=i}for(e=0;e<l.length;e++)for(n=0;n<l[e].length;n++)l[e][n]&&(l[e][n].pointRight=e<l.length-1?l[e+1][n]:void 0,l[e][n].pointTop=n<l[e].length-1?l[e][n+1]:void 0,l[e][n].pointCross=e<l.length-1&&n<l[e].length-1?l[e+1][n+1]:void 0);return s},Ll.prototype.getInfo=function(){var t=this.dataFilter;if(t)return t.getLabel()+": "+t.getSelectedValue()},Ll.prototype.reload=function(){this.dataTable&&this.setData(this.dataTable)},Ll.prototype._getDataPoints=function(t){var e=[];if(this.style===aa.GRID||this.style===aa.SURFACE)e=this.initDataAsMatrix(t);else if(e=this.getDataPoints(t),this.style===aa.LINE)for(var n=0;n<e.length;n++)n>0&&(e[n-1].pointNext=e[n]);return e},Pl.STYLE=aa;function Pl(t,e,n){if(!(this instanceof Pl))throw new SyntaxError("Constructor must be called with the new operator");this.containerElement=t,this.dataGroup=new Ll,this.dataPoints=null,this.create(),function(t,e){if(void 0===t||ca(t))throw new Error("No DEFAULTS passed");if(void 0===e)throw new Error("No dst passed");ha=t,da(t,e,la),da(t,e,ua,"default"),va(t,e),e.margin=10,e.showTooltip=!1,e.onclick_callback=null,e.eye=new Zo(0,0,-1)}(Pl.DEFAULTS,this),this.colX=void 0,this.colY=void 0,this.colZ=void 0,this.colValue=void 0,this.setOptions(n),this.setData(e)}function Al(t){return"clientX"in t?t.clientX:t.targetTouches[0]&&t.targetTouches[0].clientX||0}function El(t){return"clientY"in t?t.clientY:t.targetTouches[0]&&t.targetTouches[0].clientY||0}Pl.DEFAULTS={width:"400px",height:"400px",filterLabel:"time",legendLabel:"value",xLabel:"x",yLabel:"y",zLabel:"z",xValueLabel:function(t){return t},yValueLabel:function(t){return t},zValueLabel:function(t){return t},showXAxis:!0,showYAxis:!0,showZAxis:!0,showGrayBottom:!1,showGrid:!0,showPerspective:!0,showShadow:!1,showSurfaceGrid:!0,keepAspectRatio:!0,rotateAxisLabels:!0,verticalRatio:.5,dotSizeRatio:.02,dotSizeMinFraction:.5,dotSizeMaxFraction:2.5,showAnimationControls:void 0,animationInterval:1e3,animationPreload:!1,animationAutoStart:void 0,axisFontSize:14,axisFontType:"arial",axisColor:"#4D4D4D",gridColor:"#D3D3D3",xCenter:"55%",yCenter:"50%",style:Pl.STYLE.DOT,tooltip:!1,tooltipDelay:300,tooltipStyle:{content:{padding:"10px",border:"1px solid #4d4d4d",color:"#1a1a1a",background:"rgba(255,255,255,0.7)",borderRadius:"2px",boxShadow:"5px 5px 10px rgba(128,128,128,0.5)"},line:{height:"40px",width:"0",borderLeft:"1px solid #4d4d4d",pointerEvents:"none"},dot:{height:"0",width:"0",border:"5px solid #4d4d4d",borderRadius:"5px",pointerEvents:"none"}},dataColor:{fill:"#7DC1FF",stroke:"#3267D2",strokeWidth:1},surfaceColors:void 0,colormap:void 0,cameraPosition:{horizontal:1,vertical:.5,distance:1.7},zoomable:!0,ctrlToZoom:!1,showLegend:void 0,backgroundColor:void 0,xBarWidth:void 0,yBarWidth:void 0,valueMin:void 0,valueMax:void 0,xMin:void 0,xMax:void 0,xStep:void 0,yMin:void 0,yMax:void 0,yStep:void 0,zMin:void 0,zMax:void 0,zStep:void 0},ni(Pl.prototype),Pl.prototype._setScale=function(){this.scale=new Zo(1/this.xRange.range(),1/this.yRange.range(),1/this.zRange.range()),this.keepAspectRatio&&(this.scale.x<this.scale.y?this.scale.y=this.scale.x:this.scale.x=this.scale.y),this.scale.z*=this.verticalRatio,void 0!==this.valueRange&&(this.scale.value=1/this.valueRange.range());var t=this.xRange.center()*this.scale.x,e=this.yRange.center()*this.scale.y,n=this.zRange.center()*this.scale.z;this.camera.setArmLocation(t,e,n)},Pl.prototype._convert3Dto2D=function(t){var e=this._convertPointToTranslation(t);return this._convertTranslationToScreen(e)},Pl.prototype._convertPointToTranslation=function(t){var e=this.camera.getCameraLocation(),n=this.camera.getCameraRotation(),r=t.x*this.scale.x,i=t.y*this.scale.y,o=t.z*this.scale.z,a=e.x,s=e.y,l=e.z,u=Math.sin(n.x),h=Math.cos(n.x),c=Math.sin(n.y),f=Math.cos(n.y),d=Math.sin(n.z),p=Math.cos(n.z);return new Zo(f*(d*(i-s)+p*(r-a))-c*(o-l),u*(f*(o-l)+c*(d*(i-s)+p*(r-a)))+h*(p*(i-s)-d*(r-a)),h*(f*(o-l)+c*(d*(i-s)+p*(r-a)))-u*(p*(i-s)-d*(r-a)))},Pl.prototype._convertTranslationToScreen=function(t){var e,n,r=this.eye.x,i=this.eye.y,o=this.eye.z,a=t.x,s=t.y,l=t.z;return this.showPerspective?(e=o/l*(a-r),n=o/l*(s-i)):(e=a*(-o/this.camera.getArmLength()),n=s*(-o/this.camera.getArmLength())),new Xo(this.currentXCenter+e*this.frame.canvas.clientWidth,this.currentYCenter-n*this.frame.canvas.clientWidth)},Pl.prototype._calcTranslations=function(t){for(var e=0;e<t.length;e++){var n=t[e];n.trans=this._convertPointToTranslation(n.point),n.screen=this._convertTranslationToScreen(n.trans);var r=this._convertPointToTranslation(n.bottom);n.dist=this.showPerspective?r.length():-r.z}ei(t).call(t,(function(t,e){return e.dist-t.dist}))},Pl.prototype._initializeRanges=function(){var t=this.dataGroup;this.xRange=t.xRange,this.yRange=t.yRange,this.zRange=t.zRange,this.valueRange=t.valueRange,this.xStep=t.xStep,this.yStep=t.yStep,this.zStep=t.zStep,this.xBarWidth=t.xBarWidth,this.yBarWidth=t.yBarWidth,this.colX=t.colX,this.colY=t.colY,this.colZ=t.colZ,this.colValue=t.colValue,this._setScale()},Pl.prototype.getDataPoints=function(t){for(var e=[],n=0;n<t.length;n++){var r=new Zo;r.x=t[n][this.colX]||0,r.y=t[n][this.colY]||0,r.z=t[n][this.colZ]||0,r.data=t[n],r.value=t[n][this.colValue]||0;var i={};i.point=r,i.bottom=new Zo(r.x,r.y,this.zRange.min),i.trans=void 0,i.screen=void 0,e.push(i)}return e},Pl.prototype._getDataPoints=function(t){var e,n,r,i,o=[];if(this.style===Pl.STYLE.GRID||this.style===Pl.STYLE.SURFACE){var a=this.dataGroup.getDistinctValues(this.colX,t),s=this.dataGroup.getDistinctValues(this.colY,t);o=this.getDataPoints(t);var l=[];for(r=0;r<o.length;r++){i=o[r];var u=Zr(a).call(a,i.point.x),h=Zr(s).call(s,i.point.y);void 0===l[u]&&(l[u]=[]),l[u][h]=i}for(e=0;e<l.length;e++)for(n=0;n<l[e].length;n++)l[e][n]&&(l[e][n].pointRight=e<l.length-1?l[e+1][n]:void 0,l[e][n].pointTop=n<l[e].length-1?l[e][n+1]:void 0,l[e][n].pointCross=e<l.length-1&&n<l[e].length-1?l[e+1][n+1]:void 0)}else if(o=this.getDataPoints(t),this.style===Pl.STYLE.LINE)for(r=0;r<o.length;r++)r>0&&(o[r-1].pointNext=o[r]);return o},Pl.prototype.create=function(){for(;this.containerElement.hasChildNodes();)this.containerElement.removeChild(this.containerElement.firstChild);this.frame=document.createElement("div"),this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas);var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t),this.frame.filter=document.createElement("div"),zr(this.frame).style.position="absolute",zr(this.frame).style.bottom="0px",zr(this.frame).style.left="0px",zr(this.frame).style.width="100%",this.frame.appendChild(zr(this.frame));var e=this;Go(this.frame.canvas,"mousedown",(function(t){e._onMouseDown(t)})),Go(this.frame.canvas,"touchstart",(function(t){e._onTouchStart(t)})),Go(this.frame.canvas,"mousewheel",(function(t){e._onWheel(t)})),Go(this.frame.canvas,"mousemove",(function(t){e._onTooltip(t)})),Go(this.frame.canvas,"click",(function(t){e._onClick(t)})),this.containerElement.appendChild(this.frame)},Pl.prototype._setSize=function(t,e){this.frame.style.width=t,this.frame.style.height=e,this._resizeCanvas()},Pl.prototype._resizeCanvas=function(){this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=this.frame.canvas.clientWidth,this.frame.canvas.height=this.frame.canvas.clientHeight,zr(this.frame).style.width=this.frame.canvas.clientWidth-20+"px"},Pl.prototype.animationStart=function(){if(this.animationAutoStart&&this.dataGroup.dataFilter){if(!zr(this.frame)||!zr(this.frame).slider)throw new Error("No animation available");zr(this.frame).slider.play()}},Pl.prototype.animationStop=function(){zr(this.frame)&&zr(this.frame).slider&&zr(this.frame).slider.stop()},Pl.prototype._resizeCenter=function(){"%"===this.xCenter.charAt(this.xCenter.length-1)?this.currentXCenter=Er(this.xCenter)/100*this.frame.canvas.clientWidth:this.currentXCenter=Er(this.xCenter),"%"===this.yCenter.charAt(this.yCenter.length-1)?this.currentYCenter=Er(this.yCenter)/100*(this.frame.canvas.clientHeight-zr(this.frame).clientHeight):this.currentYCenter=Er(this.yCenter)},Pl.prototype.getCameraPosition=function(){var t=this.camera.getArmRotation();return t.distance=this.camera.getArmLength(),t},Pl.prototype._readData=function(t){this.dataPoints=this.dataGroup.initializeData(this,t,this.style),this._initializeRanges(),this._redrawFilter()},Pl.prototype.setData=function(t){null!=t&&(this._readData(t),this.redraw(),this.animationStart())},Pl.prototype.setOptions=function(t){void 0!==t&&(!0===Aa.validate(t,ja)&&console.log("%cErrors have been found in the supplied options object.",Pa),this.animationStop(),function(t,e){if(void 0!==t){if(void 0===e)throw new Error("No dst passed");if(void 0===ha||ca(ha))throw new Error("DEFAULTS not set for module Settings");pa(t,e,la),pa(t,e,ua,"default"),va(t,e)}}(t,this),this.setPointDrawingMethod(),this._setSize(this.width,this.height),this.setAxisLabelMethod(),this.setData(this.dataGroup.getDataTable()),this.animationStart())},Pl.prototype.setPointDrawingMethod=function(){var t=void 0;switch(this.style){case Pl.STYLE.BAR:t=this._redrawBarGraphPoint;break;case Pl.STYLE.BARCOLOR:t=this._redrawBarColorGraphPoint;break;case Pl.STYLE.BARSIZE:t=this._redrawBarSizeGraphPoint;break;case Pl.STYLE.DOT:t=this._redrawDotGraphPoint;break;case Pl.STYLE.DOTLINE:t=this._redrawDotLineGraphPoint;break;case Pl.STYLE.DOTCOLOR:t=this._redrawDotColorGraphPoint;break;case Pl.STYLE.DOTSIZE:t=this._redrawDotSizeGraphPoint;break;case Pl.STYLE.SURFACE:t=this._redrawSurfaceGraphPoint;break;case Pl.STYLE.GRID:t=this._redrawGridGraphPoint;break;case Pl.STYLE.LINE:t=this._redrawLineGraphPoint;break;default:throw new Error("Can not determine point drawing method for graph style '"+this.style+"'")}this._pointDrawingMethod=t},Pl.prototype.setAxisLabelMethod=function(){this.rotateAxisLabels?(this._drawAxisLabelX=this.drawAxisLabelXRotate,this._drawAxisLabelY=this.drawAxisLabelYRotate,this._drawAxisLabelZ=this.drawAxisLabelZRotate):(this._drawAxisLabelX=this.drawAxisLabelX,this._drawAxisLabelY=this.drawAxisLabelY,this._drawAxisLabelZ=this.drawAxisLabelZ)},Pl.prototype.redraw=function(){if(void 0===this.dataPoints)throw new Error("Graph data not initialized");this._resizeCanvas(),this._resizeCenter(),this._redrawSlider(),this._redrawClear(),this._redrawAxis(),this._redrawDataGraph(),this._redrawInfo(),this._redrawLegend()},Pl.prototype._getContext=function(){var t=this.frame.canvas.getContext("2d");return t.lineJoin="round",t.lineCap="round",t},Pl.prototype._redrawClear=function(){var t=this.frame.canvas;t.getContext("2d").clearRect(0,0,t.width,t.height)},Pl.prototype._dotSize=function(){return this.frame.clientWidth*this.dotSizeRatio},Pl.prototype._getLegendWidth=function(){var t;this.style===Pl.STYLE.DOTSIZE?t=this._dotSize()*this.dotSizeMaxFraction:t=this.style===Pl.STYLE.BARSIZE?this.xBarWidth:20;return t},Pl.prototype._redrawLegend=function(){if(!0===this.showLegend&&this.style!==Pl.STYLE.LINE&&this.style!==Pl.STYLE.BARSIZE){var t=this.style===Pl.STYLE.BARSIZE||this.style===Pl.STYLE.DOTSIZE,e=this.style===Pl.STYLE.DOTSIZE||this.style===Pl.STYLE.DOTCOLOR||this.style===Pl.STYLE.SURFACE||this.style===Pl.STYLE.BARCOLOR,n=Math.max(.25*this.frame.clientHeight,100),r=this.margin,i=this._getLegendWidth(),o=this.frame.clientWidth-this.margin,a=o-i,s=r+n,l=this._getContext();if(l.lineWidth=1,l.font="14px arial",!1===t){var u,h=n;for(u=0;u<h;u++){var c=1-(u-0)/(h-0),f=this._colormap(c,1);l.strokeStyle=f,l.beginPath(),l.moveTo(a,r+u),l.lineTo(o,r+u),l.stroke()}l.strokeStyle=this.axisColor,l.strokeRect(a,r,i,n)}else{var d;this.style===Pl.STYLE.DOTSIZE?d=i*(this.dotSizeMinFraction/this.dotSizeMaxFraction):(this.style,Pl.STYLE.BARSIZE),l.strokeStyle=this.axisColor,l.fillStyle=Sr(this.dataColor),l.beginPath(),l.moveTo(a,r),l.lineTo(o,r),l.lineTo(a+d,s),l.lineTo(a,s),l.closePath(),Sr(l).call(l),l.stroke()}var p,v,y=e?this.valueRange.min:this.zRange.min,m=e?this.valueRange.max:this.zRange.max,g=new Jo(y,m,(m-y)/5,!0);for(g.start(!0);!g.end();)u=s-(g.getCurrent()-y)/(m-y)*n,p=new Xo(a-5,u),v=new Xo(a,u),this._line(l,p,v),l.textAlign="right",l.textBaseline="middle",l.fillStyle=this.axisColor,l.fillText(g.getCurrent(),a-10,u),g.next();l.textAlign="right",l.textBaseline="top";var _=this.legendLabel;l.fillText(_,o,s+this.margin)}},Pl.prototype._redrawFilter=function(){var t=this.dataGroup.dataFilter,e=zr(this.frame);if(e.innerHTML="",t){var n=new qo(e,{visible:this.showAnimationControls});e.slider=n,e.style.padding="10px",n.setValues(wr(t)),n.setPlayInterval(this.animationInterval);var r=this;n.setOnChangeCallback((function(){var t=r.dataGroup.dataFilter,e=n.getIndex();t.selectValue(e),r.dataPoints=t._getDataPoints(),r.redraw()}))}else e.slider=void 0},Pl.prototype._redrawSlider=function(){void 0!==zr(this.frame).slider&&zr(this.frame).slider.redraw()},Pl.prototype._redrawInfo=function(){var t=this.dataGroup.getInfo();if(void 0!==t){var e=this._getContext();e.font="14px arial",e.lineStyle="gray",e.fillStyle="gray",e.textAlign="left",e.textBaseline="top";var n=this.margin,r=this.margin;e.fillText(t,n,r)}},Pl.prototype._line=function(t,e,n,r){void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e.x,e.y),t.lineTo(n.x,n.y),t.stroke()},Pl.prototype.drawAxisLabelX=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)},Pl.prototype.drawAxisLabelY=function(t,e,n,r,i){void 0===i&&(i=0);var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.textAlign="center",t.textBaseline="top",o.y+=i):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle"):(t.textAlign="left",t.textBaseline="middle"),t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)},Pl.prototype.drawAxisLabelZ=function(t,e,n,r){void 0===r&&(r=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,i.x-r,i.y)},Pl.prototype.drawAxisLabelXRotate=function(t,e,n,r,i){var o=this._convert3Dto2D(e);Math.cos(2*r)>0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,0,0),t.restore()):Math.sin(2*r)<0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y))},Pl.prototype.drawAxisLabelYRotate=function(t,e,n,r,i){var o=this._convert3Dto2D(e);Math.cos(2*r)<0?(t.save(),t.translate(o.x,o.y),t.rotate(-Math.PI/2),t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,0,0),t.restore()):Math.sin(2*r)>0?(t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y)):(t.textAlign="left",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,o.x,o.y))},Pl.prototype.drawAxisLabelZRotate=function(t,e,n,r){void 0===r&&(r=0);var i=this._convert3Dto2D(e);t.textAlign="right",t.textBaseline="middle",t.fillStyle=this.axisColor,t.fillText(n,i.x-r,i.y)},Pl.prototype._line3d=function(t,e,n,r){var i=this._convert3Dto2D(e),o=this._convert3Dto2D(n);this._line(t,i,o,r)},Pl.prototype._redrawAxis=function(){var t,e,n,r,i,o,a,s,l,u,h=this._getContext();h.font=this.axisFontSize/this.camera.getArmLength()+"px "+this.axisFontType;var c,f,d,p=.025/this.scale.x,v=.025/this.scale.y,y=5/this.camera.getArmLength(),m=this.camera.getArmRotation().horizontal,g=new Xo(Math.cos(m),Math.sin(m)),_=this.xRange,w=this.yRange,b=this.zRange;for(h.lineWidth=1,r=void 0===this.defaultXStep,(n=new Jo(_.min,_.max,this.xStep,r)).start(!0);!n.end();){var x=n.getCurrent();if(this.showGrid?(t=new Zo(x,w.min,b.min),e=new Zo(x,w.max,b.min),this._line3d(h,t,e,this.gridColor)):this.showXAxis&&(t=new Zo(x,w.min,b.min),e=new Zo(x,w.min+p,b.min),this._line3d(h,t,e,this.axisColor),t=new Zo(x,w.max,b.min),e=new Zo(x,w.max-p,b.min),this._line3d(h,t,e,this.axisColor)),this.showXAxis){a=g.x>0?w.min:w.max,c=new Zo(x,a,b.min);var S="  "+this.xValueLabel(x)+"  ";this._drawAxisLabelX.call(this,h,c,S,m,y)}n.next()}for(h.lineWidth=1,r=void 0===this.defaultYStep,(n=new Jo(w.min,w.max,this.yStep,r)).start(!0);!n.end();){var k=n.getCurrent();if(this.showGrid?(t=new Zo(_.min,k,b.min),e=new Zo(_.max,k,b.min),this._line3d(h,t,e,this.gridColor)):this.showYAxis&&(t=new Zo(_.min,k,b.min),e=new Zo(_.min+v,k,b.min),this._line3d(h,t,e,this.axisColor),t=new Zo(_.max,k,b.min),e=new Zo(_.max-v,k,b.min),this._line3d(h,t,e,this.axisColor)),this.showYAxis){o=g.y>0?_.min:_.max,c=new Zo(o,k,b.min);var D="  "+this.yValueLabel(k)+"  ";this._drawAxisLabelY.call(this,h,c,D,m,y)}n.next()}if(this.showZAxis){for(h.lineWidth=1,r=void 0===this.defaultZStep,(n=new Jo(b.min,b.max,this.zStep,r)).start(!0),o=g.x>0?_.min:_.max,a=g.y<0?w.min:w.max;!n.end();){var M=n.getCurrent(),O=new Zo(o,a,M),T=this._convert3Dto2D(O);e=new Xo(T.x-y,T.y),this._line(h,T,e,this.axisColor);var C=this.zValueLabel(M)+" ";this._drawAxisLabelZ.call(this,h,O,C,5),n.next()}h.lineWidth=1,t=new Zo(o,a,b.min),e=new Zo(o,a,b.max),this._line3d(h,t,e,this.axisColor)}this.showXAxis&&(h.lineWidth=1,f=new Zo(_.min,w.min,b.min),d=new Zo(_.max,w.min,b.min),this._line3d(h,f,d,this.axisColor),f=new Zo(_.min,w.max,b.min),d=new Zo(_.max,w.max,b.min),this._line3d(h,f,d,this.axisColor));this.showYAxis&&(h.lineWidth=1,t=new Zo(_.min,w.min,b.min),e=new Zo(_.min,w.max,b.min),this._line3d(h,t,e,this.axisColor),t=new Zo(_.max,w.min,b.min),e=new Zo(_.max,w.max,b.min),this._line3d(h,t,e,this.axisColor));var L=this.xLabel;L.length>0&&this.showXAxis&&(u=.1/this.scale.y,o=(_.max+3*_.min)/4,a=g.x>0?w.min-u:w.max+u,i=new Zo(o,a,b.min),this.drawAxisLabelX(h,i,L,m));var P=this.yLabel;P.length>0&&this.showYAxis&&(l=.1/this.scale.x,o=g.y>0?_.min-l:_.max+l,a=(w.max+3*w.min)/4,i=new Zo(o,a,b.min),this.drawAxisLabelY(h,i,P,m));var A=this.zLabel;A.length>0&&this.showZAxis&&(30,o=g.x>0?_.min:_.max,a=g.y<0?w.min:w.max,s=(b.max+3*b.min)/4,i=new Zo(o,a,s),this.drawAxisLabelZ(h,i,A,30))},Pl.prototype._getStrokeWidth=function(t){return void 0!==t?this.showPerspective?1/-t.trans.z*this.dataColor.strokeWidth:-this.eye.z/this.camera.getArmLength()*this.dataColor.strokeWidth:this.dataColor.strokeWidth},Pl.prototype._redrawBar=function(t,e,n,r,i,o){var a,s=this,l=e.point,u=this.zRange.min,h=[{point:new Zo(l.x-n,l.y-r,l.z)},{point:new Zo(l.x+n,l.y-r,l.z)},{point:new Zo(l.x+n,l.y+r,l.z)},{point:new Zo(l.x-n,l.y+r,l.z)}],c=[{point:new Zo(l.x-n,l.y-r,u)},{point:new Zo(l.x+n,l.y-r,u)},{point:new Zo(l.x+n,l.y+r,u)},{point:new Zo(l.x-n,l.y+r,u)}];yr(h).call(h,(function(t){t.screen=s._convert3Dto2D(t.point)})),yr(c).call(c,(function(t){t.screen=s._convert3Dto2D(t.point)}));var f=[{corners:h,center:Zo.avg(c[0].point,c[2].point)},{corners:[h[0],h[1],c[1],c[0]],center:Zo.avg(c[1].point,c[0].point)},{corners:[h[1],h[2],c[2],c[1]],center:Zo.avg(c[2].point,c[1].point)},{corners:[h[2],h[3],c[3],c[2]],center:Zo.avg(c[3].point,c[2].point)},{corners:[h[3],h[0],c[0],c[3]],center:Zo.avg(c[0].point,c[3].point)}];e.surfaces=f;for(var d=0;d<f.length;d++){a=f[d];var p=this._convertPointToTranslation(a.center);a.dist=this.showPerspective?p.length():-p.z}ei(f).call(f,(function(t,e){var n=e.dist-t.dist;return n||(t.corners===h?1:e.corners===h?-1:0)})),t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=o,t.fillStyle=i;for(var v=2;v<f.length;v++)a=f[v],this._polygon(t,a.corners)},Pl.prototype._polygon=function(t,e,n,r){if(!(e.length<2)){void 0!==n&&(t.fillStyle=n),void 0!==r&&(t.strokeStyle=r),t.beginPath(),t.moveTo(e[0].screen.x,e[0].screen.y);for(var i=1;i<e.length;++i){var o=e[i];t.lineTo(o.screen.x,o.screen.y)}t.closePath(),Sr(t).call(t),t.stroke()}},Pl.prototype._drawCircle=function(t,e,n,r,i){var o=this._calcRadius(e,i);t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=r,t.fillStyle=n,t.beginPath(),t.arc(e.screen.x,e.screen.y,o,0,2*Math.PI,!0),Sr(t).call(t),t.stroke()},Pl.prototype._getColorsRegular=function(t){var e=(t.point.value-this.valueRange.min)*this.scale.value;return{fill:this._colormap(e,1),border:this._colormap(e,.8)}},Pl.prototype._getColorsColor=function(t){var e,n,r;if(t&&t.point&&t.point.data&&t.point.data.style&&(r=t.point.data.style),r&&"object"===rr(r)&&Sr(r)&&r.stroke)return{fill:Sr(r),border:r.stroke};if("string"==typeof t.point.value)e=t.point.value,n=t.point.value;else{var i=(t.point.value-this.valueRange.min)*this.scale.value;e=this._colormap(i,1),n=this._colormap(i,.8)}return{fill:e,border:n}},Pl.prototype._getColorsSize=function(){return{fill:Sr(this.dataColor),border:this.dataColor.stroke}},Pl.prototype._colormap=function(t){var e,n,r,i,o,a,s,l,u,h=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,c=this.colormap;if(Kt(c)){var f=c.length-1,d=Math.max(Math.floor(t*f),0),p=Math.min(d+1,f),v=t*f-d,y=c[d],m=c[p];e=y.r+v*(m.r-y.r),n=y.g+v*(m.g-y.g),r=y.b+v*(m.b-y.b)}else if("function"==typeof c){var g=c(t);e=g.r,n=g.g,r=g.b,i=g.a}else{var _=240*(1-t),w=Bo(_/360,1,1);e=w.r,n=w.g,r=w.b}return"number"!=typeof i||Jt(i)?$t(o=$t(a="RGB(".concat(Math.round(e*h),", ")).call(a,Math.round(n*h),", ")).call(o,Math.round(r*h),")"):$t(s=$t(l=$t(u="RGBA(".concat(Math.round(e*h),", ")).call(u,Math.round(n*h),", ")).call(l,Math.round(r*h),", ")).call(s,i,")")},Pl.prototype._calcRadius=function(t,e){var n;return void 0===e&&(e=this._dotSize()),(n=this.showPerspective?e/-t.trans.z:e*(-this.eye.z/this.camera.getArmLength()))<0&&(n=0),n},Pl.prototype._redrawBarGraphPoint=function(t,e){var n=this.xBarWidth/2,r=this.yBarWidth/2,i=this._getColorsRegular(e);this._redrawBar(t,e,n,r,Sr(i),i.border)},Pl.prototype._redrawBarColorGraphPoint=function(t,e){var n=this.xBarWidth/2,r=this.yBarWidth/2,i=this._getColorsColor(e);this._redrawBar(t,e,n,r,Sr(i),i.border)},Pl.prototype._redrawBarSizeGraphPoint=function(t,e){var n=(e.point.value-this.valueRange.min)/this.valueRange.range(),r=this.xBarWidth/2*(.8*n+.2),i=this.yBarWidth/2*(.8*n+.2),o=this._getColorsSize();this._redrawBar(t,e,r,i,Sr(o),o.border)},Pl.prototype._redrawDotGraphPoint=function(t,e){var n=this._getColorsRegular(e);this._drawCircle(t,e,Sr(n),n.border)},Pl.prototype._redrawDotLineGraphPoint=function(t,e){var n=this._convert3Dto2D(e.bottom);t.lineWidth=1,this._line(t,n,e.screen,this.gridColor),this._redrawDotGraphPoint(t,e)},Pl.prototype._redrawDotColorGraphPoint=function(t,e){var n=this._getColorsColor(e);this._drawCircle(t,e,Sr(n),n.border)},Pl.prototype._redrawDotSizeGraphPoint=function(t,e){var n=this._dotSize(),r=(e.point.value-this.valueRange.min)/this.valueRange.range(),i=n*this.dotSizeMinFraction,o=i+(n*this.dotSizeMaxFraction-i)*r,a=this._getColorsSize();this._drawCircle(t,e,Sr(a),a.border,o)},Pl.prototype._redrawSurfaceGraphPoint=function(t,e){var n=e.pointRight,r=e.pointTop,i=e.pointCross;if(void 0!==e&&void 0!==n&&void 0!==r&&void 0!==i){var o,a,s,l=!0;if(this.showGrayBottom||this.showShadow){var u=Zo.subtract(i.trans,e.trans),h=Zo.subtract(r.trans,n.trans),c=Zo.crossProduct(u,h);if(this.showPerspective){var f=Zo.avg(Zo.avg(e.trans,i.trans),Zo.avg(n.trans,r.trans));s=-Zo.dotProduct(c.normalize(),f.normalize())}else s=c.z/c.length();l=s>0}if(l||!this.showGrayBottom){var d=((e.point.value+n.point.value+r.point.value+i.point.value)/4-this.valueRange.min)*this.scale.value,p=this.showShadow?(1+s)/2:1;o=this._colormap(d,p)}else o="gray";a=this.showSurfaceGrid?this.axisColor:o,t.lineWidth=this._getStrokeWidth(e);var v=[e,n,i,r];this._polygon(t,v,o,a)}},Pl.prototype._drawGridLine=function(t,e,n){if(void 0!==e&&void 0!==n){var r=((e.point.value+n.point.value)/2-this.valueRange.min)*this.scale.value;t.lineWidth=2*this._getStrokeWidth(e),t.strokeStyle=this._colormap(r,1),this._line(t,e.screen,n.screen)}},Pl.prototype._redrawGridGraphPoint=function(t,e){this._drawGridLine(t,e,e.pointRight),this._drawGridLine(t,e,e.pointTop)},Pl.prototype._redrawLineGraphPoint=function(t,e){void 0!==e.pointNext&&(t.lineWidth=this._getStrokeWidth(e),t.strokeStyle=this.dataColor.stroke,this._line(t,e.screen,e.pointNext.screen))},Pl.prototype._redrawDataGraph=function(){var t,e=this._getContext();if(!(void 0===this.dataPoints||this.dataPoints.length<=0))for(this._calcTranslations(this.dataPoints),t=0;t<this.dataPoints.length;t++){var n=this.dataPoints[t];this._pointDrawingMethod.call(this,e,n)}},Pl.prototype._storeMousePosition=function(t){this.startMouseX=Al(t),this.startMouseY=El(t),this._startCameraOffset=this.camera.getOffset()},Pl.prototype._onMouseDown=function(t){if(t=t||window.event,this.leftButtonDown&&this._onMouseUp(t),this.leftButtonDown=t.which?1===t.which:1===t.button,this.leftButtonDown||this.touchDown){this._storeMousePosition(t),this.startStart=new Date(this.start),this.startEnd=new Date(this.end),this.startArmRotation=this.camera.getArmRotation(),this.frame.style.cursor="move";var e=this;this.onmousemove=function(t){e._onMouseMove(t)},this.onmouseup=function(t){e._onMouseUp(t)},Go(document,"mousemove",e.onmousemove),Go(document,"mouseup",e.onmouseup),Vo(t)}},Pl.prototype._onMouseMove=function(t){this.moving=!0,t=t||window.event;var e=Er(Al(t))-this.startMouseX,n=Er(El(t))-this.startMouseY;if(t&&!0===t.ctrlKey){var r=.5*this.frame.clientWidth,i=.5*this.frame.clientHeight,o=(this._startCameraOffset.x||0)-e/r*this.camera.armLength*.8,a=(this._startCameraOffset.y||0)+n/i*this.camera.armLength*.8;this.camera.setOffset(o,a),this._storeMousePosition(t)}else{var s=this.startArmRotation.horizontal+e/200,l=this.startArmRotation.vertical+n/200,u=Math.sin(4/360*2*Math.PI);Math.abs(Math.sin(s))<u&&(s=Math.round(s/Math.PI)*Math.PI-.001),Math.abs(Math.cos(s))<u&&(s=(Math.round(s/Math.PI-.5)+.5)*Math.PI-.001),Math.abs(Math.sin(l))<u&&(l=Math.round(l/Math.PI)*Math.PI),Math.abs(Math.cos(l))<u&&(l=(Math.round(l/Math.PI-.5)+.5)*Math.PI),this.camera.setArmRotation(s,l)}this.redraw();var h=this.getCameraPosition();this.emit("cameraPositionChange",h),Vo(t)},Pl.prototype._onMouseUp=function(t){this.frame.style.cursor="auto",this.leftButtonDown=!1,Uo(document,"mousemove",this.onmousemove),Uo(document,"mouseup",this.onmouseup),Vo(t)},Pl.prototype._onClick=function(t){if(this.onclick_callback||this.hasListeners("click")){if(this.moving)this.moving=!1;else{var e=this.frame.getBoundingClientRect(),n=Al(t)-e.left,r=El(t)-e.top,i=this._dataPointFromXY(n,r);i&&(this.onclick_callback&&this.onclick_callback(i.point.data),this.emit("click",i.point.data))}Vo(t)}},Pl.prototype._onTooltip=function(t){var e=this.tooltipDelay,n=this.frame.getBoundingClientRect(),r=Al(t)-n.left,i=El(t)-n.top;if(this.showTooltip)if(this.tooltipTimeout&&clearTimeout(this.tooltipTimeout),this.leftButtonDown)this._hideTooltip();else if(this.tooltip&&this.tooltip.dataPoint){var o=this._dataPointFromXY(r,i);o!==this.tooltip.dataPoint&&(o?this._showTooltip(o):this._hideTooltip())}else{var a=this;this.tooltipTimeout=bt((function(){a.tooltipTimeout=null;var t=a._dataPointFromXY(r,i);t&&a._showTooltip(t)}),e)}},Pl.prototype._onTouchStart=function(t){this.touchDown=!0;var e=this;this.ontouchmove=function(t){e._onTouchMove(t)},this.ontouchend=function(t){e._onTouchEnd(t)},Go(document,"touchmove",e.ontouchmove),Go(document,"touchend",e.ontouchend),this._onMouseDown(t)},Pl.prototype._onTouchMove=function(t){this._onMouseMove(t)},Pl.prototype._onTouchEnd=function(t){this.touchDown=!1,Uo(document,"touchmove",this.ontouchmove),Uo(document,"touchend",this.ontouchend),this._onMouseUp(t)},Pl.prototype._onWheel=function(t){if(t||(t=window.event),this.zoomable&&(!this.ctrlToZoom||t.ctrlKey)){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail&&(e=-t.detail/3),e){var n=this.camera.getArmLength()*(1-e/10);this.camera.setArmLength(n),this.redraw(),this._hideTooltip()}var r=this.getCameraPosition();this.emit("cameraPositionChange",r),Vo(t)}},Pl.prototype._insideTriangle=function(t,e){var n=e[0],r=e[1],i=e[2];function o(t){return t>0?1:t<0?-1:0}var a=o((r.x-n.x)*(t.y-n.y)-(r.y-n.y)*(t.x-n.x)),s=o((i.x-r.x)*(t.y-r.y)-(i.y-r.y)*(t.x-r.x)),l=o((n.x-i.x)*(t.y-i.y)-(n.y-i.y)*(t.x-i.x));return!(0!=a&&0!=s&&a!=s||0!=s&&0!=l&&s!=l||0!=a&&0!=l&&a!=l)},Pl.prototype._dataPointFromXY=function(t,e){var n,r=null,i=null,o=null,a=new Xo(t,e);if(this.style===Pl.STYLE.BAR||this.style===Pl.STYLE.BARCOLOR||this.style===Pl.STYLE.BARSIZE)for(n=this.dataPoints.length-1;n>=0;n--){var s=(r=this.dataPoints[n]).surfaces;if(s)for(var l=s.length-1;l>=0;l--){var u=s[l].corners,h=[u[0].screen,u[1].screen,u[2].screen],c=[u[2].screen,u[3].screen,u[0].screen];if(this._insideTriangle(a,h)||this._insideTriangle(a,c))return r}}else for(n=0;n<this.dataPoints.length;n++){var f=(r=this.dataPoints[n]).screen;if(f){var d=Math.abs(t-f.x),p=Math.abs(e-f.y),v=Math.sqrt(d*d+p*p);(null===o||v<o)&&v<100&&(o=v,i=r)}}return i},Pl.prototype.hasBars=function(t){return t==Pl.STYLE.BAR||t==Pl.STYLE.BARCOLOR||t==Pl.STYLE.BARSIZE},Pl.prototype._showTooltip=function(t){var e,n,r;this.tooltip?(e=this.tooltip.dom.content,n=this.tooltip.dom.line,r=this.tooltip.dom.dot):(e=document.createElement("div"),ft(e.style,{},this.tooltipStyle.content),e.style.position="absolute",n=document.createElement("div"),ft(n.style,{},this.tooltipStyle.line),n.style.position="absolute",r=document.createElement("div"),ft(r.style,{},this.tooltipStyle.dot),r.style.position="absolute",this.tooltip={dataPoint:null,dom:{content:e,line:n,dot:r}}),this._hideTooltip(),this.tooltip.dataPoint=t,"function"==typeof this.showTooltip?e.innerHTML=this.showTooltip(t.point):e.innerHTML="<table><tr><td>"+this.xLabel+":</td><td>"+t.point.x+"</td></tr><tr><td>"+this.yLabel+":</td><td>"+t.point.y+"</td></tr><tr><td>"+this.zLabel+":</td><td>"+t.point.z+"</td></tr></table>",e.style.left="0",e.style.top="0",this.frame.appendChild(e),this.frame.appendChild(n),this.frame.appendChild(r);var i=e.offsetWidth,o=e.offsetHeight,a=n.offsetHeight,s=r.offsetWidth,l=r.offsetHeight,u=t.screen.x-i/2;u=Math.min(Math.max(u,10),this.frame.clientWidth-10-i),n.style.left=t.screen.x+"px",n.style.top=t.screen.y-a+"px",e.style.left=u+"px",e.style.top=t.screen.y-a-o+"px",r.style.left=t.screen.x-s/2+"px",r.style.top=t.screen.y-l/2+"px"},Pl.prototype._hideTooltip=function(){if(this.tooltip)for(var t in this.tooltip.dataPoint=null,this.tooltip.dom)if(this.tooltip.dom.hasOwnProperty(t)){var e=this.tooltip.dom[t];e&&e.parentNode&&e.parentNode.removeChild(e)}},Pl.prototype.setCameraPosition=function(t){ga(t,this),this.redraw()},Pl.prototype.setSize=function(t,e){this._setSize(t,e),this.redraw()},t.DELETE=To,t.DataSet=Dl,t.DataStream=Sl,t.DataView=Ml,t.Graph3d=Pl,t.Graph3dCamera=oa,t.Graph3dFilter=Cl,t.Graph3dPoint2d=Xo,t.Graph3dPoint3d=Zo,t.Graph3dSlider=qo,t.Graph3dStepNumber=Jo,t.Queue=bl,t.createNewDataPipeFrom=function(t){return new yl(t)},Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-graph3d.min.js.map
